DEFINT A-Z
STATIC SUB CODES (I)
COUNTER& = COUNTER& + 1
LASTSTR = I
'PRINT "PC="; HEX$(word(reg.pc) - 1); " A="; HEX$(reg.a); " X="; HEX$(reg.x); " Y="; HEX$(reg.y); " S="; HEX$(reg.S); " P="; HEX$(reg.p);
'PRINT " zf="; HEX$(reg.ZF); " vf="; HEX$(reg.VF); " nf="; HEX$(reg.NF); " ";
'PRINT CYCLE& / (TIMER - ts!);
'PRINT counter&;
'PRINT cycle&;
'PRINT opcode$(I); " "; 'HEX$(I), cycle&
'PRINT
'KK$ = INPUT$(1)

'LINE INPUT #3, f$
'PRINT f$

SELECT CASE I
CASE &HD4'/* CSH set clock highspeed */
CASE &H54'/* CSL set clock lowspeed */

CASE &H44: '/* BSR * REL */   'FIXED
           cmdr m.push, REG.pc.H
           cmdr m.push, REG.pc.L
           'I = op6502i(reg.pc)
           'I = I + (I > 127) * 256
           'WORDS reg.pc, word(reg.pc) + I + 1



CASE &H80: '/* BRA * REL */
          I = op6502i(REG.pc)
          I = I + (I > 127) * 256
          WORDS REG.pc, word(REG.pc) + I + 1

CASE &H7C: '/* JMP ($ssss,x) */
        M.LDWORD k: WORDS k, word(k) + REG.x
        REG.pc.L = op6502i(k)
        REG.pc.H = op6502(word(k) + 1)

CASE &HDA: cmdrf REG.x  '  /* PHX */
CASE &H5A: cmdrf REG.y '               /* PHY */
CASE &HFA: cmdrf REG.x: cmdr m.fl, REG.x '    /* PLX */
CASE &H7A: cmdrf REG.y: cmdr m.fl, REG.y'      /* PLY */

CASE &H62: REG.a = 0' /* CLA */
CASE &H82: REG.x = 0' /* CLX */
CASE &HC2: REG.y = 0' /* CLY */

CASE &H2:  I = REG.x: REG.x = REG.y: REG.y = I'  /* SXY */
CASE &H22: I = REG.a: REG.a = REG.x: REG.x = I'  /* SAX */
CASE &H42: I = REG.a: REG.a = REG.y: REG.y = I'  /* SAY */

CASE &H3A: cmdrf REG.a                  ' /* DEC A */
CASE &H1A: cmdrf REG.a                   ' /* INC A */



CASE &HD2: cmdrf I: M.CMP REG.a, I       '/* CMP ($ss) INDIR */
CASE &HB2: cmdrf REG.a: cmdr m.fl, REG.a '/* LDA ($ss) INDIR */
CASE &H92: cmdcf j: Wr6502 word(j), REG.a'/* STA ($ss) INDIR */



CASE &HF4: ' /* SET */
        I = op6502i(REG.pc)
        CYCLE& = CYCLE& + CYCLES(I) + 3
        cmdd CMDSET1(I), CMDSET2(I)  'IF ERROR, TAKE BACK OFF CYCLES(I)


CASE &H3: io_write 0, nop6502(REG.pc)  '/* ST0 */
CASE &H13: io_write 2, nop6502(REG.pc) '/* ST1 */
CASE &H23: io_write 3, nop6502(REG.pc) '/* ST2 */

CASE &H43: '/* TMAi */
        I = nop6502(REG.pc)
          FOR ii = 0 TO 7
              IF (I AND 2 ^ ii) THEN EXIT FOR
          NEXT ii
          REG.a = REG.MPR(ii)
CASE &H53: '/* TAMi */

        I = nop6502(REG.pc)
         FOR ii = 0 TO 7
              IF I AND 2 ^ ii THEN
                        REG.MPR(ii) = REG.a
                        BANK.SET ii, REG.a
              'EXIT FOR
              END IF
         NEXT ii

CASE &HC3: ' /* TDD */
        T_INIT src&, dist&, length&
        DO
        Wr6502 dist&, Rd6502(src&)
        dist& = dist& - 1
        src& = src& - 1
        length& = length& - 1
        LOOP WHILE length&

CASE &H73: ' /* TII */
        T_INIT src&, dist&, length&
        DO
             Wr6502 dist&, Rd6502(src&)
             dist& = dist& + 1
             src& = src& + 1
             length& = length& - 1
        LOOP WHILE length&


CASE &HE3: ' /* TIA */
        T_INIT src&, dist&, length&
        DO
                Wr6502 dist&, Rd6502(src&)
                src& = src& + 1
                ' if (!(--length)):break
                length& = length& - 1
                IF length& = 0 THEN EXIT DO
                Wr6502 dist& + 1, Rd6502(src&)
                src& = src& + 1
                lenght& = length& - 1
        LOOP WHILE length&


CASE &HF3: ' /* TAI */

        T_INIT src&, dist&, length&
         DO
                Wr6502 dist&, Rd6502(src&)
                dist& = dist& + 1
                length& = length& - 1
               IF length& = 0 THEN EXIT DO
               Wr6502 dist&, Rd6502(src& + 1)
               dist& = dist& + 1
               length& = length& - 1
         LOOP WHILE length&


CASE &HD3: ' /* TIN */
        T_INIT src&, dist&, length&
        DO
                Wr6502 dist&, Rd6502(src&)
                src& = src& + 1
        length& = length& - 1
        LOOP WHILE length&


CASE &H83: '/* TST #$ss,$ss IMM,ZP */
        I = nop6502(REG.pc): ii = RAMG(MCZp())
        REG.NF = ii
        REG.VF = ii: REG.ZF = I AND ii

CASE &HA3: '/* TST #$ss,$ss,x IMM,ZP,x */
        I = nop6502(REG.pc): ii = RAMG(MCZx())
        REG.NF = ii
        REG.VF = ii: REG.ZF = I AND ii
CASE &H93: '/* TST #$ss,$ssss IMM,ABS */
        I = nop6502(REG.pc): cmdrf ii
        REG.NF = ii
        REG.VF = ii: REG.ZF = I AND ii

CASE &HB3: '/* TST #$ss,$ssss,x IMM,ABS,x */
        I = nop6502(REG.pc): cmdrf ii
        REG.NF = ii
        REG.VF = ii: REG.ZF = I AND ii

'SBC

CASE &H10: IF (REG.NF AND n.flag) THEN REGINC REG.pc ELSE M.JR  '/* BPL * REL */
CASE &H30: IF (REG.NF AND n.flag) THEN M.JR ELSE REGINC REG.pc  '/* BMI * REL */
CASE &HD0: IF REG.ZF = 0 THEN REGINC REG.pc ELSE M.JR      '/* BNE * REL */
CASE &HF0: IF REG.ZF = 0 THEN M.JR ELSE REGINC REG.pc     '/* BEQ * REL */
CASE &H90: IF (REG.p AND c.flag) THEN REGINC REG.pc ELSE M.JR '/* BCC * REL */
CASE &HB0: IF (REG.p AND c.flag) THEN M.JR ELSE REGINC REG.pc '/* BCS * REL */
CASE &H50: IF (REG.VF AND v.flag) THEN REGINC REG.pc ELSE M.JR'/* BVC * REL */
CASE &H70: IF (REG.VF AND v.flag) THEN M.JR ELSE REGINC REG.pc '/* BVS * REL */


CASE &H40: '/* RTI */

  I = REG.p


  cmdr m.pop.p, REG.p

  IF ((REG.IRequest <> INT.NONE) AND (I AND I.flag) <> 0 AND NOT (REG.p AND I.flag) <> 0) THEN
     REGAfterCLI = 1
    REG.IBackup = REG.ICount
    REG.ICount = 0
    END IF
    cmdr m.pop, REG.pc.L
    cmdr m.pop, REG.pc.H



CASE &H60: '/* RTS */
  cmdr m.pop, REG.pc.L: cmdr m.pop, REG.pc.H: REGINC REG.pc
  'JS = JS - 1
  'REGINC JUMPSTA(JS)
  'PRINT HEX$(word(JUMPSTA(JS)));

CASE &H20: '/* JSR $ssss ABS */

  k.L = nop6502(REG.pc)
  k.H = op6502i(REG.pc)
  'JUMPSTA(JS) = REG.PC
  cmdr m.push, REG.pc.H
  cmdr m.push, REG.pc.L
  REG.pc = k
  'JS = JS + 1
  'JSS = JSS + 1
CASE &H4C: M.LDWORD k: REG.pc = k'/* JMP $ssss ABS */

CASE &H6C: '/* JMP ($ssss) ABDINDIR */
  M.LDWORD k
  REG.pc.L = nop6502(k)
  REG.pc.H = op6502i(k)


CASE &H0: '/* BRK */
  REGINC REG.pc
  cmdr m.push, REG.pc.H: cmdr m.push, REG.pc.L
  cmdr m.push.p, REG.p AND Tn.flag OR (b.flag)
  REG.p = (REG.p OR I.flag) AND DN.FLAG
  k = REG.pc
  REG.pc.L = op6502(VEC.BRK)
  REG.pc.H = op6502(VEC.BRK + 1)
  PRINT ERR, "BRK instruction " + HEX$(word(k) - 1)
  endprog



CASE &H58: '/* CLI */
  IF ((REG.IRequest <> INT.NONE) AND (REG.p AND I.flag) <> 0) THEN

    REG.AfterCLI = 1
    REG.IBackup = REG.ICount
    REG.ICount = 0

  END IF
  REG.p = REG.p AND IN.FLAG



CASE &H28: '/* PLP */
  cmdr m.pop.p, I

  IF ((REG.IRequest <> INT.NONE) AND ((I XOR REG.p) AND notb(I) AND I.flag) <> 0) THEN

    REG.AfterCLI = 1
    REG.IBackup = REG.ICount
    REG.ICount = 0

  END IF
  REG.p = I



CASE &H8: cmdrf REG.p AND Tn.flag OR b.flag'     /* PHP */
CASE &H18: REG.p = REG.p AND cn.flag          '     /* CLC */
CASE &HB8: REG.VF = 0                              '     /* CLV */
CASE &HD8: REG.p = REG.p AND DN.FLAG          '     /* CLD */
CASE &H38: REG.p = REG.p OR c.flag                 '     /* SEC */
CASE &HF8: REG.p = REG.p OR D.flag                 '     /* SED */
CASE &H78: REG.p = REG.p OR I.flag                 '     /* SEI */
CASE &H48: cmdrf REG.a          '             /* PHA */
CASE &H68: cmdrf REG.a: cmdr m.fl, REG.a       '     /* PLA */
CASE &H98: REG.a = REG.y: cmdrf REG.a     '     /* TYA */

'can i use cmdr m.inc, reg.y ?
CASE &HA8: REG.y = REG.a: cmdrf REG.y     '     /* TAY */
CASE &HC8: REG.y = REG.y + 1: cmdrf REG.y '     /* INY */
CASE &H88: REG.y = REG.y - 1: cmdrf REG.y '     /* DEY */
CASE &H8A: REG.a = REG.x: cmdrf REG.a     '     /* TXA */
CASE &HAA: REG.x = REG.a: cmdrf REG.x     '     /* TAX */
CASE &HE8: REG.x = REG.x + 1: cmdrf REG.x '     /* INX */
CASE &HCA: REG.x = REG.x - 1: cmdrf REG.x '     /* DEX */
CASE &HEA:  '                                  /* NOP */
CASE &H9A: REG.S = REG.x                 '     /* TXS */
CASE &HBA: REG.x = REG.S: cmdrf REG.x     '     /* TSX */



CASE &H84: cmdrf REG.y                 '  /* STY $ss ZP */
CASE &H85: cmdrf REG.a                 '  /* STA $ss ZP */
CASE &H86: cmdrf REG.x                 '  /* STX $ss ZP */
CASE &HA4: cmdrf REG.y: cmdr m.fl, REG.y    '  /* LDY $ss ZP */
CASE &HA5: cmdrf REG.a: cmdr m.fl, REG.a    '  /* LDA $ss ZP */
CASE &HA6: cmdrf REG.x: cmdr m.fl, REG.x     '  /* LDX $ss ZP */
CASE &HC4: cmdrf I: M.CMP REG.y, I     '  /* CPY $ss ZP */
CASE &HC5: cmdrf I: M.CMP REG.a, I     '  /* CMP $ss ZP */
CASE &HE4: cmdrf I: M.CMP REG.x, I    '  /* CPX $ss ZP */
CASE &H8C: cmdrf REG.y                 '  /* STY $ssss ABS */
CASE &H8D: cmdrf REG.a                '  /* STA $ssss ABS */
CASE &H8E: cmdrf REG.x                '  /* STX $ssss ABS */
CASE &HAC: cmdrf REG.y: cmdr m.fl, REG.y     '  /* LDY $ssss ABS */
CASE &HAD: cmdrf REG.a: cmdr m.fl, REG.a     '  /* LDA $ssss ABS */
CASE &HAE: cmdrf REG.x: cmdr m.fl, REG.x      '  /* LDX $ssss ABS */
CASE &HCC: cmdrf I: M.CMP REG.y, I      '  /* CPY $ssss ABS */
CASE &HCD: cmdrf I: M.CMP REG.a, I      '  /* CMP $ssss ABS */
CASE &HEC: cmdrf I: M.CMP REG.x, I     '  /* CPX $ssss ABS */
CASE &HA0: cmdrf REG.y: cmdr m.fl, REG.y      '  /* LDY #$ss IMM */
CASE &HA2: cmdrf REG.x: cmdr m.fl, REG.x      '  /* LDX #$ss IMM */
CASE &HA9: cmdrf REG.a: cmdr m.fl, REG.a      '  /* LDA #$ss IMM */
CASE &HC0: cmdrf I: M.CMP REG.y, I      '  /* CPY #$ss IMM */
CASE &HC9: cmdrf I: M.CMP REG.a, I      '  /* CMP #$ss IMM */
CASE &HE0: cmdrf I: M.CMP REG.x, I    '  /* CPX #$ss IMM */
CASE &H94: cmdrf REG.y                  '  /* STY $ss,x ZP,x */
CASE &H95: cmdrf REG.a                  '  /* STA $ss,x ZP,x */
CASE &H96: cmdrf REG.x                  '  /* STX $ss,y ZP,y */
CASE &HB4: cmdrf REG.y: cmdr m.fl, REG.y      '  /* LDY $ss,x ZP,x */
CASE &HB5: cmdrf REG.a: cmdr m.fl, REG.a      '  /* LDA $ss,x ZP,x */
CASE &HB6: cmdrf REG.x: cmdr m.fl, REG.x     '  /* LDX $ss,y ZP,y */
CASE &HD5: cmdrf I: M.CMP REG.a, I      '  /* CMP $ss,x ZP,x */



CASE &H99: cmdrf REG.a                  '  /* STA $ssss,y ABS,y */
CASE &H9D: cmdrf REG.a                  '  /* STA $ssss,x ABS,x */
CASE &HB9: cmdrf REG.a: cmdr m.fl, REG.a      '  /* LDA $ssss,y ABS,y */
CASE &HBC: cmdrf REG.y: cmdr m.fl, REG.y     '  /* LDY $ssss,x ABS,x */
CASE &HBD: cmdrf REG.a: cmdr m.fl, REG.a      '  /* LDA $ssss,x ABS,x */
CASE &HBE: cmdrf REG.x: cmdr m.fl, REG.x      '  /* LDX $ssss,y ABS,y */
CASE &HD9: cmdrf I: M.CMP REG.a, I     '  /* CMP $ssss,y ABS,y */
CASE &HDD: cmdrf I: M.CMP REG.a, I     '  /* CMP $ssss,x ABS,x */
CASE &H81: cmdrf REG.a                 '  /* STA ($ss,x) INDEXINDIR */
CASE &H91: cmdrf REG.a                 '  /* STA ($ss),y INDIRINDEX */
CASE &HA1: cmdrf REG.a: cmdr m.fl, REG.a     '  /* LDA ($ss,x) INDEXINDIR */
CASE &HB1: cmdrf REG.a: cmdr m.fl, REG.a     '  /* LDA ($ss),y INDIRINDEX */
CASE &HC1: cmdrf I: M.CMP REG.a, I     '  /* CMP ($ss,x) INDEXINDIR */
CASE &HD1: cmdrf I: M.CMP REG.a, I     '  /* CMP ($ss),y INDIRINDEX */


CASE &HA:  cmdrf REG.a                 '  /* ASL a ACC */
CASE &H2A: cmdrf REG.a                '  /* ROL a ACC */
CASE &H4A: cmdrf REG.a                '  /* LSR a ACC */
CASE &H6A: cmdrf REG.a                '  /* ROR a ACC */
CASE IS = ((cmd1(I) <> 0) AND I): cmdd cmd1(I), CMD2(I)
CASE IS = ((cmr1(I) <> 0) AND I): cmdr cmr1(I), CMr2(I)
CASE IS = (ii OR &HF) '/* BBRi/BBSi
IF ((RAMG(MCZp()) AND 2 ^ (I \ SH4)) <> 0) AND (I < &H80) THEN REGINC REG.pc ELSE M.JR'BBRI, BBSI
CASE ELSE


'  IF (I AND &H87) = &H87 THEN CMDR M.SMB, 2 ^ (I \ 2 ^ 4)
 ' IF (I AND &H7) = &H7 THEN CMDR M.RMB, 2 ^ (I \ 2 ^ 4)
tt! = TIMER
PRINT CYCLE& / (tt! - ts!), COUNTER& / (tt! - ts!), tt! - ts!
PRINT CYCLE&, COUNTER&
PRINT
PRINT "ERROR:"; HEX$(word(REG.pc) - 1), HEX$(I): endprog
'default:
'  if(_TrapBadOps) {
'    fprintf
'    ( stderr,
'      "[M6502 %lX] Unrecognized instruction: $%02X at PC=$%04X\n",
'      (unsigned)_User,Op6502(REG.PC.W-1),(word)(REG.PC.W-1)
'    );
'
'    _Trace=1;
'
'  }
'
'  break;
END SELECT

'PRINT
'kk$ = INPUT$(1)
NEXTCODES:
END SUB

