DECLARE FUNCTION RdRAM% (a%)
DECLARE FUNCTION nop6502% (rg AS ANY)
DECLARE FUNCTION WORD& (rg AS ANY)
DECLARE SUB words (rg AS ANY, a&)
DECLARE SUB CODES (I%)
DECLARE SUB RESET6502 ()
DECLARE SUB RUN6502 ()
DECLARE SUB M.DEC (rg%)
DECLARE SUB M.INC (rg%)
DECLARE SUB TRB (rg%)
DECLARE SUB TSB (rg%)
DECLARE SUB CmdE (rg%, CMD%)
DECLARE SUB M.ASL (rg%)
DECLARE SUB M.LSR (rg%)
DECLARE SUB M.ROL (rg%)
DECLARE SUB M.ROR (rg%)
DECLARE SUB MC.Ab (rg AS ANY)
DECLARE SUB MC.Ax (rg AS ANY)
DECLARE SUB MC.Ay (rg AS ANY)
DECLARE SUB MC.Ix (rg AS ANY)
DECLARE SUB MC.Iy (rg AS ANY)
DECLARE SUB wrRAM (a%, b%)
DECLARE FUNCTION OP6502W% (a%)
DECLARE FUNCTION RDRAMW% (a%)
DECLARE FUNCTION MCAB% ()
DECLARE FUNCTION MCAX% ()
DECLARE FUNCTION MCAY% ()
DECLARE FUNCTION MCIX% ()
DECLARE FUNCTION MCIY% ()
DECLARE FUNCTION MCZY% ()
DECLARE SUB M.ADC (rg%)
DECLARE SUB M.AND (rg%)
DECLARE SUB M.BIT (rg%)
DECLARE SUB M.CMP (RG1%, RG2%)
DECLARE SUB M.EOR (rg%)
DECLARE SUB M.FL (rg%)
DECLARE SUB M.JR ()
DECLARE SUB M.LDWORD (rg AS ANY)
DECLARE SUB M.ORA (rg%)
DECLARE SUB M.POP (rg%)
DECLARE SUB M.POP.P (rg%)
DECLARE SUB M.PUSH (rg%)
DECLARE SUB M.PUSH.P (rg%)
DECLARE SUB M.SBC (rg%)
DECLARE SUB MC.ID (rg AS ANY)
DECLARE FUNCTION MCZp% ()
DECLARE FUNCTION MCZx% ()
DECLARE SUB MM.Ab (rg%)
DECLARE SUB mm.ax (rg%)
DECLARE SUB MM.Zp (RP%)
DECLARE SUB mm.zx (rg%)
DECLARE SUB MR.Ax (rg%)
DECLARE SUB MR.Ay (rg%)
DECLARE SUB MR.ID (rg%)
DECLARE SUB MR.Im (rg%)
DECLARE SUB MR.Ix (rg%)
DECLARE SUB MR.Iy (rg%)
DECLARE SUB MR.Zp (rg%)
DECLARE SUB MR.Zx (rg%)
DECLARE SUB mr.zy (rg%)
DECLARE SUB MW.Ab (rg%)
DECLARE SUB MW.Ax (rg%)
DECLARE SUB mw.ay (rg%)
DECLARE SUB mw.ix (rg%)
DECLARE SUB mw.iy (rg%)
DECLARE SUB MW.Zp (rg%)
DECLARE SUB MW.Zx (rg%)
DECLARE SUB mw.zy (rg%)
DECLARE FUNCTION op6502% (a&)
DECLARE SUB Wr6502 (a&, b%)
DECLARE SUB M.ADCx (rg%)
DECLARE SUB MR.Ab (rg%)
DECLARE SUB M.ANDx (rg%)
DECLARE SUB M.EORx (rg%)
DECLARE SUB M.ORAx (rg%)
DECLARE SUB IO.write (a%, b%)
DECLARE SUB BANK.SET (a%, b%)
DECLARE SUB T_INIT ()
DECLARE FUNCTION rd6502% (a&)
DECLARE SUB M.RMB (rg%)
DECLARE SUB M.SMB (rg%)
DEFINT A-Z

'TYPE bb  'change this around for lsb fists, last
'L AS INTEGER
'H AS INTEGER
'END TYPE


'TYPE PCC
' W AS INTEGER
' B AS bb
'END TYPE

TYPE pcc
 L AS INTEGER
 h AS INTEGER
END TYPE

TYPE regg
 P AS INTEGER        'on byte register
 a AS INTEGER
 x AS INTEGER
 Y AS INTEGER
 s AS INTEGER
 pc AS pcc
 NF AS INTEGER
 VF AS INTEGER
 ZF AS INTEGER
 mpr(7) AS INTEGER
 IRequest AS INTEGER
 ICount AS INTEGER
 IBackup AS INTEGER
 AfterCLI AS INTEGER
 IPeriod AS INTEGER
 USER AS INTEGER
END TYPE


'byte = unsigned char (1)
'word = unsigned short (2)
'offset = signed char

'UNION pair
' word w
' int b {byte l,h}
'end type
' n
' n.w
' n.b (n.b.l,n.b.h)


                       '       /* 6502 status flags:         */
CONST C.FLAG = &H1     '       /* 1: Carry occured           */
CONST Z.FLAG = &H2     '       /* 1: Result is zero          */
CONST I.FLAG = &H4     '       /* 1: Interrupts disabled     */
CONST D.FLAG = &H8     '       /* 1: Decimal mode            */
CONST b.flag = &H10    '       /* Break [0 on stk after int] */
CONST r.flag = &H20    '       /* Always 1                   */
CONST V.FLAG = &H40    '       /* 1: Overflow occured        */
CONST N.FLAG = &H80    '       /* 1: Result is negative      */

'                      '       /* Loop6502() returns:        */
CONST INT.NONE = 0     '       /* No interrupt required      */
CONST INT.IRQ = 1      '       /* Standard IRQ interrupt     */
CONST INT.NMI = 2      '       /* Non-maskable interrupt     */
CONST INT.QUIT = 3     '       /* Exit the emulation         */

CONST INT.TIMER = 4
CONST INT.IRQ2 = 8
CONST VEC.RESET = &HFFFE
CONST VER.NMI = &HFFFC
CONST VEC.TIMER = &HFFFA
CONST VEC.IRQ = &HFFF8
CONST VER.IRQ2 = &HFFF6
CONST VEC.BRK = &HFFFE





DIM SHARED reg AS regg, k AS pcc, J AS pcc, CYCLES%(255), zntable%(255), I
DIM SHARED pram(32766), CYCLE
OPEN "BONK3.PCE" FOR BINARY ACCESS READ AS #1
OPEN "pram.ram" FOR BINARY ACCESS READ WRITE AS #2
D$ = STRING$(1000, 0)
FOR I = 1 TO 100
PUT #2, , D$
NEXT I
D$ = ""



RESTORE cycledata
FOR ii = 0 TO 255: READ CYCLES%(ii): NEXT ii
RESTORE zntabledata
FOR ii = 0 TO 255: READ zntable%(ii): NEXT ii
RUN6502
END


cycledata:
'static byte Cycles[256] =
DATA     8,7,3, 4,6,4,6,7,3,2,2,0,7,5,7,6
DATA     2,7,7, 4,6,4,6,7,2,5,2,0,7,5,7,6
DATA     7,7,3, 4,4,4,6,7,3,2,2,0,5,5,7,6
DATA     2,7,7, 0,4,4,6,7,2,5,2,0,5,5,7,6
DATA     7,7,3, 4,8,4,6,7,3,2,2,0,4,5,7,6
DATA     2,7,7, 5,0,4,6,7,2,5,3,0,0,5,7,6
DATA     7,7,2, 0,4,4,6,7,3,2,2,0,7,5,7,6
DATA     2,7,7,17,4,4,6,7,2,5,3,0,7,5,7,6
DATA     4,7,2, 7,4,4,4,7,2,2,2,0,5,5,5,6
DATA     2,7,7, 8,4,4,4,7,2,5,2,0,5,5,5,6
DATA     2,7,2, 7,4,4,4,7,2,2,2,0,5,5,5,6
DATA     2,7,7, 8,4,4,4,7,2,5,2,0,5,5,5,6
DATA     2,7,2,17,4,4,6,7,2,2,2,0,5,5,7,6
DATA     2,7,7,17,0,4,6,7,2,5,3,0,0,5,7,6
DATA     2,7,0,17,4,4,6,7,2,2,2,0,5,5,7,6
DATA     2,7,7,17,2,4,6,7,2,5,3,0,0,5,7,0









'DATA  7,6,2,8,3,3,5,5,3,2,2,2,4,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  6,6,2,8,3,3,5,5,4,2,2,2,4,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  6,6,2,8,3,3,5,5,3,2,2,2,3,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  6,6,2,8,3,3,5,5,4,2,2,2,5,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  2,6,2,6,3,3,3,3,2,2,2,2,4,4,4,4
'DATA  2,6,2,6,4,4,4,4,2,5,2,5,5,5,5,5
'DATA  2,6,2,6,3,3,3,3,2,2,2,2,4,4,4,4
'DATA  2,5,2,5,4,4,4,4,2,4,2,5,4,4,4,4
'DATA  2,6,2,8,3,3,5,5,2,2,2,2,4,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  2,6,2,8,3,3,5,5,2,2,2,2,4,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'


zntabledata:
'byte ZNTable[256] =

'DATA  Z.FLAG,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

'new
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128



 





'old
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG

CONST MNUL = 0, minc = 1, MDEC = 2, MROR = 3, MROL = 4, MLSR = 5, MASL = 6, MTRB = 7, MTSB = 8

SUB BANK.SET (a%, b%)
END SUB

SUB CmdE (rg, CMD)
SELECT CASE CMD
CASE MNUL:
CASE minc: M.INC rg
CASE MDEC: M.DEC rg
CASE MROR: M.ROR rg
CASE MROL: M.ROL rg
CASE MLSR: M.LSR rg
CASE MASL: M.ASL rg
CASE MTRB: TRB rg
CASE MTSB: TSB rg
END SELECT



END SUB

SUB CODES (I)

SELECT CASE I
CASE &HD4'/* CSH set clock highspeed */
CASE &H54'/* CSL set clock lowspeed */

CASE &H44: '/* BSR * REL */
           M.PUSH reg.pc.h
           M.PUSH reg.pc.L

CASE &H80: '/* BRA * REL */
          words reg.pc, WORD(reg.pc) + op6502(WORD(reg.pc)) + 1


CASE &H7C: '/* JMP ($ssss,x) */
        M.LDWORD k: words k, WORD(k) + reg.x
        reg.pc.L = op6502(WORD(k))
        reg.pc.h = op6502(WORD(k) + 1)

CASE &HDA: M.PUSH reg.x  '  /* PHX */

CASE &H5A: M.PUSH reg.Y '               /* PHY */
CASE &HFA: M.POP reg.x: M.FL reg.x '    /* PLX */
CASE &H7A: M.POP reg.Y: M.FL reg.Y'      /* PLY */

CASE &H62: reg.a = 0' /* CLA */
CASE &H82: reg.x = 0' /* CLX */
CASE &HC2: reg.Y = 0' /* CLY */

CASE &H2: I = reg.x: reg.x = reg.Y: reg.Y = I'  /* SXY */
CASE &H22: I = reg.a: reg.a = reg.x: reg.x = I'  /* SAX */
CASE &H42: I = reg.a: reg.a = reg.Y: reg.Y = I'  /* SAY */

CASE &H3A: M.DEC reg.a                  ' /* DEC A */

CASE &H1A: M.INC reg.a                  ' /* INC A */


CASE &H72: MR.ID I: M.ADC I               '/* ADC ($ss) INDIR */
CASE &H32: MR.ID I: M.AND I               '/* AND ($ss) INDIR */
CASE &HD2: MR.ID I: M.CMP reg.a, I        '/* CMP ($ss) INDIR */
CASE &H52: MR.ID I: M.EOR I               '/* EOR ($ss) INDIR */
CASE &HB2: MR.ID reg.a: M.FL reg.a        '/* LDA ($ss) INDIR */
CASE &H12: MR.ID I: M.ORA I               '/* ORA ($ss) INDIR */
CASE &H92: MC.ID J: Wr6502 WORD(J), reg.a     '/* STA ($ss) INDIR */
CASE &HF2: MR.ID I: M.SBC I             '  /* SBC ($ss) INDIR */

CASE &H89: MR.Im I: M.BIT I  '              /* BIT #$ss IMM */
CASE &H34: MR.Zx I: M.BIT I  '              /* BIT $ss,x ZP,x */
CASE &H3C: MR.Ax I: M.BIT I  '              /* BIT $ssss,x ABS,x */

CASE &H64: MW.Zp &H0            '          /* STZ $ss ZP */
CASE &H74: MW.Zx &H0            '          /* STZ $ss,x ZP,x */
CASE &H9C: MW.Ab &H0            '          /* STZ $ssss ABS */
CASE &H9E: MW.Ax &H0            '          /* STZ $ssss,x ABS,x */

CASE &HF4: ' /* SET */
        I = op6502(WORD(reg.pc))
        words reg.pc, WORD(reg.pc) + 1
        CYCLE = CYCLE + CYCLES(I) + 3
        SELECT CASE I
        CASE &H65: MR.Zp I: M.ADCx I'       /* ADC $ss ZP */
        CASE &H6D: MR.Ab I: M.ADCx I'       /* ADC $ssss ABS */
        CASE &H69: MR.Im I: M.ADCx I'       /* ADC #$ss IMM */
        CASE &H75: MR.Zx I: M.ADCx I'       /* ADC $ss,x ZP,x */
        CASE &H79: MR.Ay I: M.ADCx I'       /* ADC $ssss,y ABS,y */
        CASE &H7D: MR.Ax I: M.ADCx I'       /* ADC $ssss,x ABS,x */
        CASE &H61: MR.Ix I: M.ADCx I'       /* ADC ($ss,x) INDEXINDIR */
        CASE &H71: MR.Iy I: M.ADCx I'       /* ADC ($ss),y INDIRINDEX */
        CASE &H72: MR.ID I: M.ADCx I'       /* ADC ($ss) INDIR */

        CASE &H25: MR.Zp I: M.ANDx I'       /* AND $ss ZP */
        CASE &H2D: MR.Ab I: M.ANDx I'       /* AND $ssss ABS */
        CASE &H29: MR.Im I: M.ANDx I'       /* AND #$ss IMM */
        CASE &H35: MR.Zx I: M.ANDx I'       /* AND $ss,x ZP,x */
        CASE &H39: MR.Ay I: M.ANDx I'       /* AND $ssss,y ABS,y */
        CASE &H3D: MR.Ax I: M.ANDx I'       /* AND $ssss,x ABS,x */
        CASE &H21: MR.Ix I: M.ANDx I'       /* AND ($ss,x) INDEXINDIR */
        CASE &H31: MR.Iy I: M.ANDx I'       /* AND ($ss),y INDIRINDEX */
        CASE &H32: MR.ID I: M.ANDx I'       /* AND ($ss) INDIR */

        CASE &H45: MR.Zp I: M.EORx I '       /* EOR $ss ZP */
        CASE &H4D: MR.Ab I: M.EORx I '       /* EOR $ssss ABS */
        CASE &H49: MR.Im I: M.EORx I '       /* EOR #$ss IMM */
        CASE &H55: MR.Zx I: M.EORx I '       /* EOR $ss,x ZP,x */
        CASE &H59: MR.Ay I: M.EORx I '       /* EOR $ssss,y ABS,y */
        CASE &H5D: MR.Ax I: M.EORx I '       /* EOR $ssss,x ABS,x */
        CASE &H41: MR.Ix I: M.EORx I '       /* EOR ($ss,x) INDEXINDIR */
        CASE &H51: MR.Iy I: M.EORx I '       /* EOR ($ss),y INDIRINDEX */
        CASE &H52: MR.ID I: M.EORx I '       /* EOR ($ss) INDIR */

        CASE &H5: MR.Zp I: M.ORAx I  '       /* ORA $ss ZP */
        CASE &HD: MR.Ab I: M.ORAx I  '       /* ORA $ssss ABS */
        CASE &H9: MR.Im I: M.ORAx I  '       /* ORA #$ss IMM */
        CASE &H15: MR.Zx I: M.ORAx I '       /* ORA $ss,x ZP,x */
        CASE &H19: MR.Ay I: M.ORAx I '       /* ORA $ssss,y ABS,y */
        CASE &H1D: MR.Ax I: M.ORAx I '       /* ORA $ssss,x ABS,x */
        CASE &H1: MR.Ix I: M.ORAx I  '       /* ORA ($ss,x) INDEXINDIR */
        CASE &H11: MR.Iy I: M.ORAx I '       /* ORA ($ss),y INDIRINDEX */
        CASE &H12: MR.ID I: M.ORAx I '       /* ORA ($ss) INDIR */

        CASE ELSE
        PRINT ERR, "no sense SET"
        CYCLE = CYCLE - CYCLES(I)


        END SELECT

CASE &H3: IO.write 0, op6502(WORD(reg.pc)): words reg.pc, WORD(reg.pc) + 1 '/* ST0 */
CASE &H13: IO.write 2, op6502(WORD(reg.pc)): words reg.pc, WORD(reg.pc) + 1 '/* ST1 */
CASE &H23: IO.write 3, op6502(WORD(reg.pc)): words reg.pc, WORD(reg.pc) + 1 '/* ST2 */

CASE &H43: '/* TMAi */
        I = op6502(WORD(reg.pc)): words reg.pc, WORD(reg.pc) + 1

          FOR ii = 0 TO 7
              I = I \ 2 ^ 1

              IF (I AND 1) THEN EXIT FOR

          '//reg.a = Reg.MPR[ii]
          '//reg.a = Reg.MPR[ii]
          reg.a = reg.mpr(ii)
          NEXT ii

CASE &H53: '/* TAMi */
        I = op6502(WORD(reg.pc)): words reg.pc, WORD(reg.pc) + 1
         ''''PRINT i
         FOR ii = 0 TO 7

                I = I \ 2 ^ 1
                IF (I AND 1) THEN
                        '//R->MPR[ii]=reg.a;
                        '//R.MPR[ii]=reg.a;
                        reg.mpr(ii) = reg.a
                        BANK.SET ii, reg.a
                END IF
         NEXT ii

CASE &HC3: ' /* TDD */
        T_INIT
        DO
        Wr6502 dist&, rd6502(src&)
        dist = dist - 1

        src = src - 1
        length = length - 1
        LOOP WHILE length
'        } while(--length);




CASE &H73: ' /* TII */
        T_INIT
        DO
             Wr6502 dist&, rd6502(src&)
             dist = dist + 1
                src = src + 1
        length = length - 1
        LOOP WHILE length
'        } while(--length);


CASE &HE3: ' /* TIA */
        T_INIT
        DO
                Wr6502 dist&, rd6502(src&)
                src = src + 1

                IF NOT length THEN EXIT DO
                ' if (!(--length)):break
                length = length - 1
                Wr6502 dist + 1, rd6502(src&)
                src = src + 1
'        } while(--length);
        lenght = length - 1
        LOOP WHILE length


CASE &HF3: ' /* TAI */
        T_INIT
        DO
                Wr6502 dist&, rd6502(src&)
                dist = dist + 1
                'if (!(--length)) break;
                length = length - 1
                IF NOT length THEN EXIT DO
                Wr6502 dist&, rd6502(src + 1)
                dist = dist + 1

         length = length - 1
         LOOP WHILE length
'        } while(--length);

CASE &HD3: ' /* TIN */
        T_INIT
        DO
                Wr6502 dist&, rd6502(src&)
                src = src + 1
        length = length - 1
        LOOP WHILE length

CASE &H14: MM.Zp MTRB '      /* TRB $ss ZP */

CASE &H1C: MM.Ab MTRB '      /* TRB $ssss ABS */
CASE &H4: MM.Zp MTSB  '      /* TSB $ss ZP */

CASE &HC: MM.Ab MTSB  '      /* TSB $ssss ABS */

CASE &H83: '/* TST #$ss,$ss IMM,ZP */
        I = op6502(WORD(reg.pc)): J.L = RdRAM(MCZp())
        words reg.pc, WORD(reg.pc) + 1
'error    NF = VF = J.L
        reg.NF = J.L
        reg.VF = J.L: reg.ZF = I AND J.L

CASE &HA3: '/* TST #$ss,$ss,x IMM,ZP,x */
        I = op6502(WORD(reg.pc)): J.L = RdRAM(MCZx())
        words reg.pc, WORD(reg.pc) + 1

'error REG,NF = REG.VF = J.L
        reg.NF = J.L
        reg.VF = J.L: reg.ZF = I AND J.L
CASE &H93: '/* TST #$ss,$ssss IMM,ABS */
        I = op6502(WORD(reg.pc)): MR.Ab J.L
        words reg.pc, WORD(reg.pc) + 1
'error
        reg.NF = J.L
         reg.VF = J.L: reg.ZF = I AND J.L

CASE &HB3: '/* TST #$ss,$ssss,x IMM,ABS,x */
        I = op6502(WORD(reg.pc)): MR.Ax J.L
        words reg.pc, WORD(reg.pc) + 1
'error
        reg.NF = J.L
        reg.VF = J.L: reg.ZF = I AND J.L

CASE &HF: IF RdRAM(MCZp()) AND &H1 THEN words reg.pc, WORD(reg.pc) + 1:      ELSE M.JR          '      /* BBRi */
CASE &H1F: IF RdRAM(MCZp()) AND &H2 THEN words reg.pc, WORD(reg.pc) + 1:     ELSE M.JR
CASE &H2F: IF RdRAM(MCZp()) AND &H4 THEN words reg.pc, WORD(reg.pc) + 1:      ELSE M.JR
CASE &H3F: IF RdRAM(MCZp()) AND &H8 THEN words reg.pc, WORD(reg.pc) + 1:      ELSE M.JR
CASE &H4F: IF RdRAM(MCZp()) AND &H10 THEN words reg.pc, WORD(reg.pc) + 1:     ELSE M.JR
CASE &H5F: IF RdRAM(MCZp()) AND &H20 THEN words reg.pc, WORD(reg.pc) + 1:     ELSE M.JR
CASE &H6F: IF RdRAM(MCZp()) AND &H40 THEN words reg.pc, WORD(reg.pc) + 1:      ELSE M.JR
CASE &H7F: IF RdRAM(MCZp()) AND &H80 THEN words reg.pc, WORD(reg.pc) + 1:      ELSE M.JR

CASE &H8F: IF RdRAM(MCZp()) AND &H1 THEN M.JR:         ELSE words reg.pc, WORD(reg.pc) + 1      '      /* BBSi */
CASE &H9F: IF RdRAM(MCZp()) AND &H2 THEN M.JR:         ELSE words reg.pc, WORD(reg.pc) + 1
CASE &HAF: IF RdRAM(MCZp()) AND &H4 THEN M.JR:         ELSE words reg.pc, WORD(reg.pc) + 1
CASE &HBF: IF RdRAM(MCZp()) AND &H8 THEN M.JR:         ELSE words reg.pc, WORD(reg.pc) + 1
CASE &HCF: IF RdRAM(MCZp()) AND &H10 THEN M.JR:        ELSE words reg.pc, WORD(reg.pc) + 1
CASE &HDF: IF RdRAM(MCZp()) AND &H20 THEN M.JR:        ELSE words reg.pc, WORD(reg.pc) + 1
CASE &HEF: IF RdRAM(MCZp()) AND &H40 THEN M.JR:        ELSE words reg.pc, WORD(reg.pc) + 1
CASE &HFF: IF RdRAM(MCZp()) AND &H80 THEN M.JR:        ELSE words reg.pc, WORD(reg.pc) + 1


CASE &H7: M.RMB &H1   '        /* RMBi */
CASE &H17: M.RMB &H2  '        /* RMBi */
CASE &H27: M.RMB &H4  '        /* RMBi */
CASE &H37: M.RMB &H8  '        /* RMBi */
CASE &H47: M.RMB &H10 '        /* RMBi */
CASE &H57: M.RMB &H20 '        /* RMBi */
CASE &H67: M.RMB &H40 '        /* RMBi */
CASE &H77: M.RMB &H80 '        /* RMBi */

CASE &H87: M.SMB &H1  '        /* SMBi */
CASE &H97: M.SMB &H2  '        /* SMBi */
CASE &HA7: M.SMB &H4  '        /* SMBi */
CASE &HB7: M.SMB &H8  '        /* SMBi */
CASE &HC7: M.SMB &H10 '        /* SMBi */
CASE &HD7: M.SMB &H20 '        /* SMBi */
CASE &HE7: M.SMB &H40 '        /* SMBi */
CASE &HF7: M.SMB &H80 '        /* SMBi */




CASE &H10: IF (reg.NF AND N.FLAG) THEN words reg.pc, WORD(reg.pc) + 1:   ELSE M.JR'/* BPL * REL */
CASE &H30: IF (reg.NF AND N.FLAG) THEN M.JR:  ELSE words reg.pc, WORD(reg.pc) + 1 '/* BMI * REL */
CASE &HD0: IF (NOT reg.ZF) THEN words reg.pc, WORD(reg.pc) + 1 ELSE : M.JR       '/* BNE * REL */
CASE &HF0: IF (NOT reg.ZF) THEN M.JR ELSE : words reg.pc, WORD(reg.pc) + 1       '/* BEQ * REL */
CASE &H90: IF (reg.P AND C.FLAG) THEN words reg.pc, WORD(reg.pc) + 1 ELSE : M.JR '/* BCC * REL */
CASE &HB0: IF (reg.P AND C.FLAG) THEN M.JR ELSE : words reg.pc, WORD(reg.pc) + 1 '/* BCS * REL */
CASE &H50: IF (reg.VF AND V.FLAG) THEN words reg.pc, WORD(reg.pc) + 1 ELSE M.JR '/* BVC * REL */
CASE &H70: IF (reg.VF AND V.FLAG) THEN M.JR ELSE : words reg.pc, WORD(reg.pc) + 1 '/* BVS * REL */


CASE &H40: '/* RTI */

  I = reg.P


  M.POP.P reg.P

  IF ((reg.IRequest <> INT.NONE) AND (I AND I.FLAG) <> 0 AND NOT (reg.P AND I.FLAG) <> 0) THEN
     REGAfterCLI = 1
    reg.IBackup = reg.ICount
    reg.ICount = 0
    END IF
    M.POP reg.pc.L
    M.POP reg.pc.h



CASE &H60: '/* RTS */
  M.POP reg.pc.L: M.POP reg.pc.h: words reg.pc, WORD(reg.pc) + 1


CASE &H20: '/* JSR $ssss ABS */
  k.L = op6502(WORD(reg.pc))
  words reg.pc, WORD(reg.pc) + 1

  k.h = op6502(WORD(reg.pc))
  M.PUSH reg.pc.h
  M.PUSH reg.pc.L
  reg.pc = k


CASE &H4C: M.LDWORD k: reg.pc = k'/* JMP $ssss ABS */


CASE &H6C: '/* JMP ($ssss) ABDINDIR */
  M.LDWORD k
  reg.pc.L = op6502(WORD(k))
  words k, WORD(k) + 1
  reg.pc.h = op6502(WORD(k))



CASE &H0: '/* BRK */
  words reg.pc, WORD(reg.pc) + 1
  M.PUSH reg.pc.h: M.PUSH reg.pc.L
  M.PUSH.P reg.P AND NOT (T.FLAG) OR (b.flag)
  reg.P = (reg.P OR I.FLAG) AND NOT (D.FLAG)
  reg.pc.L = op6502(VEC.BRK)
  reg.pc.h = op6502(VEC.BRK + 1)

  PRINT ERR, "BRK instruction"
  END



CASE &H58: '/* CLI */
  IF ((reg.IRequest <> INT.NONE) AND (reg.P AND I.FLAG) <> 0) THEN
  
    reg.AfterCLI = 1
    reg.IBackup = reg.ICount
    reg.ICount = 0

  END IF
  reg.P = reg.P AND NOT (I.FLAG)



CASE &H28: '/* PLP */
  M.POP.P I

  IF ((reg.IRequest <> INT.NONE) AND ((I XOR reg.P) AND NOT (I) AND I.FLAG) <> 0) THEN

    reg.AfterCLI = 1
    reg.IBackup = reg.ICount
    reg.ICount = 0

  END IF
  reg.P = I



CASE &H8: M.PUSH.P reg.P AND NOT (T.FLAG) OR b.flag'     /* PHP */
CASE &H18: reg.P = reg.P AND NOT (C.FLAG)          '     /* CLC */
CASE &HB8: reg.VF = 0                              '     /* CLV */
CASE &HD8: reg.P = reg.P AND NOT (D.FLAG)          '     /* CLD */
CASE &H38: reg.P = reg.P OR C.FLAG                 '     /* SEC */
CASE &HF8: reg.P = reg.P OR D.FLAG                 '     /* SED */
CASE &H78: reg.P = reg.P OR I.FLAG                 '     /* SEI */
CASE &H48: M.PUSH reg.a          '             /* PHA */
CASE &H68: M.POP reg.a: M.FL reg.a       '     /* PLA */
CASE &H98: reg.a = reg.Y: M.FL reg.a     '     /* TYA */
CASE &HA8: reg.Y = reg.a: M.FL reg.Y     '     /* TAY */
CASE &HC8: reg.Y = reg.Y + 1: M.FL reg.Y '     /* INY */
CASE &H88: reg.Y = reg.Y - 1: M.FL reg.Y '     /* DEY */
CASE &H8A: reg.a = reg.x: M.FL reg.a     '     /* TXA */
CASE &HAA: reg.x = reg.a: M.FL reg.x     '     /* TAX */
CASE &HE8: reg.x = reg.x + 1: M.FL reg.x '     /* INX */
CASE &HCA: reg.x = reg.x - 1: M.FL reg.x '     /* DEX */
CASE &HEA:  '                                  /* NOP */
CASE &H9A: reg.s = reg.x                 '     /* TXS */
CASE &HBA: reg.x = reg.s: M.FL reg.x     '     /* TSX */

CASE &H24: MR.Zp I: M.BIT I            '  /* BIT $ss ZP */
CASE &H2C: MR.Ab I: M.BIT I            '  /* BIT $ssss ABS */

CASE &H5: MR.Zp I: M.ORA I             '  /* ORA $ss ZP */
CASE &H6: MM.Zp MASL                 '  /* ASL $ss ZP */
CASE &H25: MR.Zp I: M.AND I            '  /* AND $ss ZP */
CASE &H26: MM.Zp MROL                '  /* ROL $ss ZP */
CASE &H45: MR.Zp I: M.EOR I            '  /* EOR $ss ZP */
CASE &H46: MM.Zp MLSR                '  /* LSR $ss ZP */
CASE &H65: MR.Zp I: M.ADC I          '  /* ADC $ss ZP */
CASE &H66: MM.Zp MROR                '  /* ROR $ss ZP */
CASE &H84: MW.Zp reg.Y                 '  /* STY $ss ZP */
CASE &H85: MW.Zp reg.a                 '  /* STA $ss ZP */
CASE &H86: MW.Zp reg.x                 '  /* STX $ss ZP */
CASE &HA4: MR.Zp reg.Y: M.FL reg.Y     '  /* LDY $ss ZP */
CASE &HA5: MR.Zp reg.a: M.FL reg.a     '  /* LDA $ss ZP */
'/BaH
'/case &HA5: R.A = RAM[ (Op6502(R.PC.W++)) ]  ;break;
'/CAUTION ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
CASE &HA6: MR.Zp reg.x: M.FL reg.x     '  /* LDX $ss ZP */
CASE &HC4: MR.Zp I: M.CMP reg.Y, I     '  /* CPY $ss ZP */
CASE &HC5: MR.Zp I: M.CMP reg.a, I     '  /* CMP $ss ZP */
CASE &HC6: MM.Zp MDEC                '  /* DEC $ss ZP */
CASE &HE4: MR.Zp I: M.CMP reg.x, I     '  /* CPX $ss ZP */
CASE &HE5: MR.Zp I: M.SBC I            '  /* SBC $ss ZP */
CASE &HE6: MM.Zp minc                '  /* INC $ss ZP */
CASE &HD: MR.Ab I: M.ORA I             '  /* ORA $ssss ABS */
CASE &HE: MM.Ab MASL                 '  /* ASL $ssss ABS */
CASE &H2D: MR.Ab I: M.AND I            '  /* AND $ssss ABS */
CASE &H2E: MM.Ab MROL                '  /* ROL $ssss ABS */

CASE &H4D: MR.Ab I: M.EOR I            '  /* EOR $ssss ABS */
CASE &H4E: MM.Ab MLSR                '  /* LSR $ssss ABS */

CASE &H6D: MR.Ab I: M.ADC I            '  /* ADC $ssss ABS */
CASE &H6E: MM.Ab MROR                '  /* ROR $ssss ABS */

CASE &H8C: MW.Ab reg.Y                 '  /* STY $ssss ABS */
CASE &H8D: MW.Ab reg.a                 '  /* STA $ssss ABS */
CASE &H8E: MW.Ab reg.x                 '  /* STX $ssss ABS */
CASE &HAC: MR.Ab reg.Y: M.FL reg.Y     '  /* LDY $ssss ABS */
CASE &HAD: MR.Ab reg.a: M.FL reg.a     '  /* LDA $ssss ABS */
CASE &HAE: MR.Ab reg.x: M.FL reg.x     '  /* LDX $ssss ABS */
CASE &HCC: MR.Ab I: M.CMP reg.Y, I     '  /* CPY $ssss ABS */
CASE &HCD: MR.Ab I: M.CMP reg.a, I     '  /* CMP $ssss ABS */
CASE &HCE: MM.Ab MDEC                '  /* DEC $ssss ABS */

CASE &HEC: MR.Ab I: M.CMP reg.x, I     '  /* CPX $ssss ABS */
CASE &HED: MR.Ab I: M.SBC I            '  /* SBC $ssss ABS */
CASE &HEE: MM.Ab minc                '  /* INC $ssss ABS */

CASE &H9: MR.Im I: M.ORA I             '  /* ORA #$ss IMM */
CASE &H29: MR.Im I: M.AND I            '  /* AND #$ss IMM */
CASE &H49: MR.Im I: M.EOR I            '  /* EOR #$ss IMM */
CASE &H69: MR.Im I: M.ADC I            '  /* ADC #$ss IMM */
CASE &HA0: MR.Im reg.Y: M.FL reg.Y     '  /* LDY #$ss IMM */
CASE &HA2: MR.Im reg.x: M.FL reg.x     '  /* LDX #$ss IMM */
CASE &HA9: MR.Im reg.a: M.FL reg.a     '  /* LDA #$ss IMM */
CASE &HC0: MR.Im I: M.CMP reg.Y, I     '  /* CPY #$ss IMM */
CASE &HC9: MR.Im I: M.CMP reg.a, I     '  /* CMP #$ss IMM */
CASE &HE0: MR.Im I: M.CMP reg.x, I     '  /* CPX #$ss IMM */
CASE &HE9: MR.Im I: M.SBC I            '  /* SBC #$ss IMM */

CASE &H15: MR.Zx I: M.ORA I            '  /* ORA $ss,x ZP,x */
CASE &H16: mm.zx MASL                '  /* ASL $ss,x ZP,x */
CASE &H35: MR.Zx I: M.AND I            '  /* AND $ss,x ZP,x */
CASE &H36: mm.zx MROL                '  /* ROL $ss,x ZP,x */
CASE &H55: MR.Zx I: M.EOR (I)          '  /* EOR $ss,x ZP,x */
CASE &H56: mm.zx MLSR                '  /* LSR $ss,x ZP,x */
CASE &H75: MR.Zx I: M.ADC I            '  /* ADC $ss,x ZP,x */
CASE &H76: mm.zx M_ROR                 '  /* ROR $ss,x ZP,x */
CASE &H94: MW.Zx reg.Y                 '  /* STY $ss,x ZP,x */
CASE &H95: MW.Zx reg.a                 '  /* STA $ss,x ZP,x */
CASE &H96: mw.zy reg.x                 '  /* STX $ss,y ZP,y */
CASE &HB4: MR.Zx reg.Y: M.FL reg.Y     '  /* LDY $ss,x ZP,x */
CASE &HB5: MR.Zx reg.a: M.FL reg.a     '  /* LDA $ss,x ZP,x */
CASE &HB6: mr.zy reg.x: M.FL reg.x     '  /* LDX $ss,y ZP,y */
CASE &HD5: MR.Zx I: M.CMP reg.a, I     '  /* CMP $ss,x ZP,x */
CASE &HD6: mm.zx MDEC                '  /* DEC $ss,x ZP,x */
CASE &HF5: MR.Zx I: M.SBC (I)          '  /* SBC $ss,x ZP,x */
CASE &HF6: mm.zx minc                '  /* INC $ss,x ZP,x */
CASE &H19: MR.Ay I: M.ORA I            '  /* ORA $ssss,y ABS,y */
CASE &H1D: MR.Ax I: M.ORA I            '  /* ORA $ssss,x ABS,x */
CASE &H1E: mm.ax MASL                '  /* ASL $ssss,x ABS,x */
CASE &H39: MR.Ay I: M.AND I            '  /* AND $ssss,y ABS,y */
CASE &H3D: MR.Ax I: M.AND I            '  /* AND $ssss,x ABS,x */
CASE &H3E: mm.ax MROL                '  /* ROL $ssss,x ABS,x */
CASE &H59: MR.Ay I: M.EOR I            '  /* EOR $ssss,y ABS,y */
CASE &H5D: MR.Ax I: M.EOR I            '  /* EOR $ssss,x ABS,x */
CASE &H5E: mm.ax MLSR                '  /* LSR $ssss,x ABS,x */
CASE &H79: MR.Ay I: M.ADC I            '  /* ADC $ssss,y ABS,y */
CASE &H7D: MR.Ax I: M.ADC I            '  /* ADC $ssss,x ABS,x */
CASE &H7E: mm.ax MROR                '  /* ROR $ssss,x ABS,x */
CASE &H99: mw.ay reg.a                 '  /* STA $ssss,y ABS,y */
CASE &H9D: MW.Ax reg.a                 '  /* STA $ssss,x ABS,x */
CASE &HB9: MR.Ay reg.a: M.FL reg.a     '  /* LDA $ssss,y ABS,y */
CASE &HBC: MR.Ax reg.Y: M.FL reg.Y     '  /* LDY $ssss,x ABS,x */
CASE &HBD: MR.Ax reg.a: M.FL reg.a     '  /* LDA $ssss,x ABS,x */
CASE &HBE: MR.Ay reg.x: M.FL reg.x     '  /* LDX $ssss,y ABS,y */
CASE &HD9: MR.Ay I: M.CMP reg.a, I     '  /* CMP $ssss,y ABS,y */
CASE &HDD: MR.Ax I: M.CMP reg.a, I     '  /* CMP $ssss,x ABS,x */
CASE &HDE: mm.ax MDEC                '  /* DEC $ssss,x ABS,x */
CASE &HF9: MR.Ay I: M.SBC I            '  /* SBC $ssss,y ABS,y */
CASE &HFD: MR.Ax I: M.SBC I            '  /* SBC $ssss,x ABS,x */
CASE &HFE: mm.ax minc                '  /* INC $ssss,x ABS,x */
CASE &H1: MR.Ix I: M.ORA I             '  /* ORA ($ss,x) INDEXINDIR */
CASE &H11: MR.Iy I: M.ORA I            '  /* ORA ($ss),y INDIRINDEX */
CASE &H21: MR.Ix I: M.AND I            '  /* AND ($ss,x) INDEXINDIR */
CASE &H31: MR.Iy I: M.AND I            '  /* AND ($ss),y INDIRINDEX */
CASE &H41: MR.Ix I: M.EOR I            '  /* EOR ($ss,x) INDEXINDIR */
CASE &H51: MR.Iy I: M.EOR I            '  /* EOR ($ss),y INDIRINDEX */
CASE &H61: MR.Ix I: M.ADC I            '  /* ADC ($ss,x) INDEXINDIR */
CASE &H71: MR.Iy I: M.ADC I            '  /* ADC ($ss),y INDIRINDEX */
CASE &H81: mw.ix reg.a                 '  /* STA ($ss,x) INDEXINDIR */
CASE &H91: mw.iy reg.a                 '  /* STA ($ss),y INDIRINDEX */
CASE &HA1: MR.Ix reg.a: M.FL reg.a     '  /* LDA ($ss,x) INDEXINDIR */
CASE &HB1: MR.Iy reg.a: M.FL reg.a     '  /* LDA ($ss),y INDIRINDEX */
CASE &HC1: MR.Ix I: M.CMP reg.a, I     '  /* CMP ($ss,x) INDEXINDIR */
CASE &HD1: MR.Iy I: M.CMP reg.a, I     '  /* CMP ($ss),y INDIRINDEX */
CASE &HE1: MR.Ix I: M.SBC I            '  /* SBC ($ss,x) INDEXINDIR */
CASE &HF1: MR.Iy I: M.SBC I            '  /* SBC ($ss),y INDIRINDEX */
CASE &HA: M.ASL reg.a                 '  /* ASL a ACC */
CASE &H2A: M.ROL reg.a                '  /* ROL a ACC */
CASE &H4A: M.LSR reg.a                '  /* LSR a ACC */
CASE &H6A: M.ROR reg.a                '  /* ROR a ACC */

CASE ELSE
PRINT
PRINT "ERROR:"; HEX$(WORD(reg.pc) - 1), HEX$(I): END
'default:
'  if(_TrapBadOps) {
'    fprintf
'    ( stderr,
'      "[M6502 %lX] Unrecognized instruction: $%02X at PC=$%04X\n",
'      (unsigned)_User,Op6502(REG.PC.W-1),(word)(REG.PC.W-1)
'    );
'
'    _Trace=1;
'
'  }
'
'  break;
END SELECT



END SUB

SUB IO.write (a%, b%)
END SUB

SUB M.ADC (rg)
  IF (reg.P AND D.FLAG) THEN
  
  k.L = (reg.a AND &HF) + (rg AND &HF) + (reg.P AND C.FLAG)
  k.h = (reg.a \ 2 ^ 4) + (rg \ 2 ^ 4)
    IF (k.L > 9) THEN k.L = k.L + 6: k.h = k.h + 1
    IF (k.h > 9) THEN k.h = k.h + 6
    reg.a = (k.L AND &HF) OR (k.h * 2 ^ 4)
    IF k.h > 15 THEN TMP = C.FLAG:  ELSE TMP = 0
    reg.P = (reg.P AND NOT (C.FLAG)) OR TMP
    'ZF = NF = A
    reg.ZF = reg.a
    reg.NF = reg.a
                CYCLE = CYCLE + 1
  
  ELSE
  
    words k, reg.a + rg + (reg.P AND C.FLAG)
    reg.P = reg.P AND NOT (C.FLAG)
    IF k.h THEN TMP = C.FLAG:  ELSE TMP = 0
    reg.P = reg.P OR TMP
    'ZF=NF=K.L
    reg.ZF = k.L
    reg.NF = k.L
    reg.a = k.L
   END IF

END SUB

SUB M.ADCx (rg)

 'MX = AdrRAM(reg.X + ZP)
  mx = RdRAM(reg.x + zp)
  IF (reg.P AND D.FLAG) THEN
  
    k.L = (mx AND &HF) + (rg AND &HF) + (reg.P AND C.FLAG)
    k.h = (mx \ 2 ^ 4) + (rg \ 2 ^ 4)';/*+(K.l>>4);*/ \
    IF (k.L > 9) THEN k.L = k.L + 6: k.h = k.h + 1
    IF (k.h > 9) THEN k.h = k.h + 6
    mx = (k.L AND &HF) OR (k.h * 2 ^ 4)
            CYCLE = CYCLE + 1
  
  ELSE
  
    words k, mx + rg + (reg.P AND C.FLAG)
                    mx = k.L
  
 END IF
 'AdrRAM(reg.X + ZP) = MX
  wrRAM reg.x + zp, mx

END SUB

SUB M.AND (rg)
reg.a = reg.a AND rg
M.FL reg.a
END SUB

SUB M.ANDx (rg)
'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) AND RG
wrRAM reg.x + zp, RdRAM(reg.x + zp) AND rg


M.FL RdRAM(reg.x + zp)
END SUB

SUB M.ASL (rg)
reg.P = reg.P AND NOT (C.FLAG)
reg.P = reg.P OR rg \ 2 ^ 7
rg = rg * 2 ^ 1
M.FL rg
END SUB

SUB M.BIT (rg)
reg.NF = rg
reg.VF = rg
reg.ZF = rg AND reg.a

END SUB

SUB M.CMP (RG1, RG2)
words k, RG1 - RG2
reg.P = reg.P AND NOT (C.FLAG)
IF k.h THEN TMP = 0 ELSE TMP = C.FLAG
reg.P = reg.P OR TMP
'ZF = NF = K.L
reg.ZF = k.L
reg.NF = k.L

END SUB

SUB M.DEC (rg)
rg = rg - 1
M.FL rg
END SUB

SUB M.EOR (rg)
reg.a = reg.a XOR rg
M.FL reg.a
END SUB

SUB M.EORx (rg)
'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) XOR RG
wrRAM reg.x + zp, RdRAM(reg.x + zp) XOR rg
M.FL RdRAM(reg.x + zp)

END SUB

SUB M.FL (rg)
'ZF=NF=RG
reg.ZF = rg
reg.NF = rg
END SUB

SUB M.INC (rg)
rg = rg + 1
M.FL rg
END SUB

DEFSNG A-Z
SUB M.JR ()
END SUB

DEFINT A-Z
SUB M.LDWORD (rg AS pcc)
rg.L = op6502(WORD(reg.pc))
rg.h = op6502(WORD(reg.pc) + 1)
words reg.pc, WORD(reg.pc) + 2
END SUB

SUB M.LSR (rg)
reg.P = reg.P AND NOT (C.FLAG)
reg.P = reg.P OR (rg AND C.FLAG)
rg = rg \ 2 ^ 1
M.FL rg

END SUB

SUB M.ORA (rg)
reg.a = reg.a OR rg
M.FL reg.a
END SUB

SUB M.ORAx (rg)
'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) OR RG
wrRAM reg.x + zp, RdRAM(reg.x + zp) OR rg
M.FL RdRAM(reg.x + zp)

END SUB

SUB M.POP (rg)
reg.s = reg.s + 1
rg = RdRAM(SP + reg.s)
END SUB

SUB M.POP.P (rg)
'NF=VF=RG
M.POP rg
reg.NF = rg
reg.VF = rg
IF rg AND Z.FLAG THEN TMP = 0 ELSE TMP = 1
reg.ZF = rg AND TMP
END SUB

SUB M.PUSH (rg)
wrRAM SP + reg.s, rg
reg.s = reg.s - 1

END SUB

SUB M.PUSH.P (rg)
IF reg.ZF THEN TMP = 0 ELSE TMP = Z.FLAG
M.PUSH ((rg) AND NOT (N.FLAG OR V.FLAG OR Z.FLAG)) OR (reg.NF AND N.FLAG) OR (reg.VF AND V.FLAG) OR TMP
END SUB

SUB M.RMB (N)
'AdrRAM(MCZp()) = AdrRAM(MCZp()) AND NOT (N)
wrRAM MCZp(), RdRAM(MCZp()) AND NOT (N)
END SUB

SUB M.ROL (rg)
k.L = (rg * 2 ^ 1) OR (reg.P AND C.FLAG)
reg.P = reg.P AND NOT (C.FLAG)
reg.P = reg.P OR (rg \ 2 ^ 7)
rg = k.L
M.FL rg
END SUB

SUB M.ROR (rg)
k.L = (rg \ 2 ^ 1) OR (reg.P * 2 ^ 7)
reg.P = REGT.P AND NOT (C.FLAG)
reg.P = reg.P OR (rg AND C.FLAG)
rg = k.L
M.FL rg
END SUB

SUB M.SBC (rg)
'/* Warning! C_FLAG is inverted before SBC and after it */
  IF (reg.P AND D.FLAG) THEN
  
    k.L = (reg.a AND &HF) - (rg AND &HF) - (NOT (reg.P) AND C.FLAG)
    IF (k.L AND &H10) THEN k.L = k.L - 6
    k.h = (reg.a \ 2 ^ 4) - (rg \ 2 ^ 4) - ((k.L AND &H10) = &H10)
    IF (k.h AND &H10) THEN k.h = k.h - 6
                CYCLE = CYCLE + 1
  
  ELSE
  
    words k, reg.a - rg - (NOT (reg.P) AND C.FLAG)
  END IF

END SUB

SUB M.SMB (N)
'AdrRAM(MCZp()) = AdrRAM(MCZp()) OR N
wrRAM MCZp(), RdRAM(MCZp()) OR N
END SUB

SUB MC.Ab (rg AS pcc)
M.LDWORD rg

END SUB

SUB MC.Ax (rg AS pcc)
M.LDWORD rg
words rg, WORD(rg) + reg.x
END SUB

SUB MC.Ay (rg AS pcc)
M.LDWORD rg
words rg, WORD(rg) + reg.Y
END SUB

SUB MC.ID (rg AS pcc)
words k, MCZp()
rg.L = RdRAM(WORD(k))
rg.h = RdRAM(WORD(k) + 1)
END SUB

SUB MC.Ix (rg AS pcc)
words k, MCZx()
rg.L = RdRAM(WORD(k))
rg.h = RdRAM(WORD(k) + 1)
END SUB

SUB MC.Iy (rg AS pcc)
words k, MCZp()
rg.L = RdRAM(WORD(k)): rg.h = RdRAM(WORD(k) + 1)
words rg, WORD(rg) + reg.Y
END SUB

SUB mc.zp (rg AS pcc)
rg.L = op6502(WORD(reg.pc))
words reg.pc, WORD(reg.pc) + 1
rg.h = zp \ 2 ^ 8

END SUB

DEFSNG A-Z
SUB mc.zx (rg AS pcc)
rg.L = op6502(WORD(reg.pc)) + reg.x
words reg.pc, WORD(reg.pc) + 1
rg.h = zp \ 2 ^ 8

END SUB

SUB mc.zy (rg AS pcc)
rg.L = op6502(WORD(reg.pc)) + reg.Y
words reg.pc, WORD(reg.pc) + 1
rg.h = zp \ 2 ^ 8

END SUB

FUNCTION MCAB% ()
MCAB% = OP6502W(WORD(reg.pc))

END FUNCTION

FUNCTION MCAX% ()
MCAX% = OP6502W(WORD(reg.pc)) + reg.x
END FUNCTION

FUNCTION MCAY% ()
MCAY% = OP6502W(WORD(reg.pc)) + reg.Y
END FUNCTION

FUNCTION MCIX% ()
MCIX% = RDRAMW(MCZx)

END FUNCTION

FUNCTION MCIY% ()
MCIY% = RDRAMW(MCZp) + reg.Y
END FUNCTION

DEFINT A-Z
FUNCTION MCZp ()
MCZp = op6502(WORD(reg.pc)) + zp
words reg.pc, WORD(reg.pc) + 1

END FUNCTION

FUNCTION MCZx ()
MCZx = (byte) * op6502(WORD(reg.pc)) + reg.x + zp
words reg.pc, WORD(reg.pc) + 1

END FUNCTION

FUNCTION MCZY ()
MCZY = (byte) * op6502(WORD(reg.pc)) + reg.Y + zp
words reg.pc, WORD(reg.pc) + 1
END FUNCTION

SUB MM.Ab (CMD)
MC.Ab J
I = rd6502(WORD(J))

CmdE I, CMD

Wr6502 WORD(J), I

END SUB

SUB mm.ax (CMD)
MC.Ax J
I = rd6502(WORD(J))

CmdE I, CMD

Wr6502 WORD(J), I

END SUB

SUB MM.Zp (CMD)
words J, MCZp()
I = RdRAM(WORD(J))

CmdE I, CMD

wrRAM WORD(J), I
END SUB

SUB mm.zx (CMD)
words J, MCZx()
I = RdRAM(WORD(J))

CmdE I, CMD

wrRAM WORD(J), I
END SUB

SUB MR.Ab (rg)
MC.Ab J
rg = rd6502(WORD(J))

END SUB

SUB MR.Ax (rg)
MC.Ax J
rg = rd6502(WORD(J))
END SUB

SUB MR.Ay (rg)
MC.Ay J
rg = rd6502(WORD(J))
END SUB

SUB MR.ID (rg)
MC.ID J
rg = rd6502(WORD(J))

END SUB

SUB MR.Im (rg)
rg = op6502(WORD(reg.pc))
words reg.pc, WORD(reg.pc) + 1
END SUB

SUB MR.Ix (rg)
MC.Ix J
rg = rd6502(WORD(J))
END SUB

SUB MR.Iy (rg)
MC.Iy J
rg = rd6502(WORD(J))
END SUB

SUB MR.Zp (rg)
rg = RdRAM(MCZp())

END SUB

SUB MR.Zx (rg)
rg = RdRAM(MCZx())
END SUB

SUB mr.zy (rg)
rg = RdRAM(MCZY())
END SUB

SUB MW.Ab (rg)
MC.Ab J
Wr6502 WORD(J), rg
END SUB

SUB MW.Ax (rg)
MC.Ax J
Wr6502 WORD(J), rg
END SUB

SUB mw.ay (rg)
MC.Ay J
Wr6502 WORD(J), rg
END SUB

SUB mw.ix (rg)
MC.Ix J
Wr6502 WORD(J), rg
END SUB

SUB mw.iy (rg)
MC.Iy J
Wr6502 WORD(J), rg
END SUB

SUB MW.Zp (rg)
wrRAM MCZp(), rg
END SUB

SUB MW.Zx (rg)
wrRAM MCZx(), rg
END SUB

SUB mw.zy (rg)
wrRAM MCZY(), rg
END SUB

FUNCTION nop6502 (rg AS pcc)
a& = WORD(rg)
HDR& = 1'512
SEEK #1, a& + HDR&
b$ = INPUT$(1, 1)
nop6502 = ASC(b$)
a& = a& + 1
words rg, a&


END FUNCTION

FUNCTION op6502 (a&)
IF a& < 0 THEN a& = 65536 + a&
HDR& = 1'512
SEEK #1, a& + HDR&
b$ = INPUT$(1, 1)
op6502 = ASC(b$)

END FUNCTION

FUNCTION OP6502W (a%)
END FUNCTION

FUNCTION rd6502 (a&)
SEEK #2, a& + 10001
b$ = INPUT$(1, 2)

rd6502 = ASC(b$)



END FUNCTION

FUNCTION RdRAM% (a%)

SEEK #2, a% + 1
b$ = INPUT$(1, 2)
'RdRAM% = pram(a%)
RdRAM% = ASC(b$)


END FUNCTION

FUNCTION RDRAMW (a%)
END FUNCTION

SUB RESET6502 ()
  reg.mpr(7) = &H0: BANK.SET 7, &H0

   reg.mpr(6) = &H5: BANK.SET 6, &H5

   reg.mpr(5) = &H4: BANK.SET 5, &H4

   reg.mpr(4) = &H3: BANK.SET 4, &H3

   reg.mpr(3) = &H2: BANK.SET 3, &H2

   reg.mpr(2) = &H1: BANK.SET 2, &H1

   reg.mpr(1) = &HF8: BANK.SET 1, &HF8

   reg.mpr(0) = &HFF: BANK.SET 0, &HFF
  reg.a = 0: reg.x = 0: reg.Y = 0
  reg.P = I.FLAG

  reg.NF = 0: reg.VF = 0

  reg.ZF = &HFF
  reg.s = &HFF

  reg.pc.L = op6502(VEC.RESET)
  reg.pc.h = op6502(VEC.RESET + 1)
  reg.ICount = reg.IPeriod
  reg.IRequest = INT.NONE
  reg.AfterCLI = 0
  '//_CycleCount=0;
  '(int)(R->User)=0;
  reg.USER = 0
END SUB

SUB RUN6502 ()
RESET6502
words reg.pc, 0

DO

I = op6502(WORD(reg.pc))
PRINT "("; HEX$(WORD(reg.pc)); ":"; HEX$(I); ")";
words reg.pc, WORD(reg.pc) + 1
CYCLE = CYCLES(I)
CODES I
LOOP
END SUB

SUB TRB (rg)
'NF=VF=RG
reg.NF = rg
reg.VF = rg
rg = rg AND NOT (reg.a)
reg.ZF = rg

END SUB

SUB TSB (rg)
'NF=VF=RG
reg.NF = rg
reg.VF = rg
rg = rg OR reg.a
reg.ZF = rg

END SUB

SUB T_INIT ()
END SUB

FUNCTION WORD& (rg AS pcc)
'A% = CVI(CHR$(RG.L) + CHR$(RG.H))
'WORD& = CVL(MKI$(A%) + MKI$(0))
WORD& = CVL(CHR$(rg.L) + CHR$(rg.h) + MKI$(0))



END FUNCTION

SUB words (rg AS pcc, a&)
'A% = CVI(MKL$(A&))
'RG.L = ASC(MKI$(A%))
'RG.H = ASC(MID$(MKI$(A%), 2))

rg.L = ASC(MKL$(a&))
rg.h = ASC(MID$(MKL$(a&), 2))


END SUB

SUB Wr6502 (a&, b%)

SEEK #2, a& + 10001
b$ = CHR$(b%)
PUT #2, , b$


END SUB

SUB wrRAM (a%, b%)
'pram(a%) = b%
b$ = CHR$(b%)
PUT #2, a% + 1, b$

END SUB

