DECLARE SUB BANK.SET (a%, b%)
DECLARE SUB CODES (I%)
DECLARE SUB IO.write (a%, b%)
DECLARE SUB M.LDWORD (rg AS ANY)
DECLARE SUB M.POP.P (rg%)
DECLARE SUB M.PUSH.P (rg%)
DECLARE SUB MC.Ab (rg AS ANY)
DECLARE SUB MC.Ax (rg AS ANY)
DECLARE SUB MC.Ay (rg AS ANY)
DECLARE SUB MC.ID (rg AS ANY)
DECLARE SUB MC.Ix (rg AS ANY)
DECLARE SUB MC.Iy (rg AS ANY)
DECLARE FUNCTION MCAB% ()
DECLARE FUNCTION MCAX% ()
DECLARE FUNCTION MCAY% ()
DECLARE FUNCTION MCIX% ()
DECLARE FUNCTION MCIY% ()
DECLARE FUNCTION MCZp% ()
DECLARE FUNCTION MCZx% ()
DECLARE FUNCTION MCZY% ()
DECLARE SUB MM.Ab (cmd%)
DECLARE SUB mm.ax (cmd%)
DECLARE SUB MM.Zp (cmd%)
DECLARE SUB mm.zx (cmd%)
DECLARE SUB MR.Ab (rg%)
DECLARE SUB MR.Ax (rg%)
DECLARE SUB MR.Ay (rg%)
DECLARE SUB MR.ID (rg%)
DECLARE SUB MR.Im (rg%)
DECLARE SUB MR.Ix (rg%)
DECLARE SUB MR.Iy (rg%)
DECLARE SUB MR.Zp (rg%)
DECLARE SUB MR.Zx (rg%)
DECLARE SUB mr.zy (rg%)
DECLARE SUB MW.Ab (rg%)
DECLARE SUB MW.Ax (rg%)
DECLARE SUB mw.ay (rg%)
DECLARE SUB mw.ix (rg%)
DECLARE SUB mw.iy (rg%)
DECLARE SUB MW.Zp (rg%)
DECLARE SUB MW.Zx (rg%)
DECLARE SUB mw.zy (rg%)
DECLARE FUNCTION nop6502% (rg AS ANY)
DECLARE FUNCTION op6502% (a&)
DECLARE FUNCTION OP6502W% (a&)
DECLARE FUNCTION rd6502% (a&)
DECLARE FUNCTION RdRAM% (a%)
DECLARE FUNCTION RDRAMW% (a%)
DECLARE SUB RESET6502 ()
DECLARE SUB RUN6502 ()
DECLARE SUB T_INIT ()
DECLARE FUNCTION WORD& (rg AS ANY)
DECLARE SUB words (rg AS ANY, a&)
DECLARE SUB Wr6502 (a&, b%)
DECLARE SUB wrRAM (a%, b%)
DECLARE SUB Cmdr (cmd%, rg%)
DECLARE SUB M.CMP (rg1%, rg2%)
DECLARE SUB M.JR ()
DEFINT A-Z

'TYPE bb  'change this around for lsb fists, last
'L AS INTEGER
'H AS INTEGER
'END TYPE


'TYPE PCC
' W AS INTEGER
' B AS bb
'END TYPE

TYPE pcc
 l AS INTEGER
 h AS INTEGER
END TYPE

TYPE regg
 P AS INTEGER        'on byte register
 a AS INTEGER
 x AS INTEGER
 y AS INTEGER
 s AS INTEGER
 pc AS pcc
 NF AS INTEGER
 VF AS INTEGER
 ZF AS INTEGER
 mpr(7) AS INTEGER
 IRequest AS INTEGER
 ICount AS INTEGER
 IBackup AS INTEGER
 AfterCLI AS INTEGER
 IPeriod AS INTEGER
 USER AS INTEGER
END TYPE


'byte = unsigned char (1)
'word = unsigned short (2)
'offset = signed char

'UNION pair
' word w
' int b {byte l,h}
'end type
' n
' n.w
' n.b (n.b.l,n.b.h)


                       '       /* 6502 status flags:         */
CONST C.FLAG = &H1     '       /* 1: Carry occured           */
CONST Z.FLAG = &H2     '       /* 1: Result is zero          */
CONST I.FLAG = &H4     '       /* 1: Interrupts disabled     */
CONST D.FLAG = &H8     '       /* 1: Decimal mode            */
CONST b.flag = &H10    '       /* Break [0 on stk after int] */
CONST r.flag = &H20    '       /* Always 1                   */
CONST V.FLAG = &H40    '       /* 1: Overflow occured        */
CONST N.FLAG = &H80    '       /* 1: Result is negative      */

'                      '       /* Loop6502() returns:        */
CONST INT.NONE = 0     '       /* No interrupt required      */
CONST INT.IRQ = 1      '       /* Standard IRQ interrupt     */
CONST INT.NMI = 2      '       /* Non-maskable interrupt     */
CONST INT.QUIT = 3     '       /* Exit the emulation         */

CONST INT.TIMER = 4
CONST INT.IRQ2 = 8
CONST VEC.RESET = &HFFFE
CONST VER.NMI = &HFFFC
CONST VEC.TIMER = &HFFFA
CONST VEC.IRQ = &HFFF8
CONST VER.IRQ2 = &HFFF6
CONST VEC.BRK = &HFFFE





DIM SHARED reg AS regg, k AS pcc, J AS pcc, CYCLES%(255), zntable%(255), I
DIM SHARED pram(32766), CYCLE, opcode$(255)
OPEN "BONK3.PCE" FOR BINARY ACCESS READ AS #1
OPEN "pram.ram" FOR BINARY ACCESS READ WRITE AS #2
D$ = STRING$(1000, 0)
FOR I = 1 TO 100
PUT #2, , D$
NEXT I
D$ = ""



RESTORE cycledata
FOR ii = 0 TO 255: READ CYCLES%(ii): NEXT ii
RESTORE zntabledata
FOR ii = 0 TO 255: READ zntable%(ii): NEXT ii
RESTORE data6502
FOR ii = 0 TO 255: READ opcode$(ii): NEXT ii
RESTORE datahu
FOR ii = 0 TO 255: READ a$
IF a$ <> "" THEN opcode$(ii) = a$
NEXT ii
CLS
RUN6502
END



cycledata:
'static byte Cycles[256] =
DATA     8,7,3, 4,6,4,6,7,3,2,2,0,7,5,7,6
DATA     2,7,7, 4,6,4,6,7,2,5,2,0,7,5,7,6
DATA     7,7,3, 4,4,4,6,7,3,2,2,0,5,5,7,6
DATA     2,7,7, 0,4,4,6,7,2,5,2,0,5,5,7,6
DATA     7,7,3, 4,8,4,6,7,3,2,2,0,4,5,7,6
DATA     2,7,7, 5,0,4,6,7,2,5,3,0,0,5,7,6
DATA     7,7,2, 0,4,4,6,7,3,2,2,0,7,5,7,6
DATA     2,7,7,17,4,4,6,7,2,5,3,0,7,5,7,6
DATA     4,7,2, 7,4,4,4,7,2,2,2,0,5,5,5,6
DATA     2,7,7, 8,4,4,4,7,2,5,2,0,5,5,5,6
DATA     2,7,2, 7,4,4,4,7,2,2,2,0,5,5,5,6
DATA     2,7,7, 8,4,4,4,7,2,5,2,0,5,5,5,6
DATA     2,7,2,17,4,4,6,7,2,2,2,0,5,5,7,6
DATA     2,7,7,17,0,4,6,7,2,5,3,0,0,5,7,6
DATA     2,7,0,17,4,4,6,7,2,2,2,0,5,5,7,6
DATA     2,7,7,17,2,4,6,7,2,5,3,0,0,5,7,0









'DATA  7,6,2,8,3,3,5,5,3,2,2,2,4,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  6,6,2,8,3,3,5,5,4,2,2,2,4,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  6,6,2,8,3,3,5,5,3,2,2,2,3,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  6,6,2,8,3,3,5,5,4,2,2,2,5,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  2,6,2,6,3,3,3,3,2,2,2,2,4,4,4,4
'DATA  2,6,2,6,4,4,4,4,2,5,2,5,5,5,5,5
'DATA  2,6,2,6,3,3,3,3,2,2,2,2,4,4,4,4
'DATA  2,5,2,5,4,4,4,4,2,4,2,5,4,4,4,4
'DATA  2,6,2,8,3,3,5,5,2,2,2,2,4,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  2,6,2,8,3,3,5,5,2,2,2,2,4,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'


zntabledata:
'byte ZNTable[256] =

'DATA  Z.FLAG,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

'new
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128



 





'old
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG

CONST MNUL = 0, minc = 1, MDEC = 2, MROR = 3, MROL = 4, MLSR = 5, masl = 6, MTRB = 7, MTSB = 8
CONST M.NUL = 0, m.inc = 1, M.DEC = 2, M.ROR = 3, M.ROL = 4, M.LSR = 5, m.asl = 6, TRB = 7, TSB = 8
CONST m.adc = 9, m.and = 10, m.andx = 11, m.bit = 12, m.eor = 13, m.eorx = 14
CONST m.fl = 15, m.ora = 16, m.orax = 17, m.pop = 18, m.push = 19, m.rmb = 20


datahu:
DATA ,,sxy,st0,tsb,,,rmbi,,,,,tsb,,,bbri
DATA ,,ora,st1,trb,,,rmbi,,,inc,,trb,,,bbri
DATA ,,sax,st2,,,,rmbi,,,,,,,,bbri
DATA ,,and,,bit,,,rmbi,,,dec,,bit,,,bbri
DATA ,,say,tmai,bsr,,,rmbi,,,,,,,,bbri
DATA ,,eor,tmai,csl,,,rmbi,,,phy,,,,,bbri
DATA ,,cla,,stz,,,rmbi,,,,,,,,bbri
DATA ,,adc,tii,stz,,,rmbi,,,ply,,jmp,,,bbri
DATA bra,,clx,tst,,,,rmbi,,bit,,,,,,bbsi
DATA ,,sta,tst,,,,rmbi,,,,,stz,,stz,bbsi
DATA ,,,tst,,,,rmbi,,,,,,,,bbsi
DATA ,,lda,tst,,,,rmbi,,,,,,,,bbsi
DATA ,,cly,tdd,,,,rmbi,,,,,,,,bbsi
DATA ,,cmp,tdd,csh,,,rmbi,,,phx,,,,,bbsi
DATA ,,,tia,,,,rmbi,,,,,,,,bbsi
DATA ,,sbc,tbi,set,,,rmbi,,,plx,,,,,bbsi








data6502:
DATA brk,rra,,,,ora,asl,,php,ora,asl,,,ora,asl,
DATA bpl,ora,,,,ora,asl,,clc,ora,,,,ora,asl,
DATA jsr,and,,,bit,and,rol,,plp,and,rol,,bit,and,rol,
DATA bmi,and,,,,and,rol,,sec,and,,,,and,rol,
DATA rti,eor,,,,eor,lsr,,pha,eor,lsr,,jmp,eor,lsr,
DATA bvl,eor,,,,eor,lsr,,cli,eor,,,,eor,lsr,
DATA rts, adl,,,,adc,ror,,pla,adc,ror,,jmp,adc,ror,
DATA bvs,adc,,,,adc,ror,,sei,adc,,,,adc,ror,
DATA , sta,,,sty,sta,stx,,dey,,txa,,sty,sya,stx,
DATA bcc,sta,,,sty,sta,stx,,tya,sta,txs,,,sta,,
DATA ldy ,lda,ldx,,ldy,lda,ldx,,tay,lda,tax,,ldy,ldy,lda,
DATA bls,lda,,,ldy,lda,ldx,,clv,lda,tsx,,ldy,lda,ldx,
DATA cpy,cmp,,,cpy,cmp,dec,,iny,cmp,dex,,cpy,cmp,dec,
DATA bne,cmp,,,,cmp,dec,,cld,cmp,,,,cmp,dec,
DATA cpx,sec,,,cpx,dbc,inc,,inx,sbc,nop,,cpx,sbc,inc,
DATA beq,sbl,,,,sbc,inc,,sed,sbl,,,,svc,inc,

SUB BANK.SET (a%, b%)
END SUB

SUB Cmdr (cmd, rg)
SELECT CASE cmd
CASE m.adc 'm.adc
  IF (reg.P AND D.FLAG) THEN

  k.l = (reg.a AND &HF) + (rg AND &HF) + (reg.P AND C.FLAG)
  k.h = (reg.a \ 2 ^ 4) + (rg \ 2 ^ 4)
    IF (k.l > 9) THEN k.l = k.l + 6: k.h = k.h + 1
    IF (k.h > 9) THEN k.h = k.h + 6
    reg.a = (k.l AND &HF) OR (k.h * 2 ^ 4)
    IF k.h > 15 THEN TMP = C.FLAG:  ELSE TMP = 0
    reg.P = (reg.P AND NOT (C.FLAG)) OR TMP
    'ZF = NF = A
    reg.ZF = reg.a
    reg.NF = reg.a
                CYCLE = CYCLE + 1

  ELSE

    words k, reg.a + rg + (reg.P AND C.FLAG)
    reg.P = reg.P AND NOT (C.FLAG)
    IF k.h THEN TMP = C.FLAG:  ELSE TMP = 0
    reg.P = reg.P OR TMP
    'ZF=NF=K.L
    reg.ZF = k.l
    reg.NF = k.l
    reg.a = k.l
   END IF
CASE M.ADCx
 'MX = AdrRAM(reg.X + ZP)
  mx = RdRAM(reg.x + zp)
  IF (reg.P AND D.FLAG) THEN

    k.l = (mx AND &HF) + (rg AND &HF) + (reg.P AND C.FLAG)
    k.h = (mx \ 2 ^ 4) + (rg \ 2 ^ 4)';/*+(K.l>>4);*/ \
    IF (k.l > 9) THEN k.l = k.l + 6: k.h = k.h + 1
    IF (k.h > 9) THEN k.h = k.h + 6
    mx = (k.l AND &HF) OR (k.h * 2 ^ 4)
            CYCLE = CYCLE + 1

  ELSE

    words k, mx + rg + (reg.P AND C.FLAG)
                    mx = k.l

 END IF
 'AdrRAM(reg.X + ZP) = MX
  wrRAM reg.x + zp, mx

CASE m.and
reg.a = reg.a AND rg
Cmdr m.fl, reg.a

CASE m.andx
   'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) AND RG
   wrRAM reg.x + zp, RdRAM(reg.x + zp) AND rg
   Cmdr m.fl, RdRAM(reg.x + zp)

CASE m.asl
   reg.P = reg.P AND NOT (C.FLAG)
   reg.P = reg.P OR rg \ 2 ^ 7
   rg = rg * 2 ^ 1
   Cmdr m.fl, rg

CASE m.bit
  reg.NF = rg
  reg.VF = rg
  reg.ZF = rg AND reg.a




CASE M.NUL:
PRINT "error: CmdRg Null": END
CASE m.inc
  rg = rg + 1
  Cmdr m.fl, rg

CASE M.DEC
  rg = rg - 1
  Cmdr m.fl, rg


CASE M.ROR
  k.l = (rg \ 2 ^ 1) OR (reg.P * 2 ^ 7)
  reg.P = REGT.P AND NOT (C.FLAG)
  reg.P = reg.P OR (rg AND C.FLAG)
  rg = k.l
  Cmdr m.fl, rg

CASE M.ROL
  k.l = (rg * 2 ^ 1) OR (reg.P AND C.FLAG)
  reg.P = reg.P AND NOT (C.FLAG)
  reg.P = reg.P OR (rg \ 2 ^ 7)
  rg = k.l
  Cmdr m.fl, rg

CASE M.LSR
  reg.P = reg.P AND NOT (C.FLAG)
  reg.P = reg.P OR (rg AND C.FLAG)
  rg = rg \ 2 ^ 1
  Cmdr m.fl, rg

CASE TRB

  'NF=VF=RG
  reg.NF = rg
  reg.VF = rg
  rg = rg AND NOT (reg.a)
  reg.ZF = rg

CASE TSB:
  'NF=VF=RG
  reg.NF = rg
  reg.VF = rg
  rg = rg OR reg.a
  reg.ZF = rg
CASE m.eor
  reg.a = reg.a XOR rg
  Cmdr m.fl, reg.a
CASE m.eorx
  'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) XOR RG
  wrRAM reg.x + zp, RdRAM(reg.x + zp) XOR rg
  Cmdr m.fl, RdRAM(reg.x + zp)
CASE m.fl
  'ZF=NF=RG
  reg.ZF = rg
  reg.NF = rg
CASE m.ora
  reg.a = reg.a OR rg
  Cmdr m.fl, reg.a
CASE m.orax
  'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) OR RG
  wrRAM reg.x + zp, RdRAM(reg.x + zp) OR rg
  Cmdr m.fl, RdRAM(reg.x + zp)
CASE m.pop
  reg.s = reg.s + 1
  rg = RdRAM(SP + reg.s)
CASE m.push
  wrRAM SP + reg.s, rg
  reg.s = reg.s - 1

CASE m.rmb
  'AdrRAM(MCZp()) = AdrRAM(MCZp()) AND NOT (N)
  wrRAM MCZp(), RdRAM(MCZp()) AND NOT (rg)
CASE M.SBC
  '/* Warning! C_FLAG is inverted before SBC and after it */
    IF (reg.P AND D.FLAG) THEN

      k.l = (reg.a AND &HF) - (rg AND &HF) - (NOT (reg.P) AND C.FLAG)
      IF (k.l AND &H10) THEN k.l = k.l - 6
      k.h = (reg.a \ 2 ^ 4) - (rg \ 2 ^ 4) - ((k.l AND &H10) = &H10)
      IF (k.h AND &H10) THEN k.h = k.h - 6
                  CYCLE = CYCLE + 1

    ELSE

      words k, reg.a - rg - (NOT (reg.P) AND C.FLAG)
    END IF
CASE M.SMB
  'AdrRAM(MCZp()) = AdrRAM(MCZp()) OR N
  wrRAM MCZp(), RdRAM(MCZp()) OR rg



 
  

CASE ELSE
PRINT "error: CmdRg not found(" + HEX$(cmd) + ")": END
END SELECT



END SUB

SUB CODES (I)

SELECT CASE I
CASE &HD4'/* CSH set clock highspeed */
CASE &H54'/* CSL set clock lowspeed */

CASE &H44: '/* BSR * REL */
           Cmdr m.push, reg.pc.h
           Cmdr m.push, reg.pc.l

CASE &H80: '/* BRA * REL */
          words reg.pc, WORD(reg.pc) + op6502(WORD(reg.pc)) + 1


CASE &H7C: '/* JMP ($ssss,x) */
        M.LDWORD k: words k, WORD(k) + reg.x
        reg.pc.l = op6502(WORD(k))
        reg.pc.h = op6502(WORD(k) + 1)

CASE &HDA: Cmdr m.push, reg.x  '  /* PHX */

CASE &H5A: Cmdr m.push, reg.y '               /* PHY */
CASE &HFA: Cmdr m.pop, reg.x: Cmdr m.fl, reg.x '    /* PLX */
CASE &H7A: Cmdr m.pop, reg.y: Cmdr m.fl, reg.y'      /* PLY */

CASE &H62: reg.a = 0' /* CLA */
CASE &H82: reg.x = 0' /* CLX */
CASE &HC2: reg.y = 0' /* CLY */

CASE &H2: I = reg.x: reg.x = reg.y: reg.y = I'  /* SXY */
CASE &H22: I = reg.a: reg.a = reg.x: reg.x = I'  /* SAX */
CASE &H42: I = reg.a: reg.a = reg.y: reg.y = I'  /* SAY */

CASE &H3A: Cmdr M.DEC, reg.a                  ' /* DEC A */

CASE &H1A: Cmdr m.inc, reg.a                  ' /* INC A */


CASE &H72: MR.ID I: Cmdr m.adc, I               '/* ADC ($ss) INDIR */
CASE &H32: MR.ID I: Cmdr m.and, I               '/* AND ($ss) INDIR */
CASE &HD2: MR.ID I: M.CMP reg.a, I        '/* CMP ($ss) INDIR */
CASE &H52: MR.ID I: Cmdr m.eor, I               '/* EOR ($ss) INDIR */
CASE &HB2: MR.ID reg.a: Cmdr m.fl, reg.a        '/* LDA ($ss) INDIR */
CASE &H12: MR.ID I: Cmdr m.ora, I               '/* ORA ($ss) INDIR */
CASE &H92: MC.ID J: Wr6502 WORD(J), reg.a     '/* STA ($ss) INDIR */
CASE &HF2: MR.ID I: Cmdr M.SBC, I             '  /* SBC ($ss) INDIR */

CASE &H89: MR.Im I: Cmdr m.bit, I  '              /* BIT #$ss IMM */
CASE &H34: MR.Zx I: Cmdr m.bit, I  '              /* BIT $ss,x ZP,x */
CASE &H3C: MR.Ax I: Cmdr m.bit, I  '              /* BIT $ssss,x ABS,x */

CASE &H64: MW.Zp &H0            '          /* STZ $ss ZP */
CASE &H74: MW.Zx &H0            '          /* STZ $ss,x ZP,x */
CASE &H9C: MW.Ab &H0            '          /* STZ $ssss ABS */
CASE &H9E: MW.Ax &H0            '          /* STZ $ssss,x ABS,x */

CASE &HF4: ' /* SET */
        I = op6502(WORD(reg.pc))
        words reg.pc, WORD(reg.pc) + 1
        CYCLE = CYCLE + CYCLES(I) + 3
        SELECT CASE I
        CASE &H65: MR.Zp I: Cmdr M.ADCx, I'       /* ADC $ss ZP */
        CASE &H6D: MR.Ab I: Cmdr M.ADCx, I'       /* ADC $ssss ABS */
        CASE &H69: MR.Im I: Cmdr M.ADCx, I'       /* ADC #$ss IMM */
        CASE &H75: MR.Zx I: Cmdr M.ADCx, I'       /* ADC $ss,x ZP,x */
        CASE &H79: MR.Ay I: Cmdr M.ADCx, I'       /* ADC $ssss,y ABS,y */
        CASE &H7D: MR.Ax I: Cmdr M.ADCx, I'       /* ADC $ssss,x ABS,x */
        CASE &H61: MR.Ix I: Cmdr M.ADCx, I'       /* ADC ($ss,x) INDEXINDIR */
        CASE &H71: MR.Iy I: Cmdr M.ADCx, I'       /* ADC ($ss),y INDIRINDEX */
        CASE &H72: MR.ID I: Cmdr M.ADCx, I'       /* ADC ($ss) INDIR */

        CASE &H25: MR.Zp I: Cmdr m.andx, I'       /* AND $ss ZP */
        CASE &H2D: MR.Ab I: Cmdr m.andx, I'       /* AND $ssss ABS */
        CASE &H29: MR.Im I: Cmdr m.andx, I'       /* AND #$ss IMM */
        CASE &H35: MR.Zx I: Cmdr m.andx, I'       /* AND $ss,x ZP,x */
        CASE &H39: MR.Ay I: Cmdr m.andx, I'       /* AND $ssss,y ABS,y */
        CASE &H3D: MR.Ax I: Cmdr m.andx, I'       /* AND $ssss,x ABS,x */
        CASE &H21: MR.Ix I: Cmdr m.andx, I'       /* AND ($ss,x) INDEXINDIR */
        CASE &H31: MR.Iy I: Cmdr m.andx, I'       /* AND ($ss),y INDIRINDEX */
        CASE &H32: MR.ID I: Cmdr m.andx, I'       /* AND ($ss) INDIR */

        CASE &H45: MR.Zp I: Cmdr m.eorx, I '       /* EOR $ss ZP */
        CASE &H4D: MR.Ab I: Cmdr m.eorx, I '       /* EOR $ssss ABS */
        CASE &H49: MR.Im I: Cmdr m.eorx, I '       /* EOR #$ss IMM */
        CASE &H55: MR.Zx I: Cmdr m.eorx, I '       /* EOR $ss,x ZP,x */
        CASE &H59: MR.Ay I: Cmdr m.eorx, I '       /* EOR $ssss,y ABS,y */
        CASE &H5D: MR.Ax I: Cmdr m.eorx, I '       /* EOR $ssss,x ABS,x */
        CASE &H41: MR.Ix I: Cmdr m.eorx, I '       /* EOR ($ss,x) INDEXINDIR */
        CASE &H51: MR.Iy I: Cmdr m.eorx, I '       /* EOR ($ss),y INDIRINDEX */
        CASE &H52: MR.ID I: Cmdr m.eorx, I '       /* EOR ($ss) INDIR */

        CASE &H5: MR.Zp I: Cmdr m.orax, I  '       /* ORA $ss ZP */
        CASE &HD: MR.Ab I: Cmdr m.orax, I  '       /* ORA $ssss ABS */
        CASE &H9: MR.Im I: Cmdr m.orax, I  '       /* ORA #$ss IMM */
        CASE &H15: MR.Zx I: Cmdr m.orax, I '       /* ORA $ss,x ZP,x */
        CASE &H19: MR.Ay I: Cmdr m.orax, I '       /* ORA $ssss,y ABS,y */
        CASE &H1D: MR.Ax I: Cmdr m.orax, I '       /* ORA $ssss,x ABS,x */
        CASE &H1: MR.Ix I: Cmdr m.orax, I  '       /* ORA ($ss,x) INDEXINDIR */
        CASE &H11: MR.Iy I: Cmdr m.orax, I '       /* ORA ($ss),y INDIRINDEX */
        CASE &H12: MR.ID I: Cmdr m.orax, I '       /* ORA ($ss) INDIR */

        CASE ELSE
        PRINT ERR, "no sense SET"
        CYCLE = CYCLE - CYCLES(I)


        END SELECT

CASE &H3: IO.write 0, op6502(WORD(reg.pc)): words reg.pc, WORD(reg.pc) + 1 '/* ST0 */
CASE &H13: IO.write 2, op6502(WORD(reg.pc)): words reg.pc, WORD(reg.pc) + 1 '/* ST1 */
CASE &H23: IO.write 3, op6502(WORD(reg.pc)): words reg.pc, WORD(reg.pc) + 1 '/* ST2 */

CASE &H43: '/* TMAi */
        I = op6502(WORD(reg.pc)): words reg.pc, WORD(reg.pc) + 1

          FOR ii = 0 TO 7
              I = I \ 2 ^ 1

              IF (I AND 1) THEN EXIT FOR

          '//reg.a = Reg.MPR[ii]
          '//reg.a = Reg.MPR[ii]
          reg.a = reg.mpr(ii)
          NEXT ii

CASE &H53: '/* TAMi */
        I = op6502(WORD(reg.pc)): words reg.pc, WORD(reg.pc) + 1
         ''''PRINT i
         FOR ii = 0 TO 7

                I = I \ 2 ^ 1
                IF (I AND 1) THEN
                        '//R->MPR[ii]=reg.a;
                        '//R.MPR[ii]=reg.a;
                        reg.mpr(ii) = reg.a
                        BANK.SET ii, reg.a
                END IF
         NEXT ii

CASE &HC3: ' /* TDD */
        T_INIT
        DO
        Wr6502 dist&, rd6502(src&)
        dist = dist - 1

        src = src - 1
        length = length - 1
        LOOP WHILE length
'        } while(--length);




CASE &H73: ' /* TII */
        T_INIT
        DO
             Wr6502 dist&, rd6502(src&)
             dist = dist + 1
                src = src + 1
        length = length - 1
        LOOP WHILE length
'        } while(--length);


CASE &HE3: ' /* TIA */
        T_INIT
        DO
                Wr6502 dist&, rd6502(src&)
                src = src + 1

                IF NOT length THEN EXIT DO
                ' if (!(--length)):break
                length = length - 1
                Wr6502 dist + 1, rd6502(src&)
                src = src + 1
'        } while(--length);
        lenght = length - 1
        LOOP WHILE length


CASE &HF3: ' /* TAI */
        T_INIT
        DO
                Wr6502 dist&, rd6502(src&)
                dist = dist + 1
                'if (!(--length)) break;
                length = length - 1
                IF NOT length THEN EXIT DO
                Wr6502 dist&, rd6502(src + 1)
                dist = dist + 1

         length = length - 1
         LOOP WHILE length
'        } while(--length);

CASE &HD3: ' /* TIN */
        T_INIT
        DO
                Wr6502 dist&, rd6502(src&)
                src = src + 1
        length = length - 1
        LOOP WHILE length

CASE &H14: MM.Zp MTRB '      /* TRB $ss ZP */

CASE &H1C: MM.Ab MTRB '      /* TRB $ssss ABS */
CASE &H4: MM.Zp MTSB  '      /* TSB $ss ZP */

CASE &HC: MM.Ab MTSB  '      /* TSB $ssss ABS */

CASE &H83: '/* TST #$ss,$ss IMM,ZP */
        I = op6502(WORD(reg.pc)): J.l = RdRAM(MCZp())
        words reg.pc, WORD(reg.pc) + 1
'error    NF = VF = J.L
        reg.NF = J.l
        reg.VF = J.l: reg.ZF = I AND J.l

CASE &HA3: '/* TST #$ss,$ss,x IMM,ZP,x */
        I = op6502(WORD(reg.pc)): J.l = RdRAM(MCZx())
        words reg.pc, WORD(reg.pc) + 1

'error REG,NF = REG.VF = J.L
        reg.NF = J.l
        reg.VF = J.l: reg.ZF = I AND J.l
CASE &H93: '/* TST #$ss,$ssss IMM,ABS */
        I = op6502(WORD(reg.pc)): MR.Ab J.l
        words reg.pc, WORD(reg.pc) + 1
'error
        reg.NF = J.l
         reg.VF = J.l: reg.ZF = I AND J.l

CASE &HB3: '/* TST #$ss,$ssss,x IMM,ABS,x */
        I = op6502(WORD(reg.pc)): MR.Ax J.l
        words reg.pc, WORD(reg.pc) + 1
'error
        reg.NF = J.l
        reg.VF = J.l: reg.ZF = I AND J.l

CASE &HF: IF RdRAM(MCZp()) AND &H1 THEN words reg.pc, WORD(reg.pc) + 1:      ELSE M.JR          '      /* BBRi */
CASE &H1F: IF RdRAM(MCZp()) AND &H2 THEN words reg.pc, WORD(reg.pc) + 1:     ELSE M.JR
CASE &H2F: IF RdRAM(MCZp()) AND &H4 THEN words reg.pc, WORD(reg.pc) + 1:      ELSE M.JR
CASE &H3F: IF RdRAM(MCZp()) AND &H8 THEN words reg.pc, WORD(reg.pc) + 1:      ELSE M.JR
CASE &H4F: IF RdRAM(MCZp()) AND &H10 THEN words reg.pc, WORD(reg.pc) + 1:     ELSE M.JR
CASE &H5F: IF RdRAM(MCZp()) AND &H20 THEN words reg.pc, WORD(reg.pc) + 1:     ELSE M.JR
CASE &H6F: IF RdRAM(MCZp()) AND &H40 THEN words reg.pc, WORD(reg.pc) + 1:      ELSE M.JR
CASE &H7F: IF RdRAM(MCZp()) AND &H80 THEN words reg.pc, WORD(reg.pc) + 1:      ELSE M.JR

CASE &H8F: IF RdRAM(MCZp()) AND &H1 THEN M.JR:         ELSE words reg.pc, WORD(reg.pc) + 1      '      /* BBSi */
CASE &H9F: IF RdRAM(MCZp()) AND &H2 THEN M.JR:         ELSE words reg.pc, WORD(reg.pc) + 1
CASE &HAF: IF RdRAM(MCZp()) AND &H4 THEN M.JR:         ELSE words reg.pc, WORD(reg.pc) + 1
CASE &HBF: IF RdRAM(MCZp()) AND &H8 THEN M.JR:         ELSE words reg.pc, WORD(reg.pc) + 1
CASE &HCF: IF RdRAM(MCZp()) AND &H10 THEN M.JR:        ELSE words reg.pc, WORD(reg.pc) + 1
CASE &HDF: IF RdRAM(MCZp()) AND &H20 THEN M.JR:        ELSE words reg.pc, WORD(reg.pc) + 1
CASE &HEF: IF RdRAM(MCZp()) AND &H40 THEN M.JR:        ELSE words reg.pc, WORD(reg.pc) + 1
CASE &HFF: IF RdRAM(MCZp()) AND &H80 THEN M.JR:        ELSE words reg.pc, WORD(reg.pc) + 1


CASE &H7: Cmdr m.rmb, &H1   '        /* RMBi */
CASE &H17: Cmdr m.rmb, &H2  '        /* RMBi */
CASE &H27: Cmdr m.rmb, &H4  '        /* RMBi */
CASE &H37: Cmdr m.rmb, &H8  '        /* RMBi */
CASE &H47: Cmdr m.rmb, &H10 '        /* RMBi */
CASE &H57: Cmdr m.rmb, &H20 '        /* RMBi */
CASE &H67: Cmdr m.rmb, &H40 '        /* RMBi */
CASE &H77: Cmdr m.rmb, &H80 '        /* RMBi */

CASE &H87: Cmdr M.SMB, &H1  '        /* SMBi */
CASE &H97: Cmdr M.SMB, &H2  '        /* SMBi */
CASE &HA7: Cmdr M.SMB, &H4  '        /* SMBi */
CASE &HB7: Cmdr M.SMB, &H8  '        /* SMBi */
CASE &HC7: Cmdr M.SMB, &H10 '        /* SMBi */
CASE &HD7: Cmdr M.SMB, &H20 '        /* SMBi */
CASE &HE7: Cmdr M.SMB, &H40 '        /* SMBi */
CASE &HF7: Cmdr M.SMB, &H80 '        /* SMBi */




CASE &H10: IF (reg.NF AND N.FLAG) THEN words reg.pc, WORD(reg.pc) + 1:   ELSE M.JR'/* BPL * REL */
CASE &H30: IF (reg.NF AND N.FLAG) THEN M.JR:  ELSE words reg.pc, WORD(reg.pc) + 1 '/* BMI * REL */
CASE &HD0: IF (NOT reg.ZF) THEN words reg.pc, WORD(reg.pc) + 1 ELSE : M.JR       '/* BNE * REL */
CASE &HF0: IF (NOT reg.ZF) THEN M.JR ELSE : words reg.pc, WORD(reg.pc) + 1       '/* BEQ * REL */
CASE &H90: IF (reg.P AND C.FLAG) THEN words reg.pc, WORD(reg.pc) + 1 ELSE : M.JR '/* BCC * REL */
CASE &HB0: IF (reg.P AND C.FLAG) THEN M.JR ELSE : words reg.pc, WORD(reg.pc) + 1 '/* BCS * REL */
CASE &H50: IF (reg.VF AND V.FLAG) THEN words reg.pc, WORD(reg.pc) + 1 ELSE M.JR '/* BVC * REL */
CASE &H70: IF (reg.VF AND V.FLAG) THEN M.JR ELSE : words reg.pc, WORD(reg.pc) + 1 '/* BVS * REL */


CASE &H40: '/* RTI */

  I = reg.P


  M.POP.P reg.P

  IF ((reg.IRequest <> INT.NONE) AND (I AND I.FLAG) <> 0 AND NOT (reg.P AND I.FLAG) <> 0) THEN
     REGAfterCLI = 1
    reg.IBackup = reg.ICount
    reg.ICount = 0
    END IF
    Cmdr m.pop, reg.pc.l
    Cmdr m.pop, reg.pc.h



CASE &H60: '/* RTS */
  Cmdr m.pop, reg.pc.l: Cmdr m.pop, reg.pc.h: words reg.pc, WORD(reg.pc) + 1


CASE &H20: '/* JSR $ssss ABS */
  k.l = op6502(WORD(reg.pc))
  words reg.pc, WORD(reg.pc) + 1

  k.h = op6502(WORD(reg.pc))
  Cmdr m.push, reg.pc.h
  Cmdr m.push, reg.pc.l
  reg.pc = k


CASE &H4C: M.LDWORD k: reg.pc = k'/* JMP $ssss ABS */


CASE &H6C: '/* JMP ($ssss) ABDINDIR */
  M.LDWORD k
  reg.pc.l = op6502(WORD(k))
  words k, WORD(k) + 1
  reg.pc.h = op6502(WORD(k))



CASE &H0: '/* BRK */
  words reg.pc, WORD(reg.pc) + 1
  Cmdr m.push, reg.pc.h: Cmdr m.push, reg.pc.l
  M.PUSH.P reg.P AND NOT (T.FLAG) OR (b.flag)
  reg.P = (reg.P OR I.FLAG) AND NOT (D.FLAG)
  reg.pc.l = op6502(VEC.BRK)
  reg.pc.h = op6502(VEC.BRK + 1)


  PRINT ERR, "BRK instruction"
  END



CASE &H58: '/* CLI */
  IF ((reg.IRequest <> INT.NONE) AND (reg.P AND I.FLAG) <> 0) THEN
  
    reg.AfterCLI = 1
    reg.IBackup = reg.ICount
    reg.ICount = 0

  END IF
  reg.P = reg.P AND NOT (I.FLAG)



CASE &H28: '/* PLP */
  M.POP.P I

  IF ((reg.IRequest <> INT.NONE) AND ((I XOR reg.P) AND NOT (I) AND I.FLAG) <> 0) THEN

    reg.AfterCLI = 1
    reg.IBackup = reg.ICount
    reg.ICount = 0

  END IF
  reg.P = I



CASE &H8: M.PUSH.P reg.P AND NOT (T.FLAG) OR b.flag'     /* PHP */
CASE &H18: reg.P = reg.P AND NOT (C.FLAG)          '     /* CLC */
CASE &HB8: reg.VF = 0                              '     /* CLV */
CASE &HD8: reg.P = reg.P AND NOT (D.FLAG)          '     /* CLD */
CASE &H38: reg.P = reg.P OR C.FLAG                 '     /* SEC */
CASE &HF8: reg.P = reg.P OR D.FLAG                 '     /* SED */
CASE &H78: reg.P = reg.P OR I.FLAG                 '     /* SEI */
CASE &H48: Cmdr m.push, reg.a          '             /* PHA */
CASE &H68: Cmdr m.pop, reg.a: Cmdr m.fl, reg.a       '     /* PLA */
CASE &H98: reg.a = reg.y: Cmdr m.fl, reg.a     '     /* TYA */
CASE &HA8: reg.y = reg.a: Cmdr m.fl, reg.y     '     /* TAY */
CASE &HC8: reg.y = reg.y + 1: Cmdr m.fl, reg.y '     /* INY */
CASE &H88: reg.y = reg.y - 1: Cmdr m.fl, reg.y '     /* DEY */
CASE &H8A: reg.a = reg.x: Cmdr m.fl, reg.a     '     /* TXA */
CASE &HAA: reg.x = reg.a: Cmdr m.fl, reg.x     '     /* TAX */
CASE &HE8: reg.x = reg.x + 1: Cmdr m.fl, reg.x '     /* INX */
CASE &HCA: reg.x = reg.x - 1: Cmdr m.fl, reg.x '     /* DEX */
CASE &HEA:  '                                  /* NOP */
CASE &H9A: reg.s = reg.x                 '     /* TXS */
CASE &HBA: reg.x = reg.s: Cmdr m.fl, reg.x     '     /* TSX */

CASE &H24: MR.Zp I: Cmdr m.bit, I            '  /* BIT $ss ZP */
CASE &H2C: MR.Ab I: Cmdr m.bit, I            '  /* BIT $ssss ABS */

CASE &H5: MR.Zp I: Cmdr m.ora, I             '  /* ORA $ss ZP */
CASE &H6: MM.Zp m.asl                 '  /* ASL $ss ZP */
CASE &H25: MR.Zp I: Cmdr m.and, I            '  /* AND $ss ZP */
CASE &H26: MM.Zp M.ROL                '  /* ROL $ss ZP */
CASE &H45: MR.Zp I: Cmdr m.eor, I            '  /* EOR $ss ZP */
CASE &H46: MM.Zp M.LSR                '  /* LSR $ss ZP */
CASE &H65: MR.Zp I: Cmdr m.adc, I          '  /* ADC $ss ZP */
CASE &H66: MM.Zp MROR                '  /* ROR $ss ZP */
CASE &H84: MW.Zp reg.y                 '  /* STY $ss ZP */
CASE &H85: MW.Zp reg.a                 '  /* STA $ss ZP */
CASE &H86: MW.Zp reg.x                 '  /* STX $ss ZP */
CASE &HA4: MR.Zp reg.y: Cmdr m.fl, reg.y     '  /* LDY $ss ZP */
CASE &HA5: MR.Zp reg.a: Cmdr m.fl, reg.a     '  /* LDA $ss ZP */
'/BaH
'/case &HA5: R.A = RAM[ (Op6502(R.PC.W++)) ]  ;break;
'/CAUTION ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
CASE &HA6: MR.Zp reg.x: Cmdr m.fl, reg.x     '  /* LDX $ss ZP */
CASE &HC4: MR.Zp I: M.CMP reg.y, I     '  /* CPY $ss ZP */
CASE &HC5: MR.Zp I: M.CMP reg.a, I     '  /* CMP $ss ZP */
CASE &HC6: MM.Zp M.DEC                '  /* DEC $ss ZP */
CASE &HE4: MR.Zp I: M.CMP reg.x, I     '  /* CPX $ss ZP */
CASE &HE5: MR.Zp I: Cmdr M.SBC, I            '  /* SBC $ss ZP */
CASE &HE6: MM.Zp m.inc                '  /* INC $ss ZP */
CASE &HD: MR.Ab I: Cmdr m.ora, I             '  /* ORA $ssss ABS */
CASE &HE: MM.Ab m.asl                 '  /* ASL $ssss ABS */
CASE &H2D: MR.Ab I: Cmdr m.and, I            '  /* AND $ssss ABS */
CASE &H2E: MM.Ab M.ROL                '  /* ROL $ssss ABS */

CASE &H4D: MR.Ab I: Cmdr m.eor, I            '  /* EOR $ssss ABS */
CASE &H4E: MM.Ab M.LSR                '  /* LSR $ssss ABS */

CASE &H6D: MR.Ab I: Cmdr m.adc, I            '  /* ADC $ssss ABS */
CASE &H6E: MM.Ab M.ROR                '  /* ROR $ssss ABS */

CASE &H8C: MW.Ab reg.y                 '  /* STY $ssss ABS */
CASE &H8D: MW.Ab reg.a                 '  /* STA $ssss ABS */
CASE &H8E: MW.Ab reg.x                 '  /* STX $ssss ABS */
CASE &HAC: MR.Ab reg.y: Cmdr m.fl, reg.y     '  /* LDY $ssss ABS */
CASE &HAD: MR.Ab reg.a: Cmdr m.fl, reg.a     '  /* LDA $ssss ABS */
CASE &HAE: MR.Ab reg.x: Cmdr m.fl, reg.x     '  /* LDX $ssss ABS */
CASE &HCC: MR.Ab I: M.CMP reg.y, I     '  /* CPY $ssss ABS */
CASE &HCD: MR.Ab I: M.CMP reg.a, I     '  /* CMP $ssss ABS */
CASE &HCE: MM.Ab M.DEC                '  /* DEC $ssss ABS */

CASE &HEC: MR.Ab I: M.CMP reg.x, I     '  /* CPX $ssss ABS */
CASE &HED: MR.Ab I: Cmdr M.SBC, I            '  /* SBC $ssss ABS */
CASE &HEE: MM.Ab m.inc                '  /* INC $ssss ABS */

CASE &H9: MR.Im I: Cmdr m.ora, I             '  /* ORA #$ss IMM */
CASE &H29: MR.Im I: Cmdr m.and, I            '  /* AND #$ss IMM */
CASE &H49: MR.Im I: Cmdr m.eor, I            '  /* EOR #$ss IMM */
CASE &H69: MR.Im I: Cmdr m.adc, I            '  /* ADC #$ss IMM */
CASE &HA0: MR.Im reg.y: Cmdr m.fl, reg.y     '  /* LDY #$ss IMM */
CASE &HA2: MR.Im reg.x: Cmdr m.fl, reg.x     '  /* LDX #$ss IMM */
CASE &HA9: MR.Im reg.a: Cmdr m.fl, reg.a     '  /* LDA #$ss IMM */
CASE &HC0: MR.Im I: M.CMP reg.y, I     '  /* CPY #$ss IMM */
CASE &HC9: MR.Im I: M.CMP reg.a, I     '  /* CMP #$ss IMM */
CASE &HE0: MR.Im I: M.CMP reg.x, I     '  /* CPX #$ss IMM */
CASE &HE9: MR.Im I: Cmdr M.SBC, I            '  /* SBC #$ss IMM */

CASE &H15: MR.Zx I: Cmdr m.ora, I            '  /* ORA $ss,x ZP,x */
CASE &H16: mm.zx m.asl                '  /* ASL $ss,x ZP,x */
CASE &H35: MR.Zx I: Cmdr m.and, I            '  /* AND $ss,x ZP,x */
CASE &H36: mm.zx M.ROL                '  /* ROL $ss,x ZP,x */
CASE &H55: MR.Zx I: Cmdr m.eor, I          '  /* EOR $ss,x ZP,x */
CASE &H56: mm.zx M.LSR                '  /* LSR $ss,x ZP,x */
CASE &H75: MR.Zx I: Cmdr m.adc, I            '  /* ADC $ss,x ZP,x */
CASE &H76: mm.zx M.ROR                 '  /* ROR $ss,x ZP,x */
CASE &H94: MW.Zx reg.y                 '  /* STY $ss,x ZP,x */
CASE &H95: MW.Zx reg.a                 '  /* STA $ss,x ZP,x */
CASE &H96: mw.zy reg.x                 '  /* STX $ss,y ZP,y */
CASE &HB4: MR.Zx reg.y: Cmdr m.fl, reg.y     '  /* LDY $ss,x ZP,x */
CASE &HB5: MR.Zx reg.a: Cmdr m.fl, reg.a     '  /* LDA $ss,x ZP,x */
CASE &HB6: mr.zy reg.x: Cmdr m.fl, reg.x     '  /* LDX $ss,y ZP,y */
CASE &HD5: MR.Zx I: M.CMP reg.a, I     '  /* CMP $ss,x ZP,x */
CASE &HD6: mm.zx M.DEC                '  /* DEC $ss,x ZP,x */
CASE &HF5: MR.Zx I: Cmdr M.SBC, I          '  /* SBC $ss,x ZP,x */
CASE &HF6: mm.zx m.inc                '  /* INC $ss,x ZP,x */
CASE &H19: MR.Ay I: Cmdr m.ora, I            '  /* ORA $ssss,y ABS,y */
CASE &H1D: MR.Ax I: Cmdr m.ora, I            '  /* ORA $ssss,x ABS,x */
CASE &H1E: mm.ax m.asl                '  /* ASL $ssss,x ABS,x */
CASE &H39: MR.Ay I: Cmdr m.and, I            '  /* AND $ssss,y ABS,y */
CASE &H3D: MR.Ax I: Cmdr m.and, I            '  /* AND $ssss,x ABS,x */
CASE &H3E: mm.ax M.ROL                '  /* ROL $ssss,x ABS,x */
CASE &H59: MR.Ay I: Cmdr m.eor, I            '  /* EOR $ssss,y ABS,y */
CASE &H5D: MR.Ax I: Cmdr m.eor, I            '  /* EOR $ssss,x ABS,x */
CASE &H5E: mm.ax M.LSR                '  /* LSR $ssss,x ABS,x */
CASE &H79: MR.Ay I: Cmdr m.adc, I            '  /* ADC $ssss,y ABS,y */
CASE &H7D: MR.Ax I: Cmdr m.adc, I            '  /* ADC $ssss,x ABS,x */
CASE &H7E: mm.ax M.ROR                '  /* ROR $ssss,x ABS,x */
CASE &H99: mw.ay reg.a                 '  /* STA $ssss,y ABS,y */
CASE &H9D: MW.Ax reg.a                 '  /* STA $ssss,x ABS,x */
CASE &HB9: MR.Ay reg.a: Cmdr m.fl, reg.a     '  /* LDA $ssss,y ABS,y */
CASE &HBC: MR.Ax reg.y: Cmdr m.fl, reg.y     '  /* LDY $ssss,x ABS,x */
CASE &HBD: MR.Ax reg.a: Cmdr m.fl, reg.a     '  /* LDA $ssss,x ABS,x */
CASE &HBE: MR.Ay reg.x: Cmdr m.fl, reg.x     '  /* LDX $ssss,y ABS,y */
CASE &HD9: MR.Ay I: M.CMP reg.a, I     '  /* CMP $ssss,y ABS,y */
CASE &HDD: MR.Ax I: M.CMP reg.a, I     '  /* CMP $ssss,x ABS,x */
CASE &HDE: mm.ax M.DEC                '  /* DEC $ssss,x ABS,x */
CASE &HF9: MR.Ay I: Cmdr M.SBC, I            '  /* SBC $ssss,y ABS,y */
CASE &HFD: MR.Ax I: Cmdr M.SBC, I            '  /* SBC $ssss,x ABS,x */
CASE &HFE: mm.ax m.inc                '  /* INC $ssss,x ABS,x */
CASE &H1: MR.Ix I: Cmdr m.ora, I             '  /* ORA ($ss,x) INDEXINDIR */
CASE &H11: MR.Iy I: Cmdr m.ora, I            '  /* ORA ($ss),y INDIRINDEX */
CASE &H21: MR.Ix I: Cmdr m.and, I            '  /* AND ($ss,x) INDEXINDIR */
CASE &H31: MR.Iy I: Cmdr m.and, I            '  /* AND ($ss),y INDIRINDEX */
CASE &H41: MR.Ix I: Cmdr m.eor, I            '  /* EOR ($ss,x) INDEXINDIR */
CASE &H51: MR.Iy I: Cmdr m.eor, I            '  /* EOR ($ss),y INDIRINDEX */
CASE &H61: MR.Ix I: Cmdr m.adc, I            '  /* ADC ($ss,x) INDEXINDIR */
CASE &H71: MR.Iy I: Cmdr m.adc, I            '  /* ADC ($ss),y INDIRINDEX */
CASE &H81: mw.ix reg.a                 '  /* STA ($ss,x) INDEXINDIR */
CASE &H91: mw.iy reg.a                 '  /* STA ($ss),y INDIRINDEX */
CASE &HA1: MR.Ix reg.a: Cmdr m.fl, reg.a     '  /* LDA ($ss,x) INDEXINDIR */
CASE &HB1: MR.Iy reg.a: Cmdr m.fl, reg.a     '  /* LDA ($ss),y INDIRINDEX */
CASE &HC1: MR.Ix I: M.CMP reg.a, I     '  /* CMP ($ss,x) INDEXINDIR */
CASE &HD1: MR.Iy I: M.CMP reg.a, I     '  /* CMP ($ss),y INDIRINDEX */
CASE &HE1: MR.Ix I: Cmdr M.SBC, I            '  /* SBC ($ss,x) INDEXINDIR */
CASE &HF1: MR.Iy I: Cmdr M.SBC, I            '  /* SBC ($ss),y INDIRINDEX */
CASE &HA: Cmdr m.asl, reg.a                 '  /* ASL a ACC */
CASE &H2A: Cmdr M.ROL, reg.a                '  /* ROL a ACC */
CASE &H4A: Cmdr M.LSR, reg.a                '  /* LSR a ACC */
CASE &H6A: Cmdr M.ROR, reg.a                '  /* ROR a ACC */

CASE ELSE
PRINT
PRINT "ERROR:"; HEX$(WORD(reg.pc) - 1), HEX$(I): END
'default:
'  if(_TrapBadOps) {
'    fprintf
'    ( stderr,
'      "[M6502 %lX] Unrecognized instruction: $%02X at PC=$%04X\n",
'      (unsigned)_User,Op6502(REG.PC.W-1),(word)(REG.PC.W-1)
'    );
'
'    _Trace=1;
'
'  }
'
'  break;
END SELECT



END SUB

SUB IO.write (a%, b%)
END SUB

SUB M.CMP (rg1, rg2)
  words k, rg1 - rg2
  reg.P = reg.P AND NOT (C.FLAG)
  IF k.h THEN TMP = 0 ELSE TMP = C.FLAG
  reg.P = reg.P OR TMP
  'ZF = NF = K.L
  reg.ZF = k.l
  reg.NF = k.l
END SUB

SUB M.JR ()
END SUB

SUB M.LDWORD (rg AS pcc)
rg.l = op6502(WORD(reg.pc))
rg.h = op6502(WORD(reg.pc) + 1)
words reg.pc, WORD(reg.pc) + 2
END SUB

SUB M.POP.P (rg)
'NF=VF=RG
Cmdr m.pop, rg
reg.NF = rg
reg.VF = rg
IF rg AND Z.FLAG THEN TMP = 0 ELSE TMP = 1
reg.ZF = rg AND TMP
END SUB

SUB M.PUSH.P (rg)
IF reg.ZF THEN TMP = 0 ELSE TMP = Z.FLAG
Cmdr m.push, ((rg) AND NOT (N.FLAG OR V.FLAG OR Z.FLAG)) OR (reg.NF AND N.FLAG) OR (reg.VF AND V.FLAG) OR TMP
END SUB

SUB MC.Ab (rg AS pcc)
M.LDWORD rg

END SUB

SUB MC.Ax (rg AS pcc)
M.LDWORD rg
words rg, WORD(rg) + reg.x
END SUB

SUB MC.Ay (rg AS pcc)
M.LDWORD rg
words rg, WORD(rg) + reg.y
END SUB

SUB MC.ID (rg AS pcc)
words k, MCZp()
rg.l = RdRAM(WORD(k))
rg.h = RdRAM(WORD(k) + 1)
END SUB

SUB MC.Ix (rg AS pcc)
words k, MCZx()
rg.l = RdRAM(WORD(k))
rg.h = RdRAM(WORD(k) + 1)
END SUB

SUB MC.Iy (rg AS pcc)
words k, MCZp()
rg.l = RdRAM(WORD(k)): rg.h = RdRAM(WORD(k) + 1)
words rg, WORD(rg) + reg.y
END SUB

SUB mc.zp (rg AS pcc)
rg.l = op6502(WORD(reg.pc))
words reg.pc, WORD(reg.pc) + 1
rg.h = zp \ 2 ^ 8

END SUB

DEFSNG A-Z
SUB mc.zx (rg AS pcc)
rg.l = op6502(WORD(reg.pc)) + reg.x
words reg.pc, WORD(reg.pc) + 1
rg.h = zp \ 2 ^ 8

END SUB

SUB mc.zy (rg AS pcc)
rg.l = op6502(WORD(reg.pc)) + reg.y
words reg.pc, WORD(reg.pc) + 1
rg.h = zp \ 2 ^ 8

END SUB

FUNCTION MCAB% ()
MCAB% = OP6502W(WORD(reg.pc))

END FUNCTION

FUNCTION MCAX% ()
MCAX% = OP6502W(WORD(reg.pc)) + reg.x
END FUNCTION

FUNCTION MCAY% ()
MCAY% = OP6502W(WORD(reg.pc)) + reg.y
END FUNCTION

FUNCTION MCIX% ()
MCIX% = RDRAMW(MCZx)

END FUNCTION

FUNCTION MCIY% ()
MCIY% = RDRAMW(MCZp) + reg.y
END FUNCTION

DEFINT A-Z
FUNCTION MCZp ()
MCZp = op6502(WORD(reg.pc)) + zp
words reg.pc, WORD(reg.pc) + 1

END FUNCTION

FUNCTION MCZx ()
MCZx = (byte) * op6502(WORD(reg.pc)) + reg.x + zp
words reg.pc, WORD(reg.pc) + 1

END FUNCTION

FUNCTION MCZY ()
MCZY = (byte) * op6502(WORD(reg.pc)) + reg.y + zp
words reg.pc, WORD(reg.pc) + 1
END FUNCTION

SUB MM.Ab (cmd)
MC.Ab J
I = rd6502(WORD(J))

Cmdr cmd, I

Wr6502 WORD(J), I

END SUB

SUB mm.ax (cmd)
MC.Ax J
I = rd6502(WORD(J))

Cmdr cmd, I

Wr6502 WORD(J), I

END SUB

SUB MM.Zp (cmd)
words J, MCZp()
I = RdRAM(WORD(J))

Cmdr cmd, I

wrRAM WORD(J), I
END SUB

SUB mm.zx (cmd)
words J, MCZx()
I = RdRAM(WORD(J))

Cmdr cmd, I

wrRAM WORD(J), I
END SUB

SUB MR.Ab (rg)
MC.Ab J
rg = rd6502(WORD(J))

END SUB

SUB MR.Ax (rg)
MC.Ax J
rg = rd6502(WORD(J))
END SUB

SUB MR.Ay (rg)
MC.Ay J
rg = rd6502(WORD(J))
END SUB

SUB MR.ID (rg)
MC.ID J
rg = rd6502(WORD(J))

END SUB

SUB MR.Im (rg)
rg = op6502(WORD(reg.pc))
words reg.pc, WORD(reg.pc) + 1
END SUB

SUB MR.Ix (rg)
MC.Ix J
rg = rd6502(WORD(J))
END SUB

SUB MR.Iy (rg)
MC.Iy J
rg = rd6502(WORD(J))
END SUB

SUB MR.Zp (rg)
rg = RdRAM(MCZp())

END SUB

SUB MR.Zx (rg)
rg = RdRAM(MCZx())
END SUB

SUB mr.zy (rg)
rg = RdRAM(MCZY())
END SUB

SUB MW.Ab (rg)
MC.Ab J
Wr6502 WORD(J), rg
END SUB

SUB MW.Ax (rg)
MC.Ax J
Wr6502 WORD(J), rg
END SUB

SUB mw.ay (rg)
MC.Ay J
Wr6502 WORD(J), rg
END SUB

SUB mw.ix (rg)
MC.Ix J
Wr6502 WORD(J), rg
END SUB

SUB mw.iy (rg)
MC.Iy J
Wr6502 WORD(J), rg
END SUB

SUB MW.Zp (rg)
wrRAM MCZp(), rg
END SUB

SUB MW.Zx (rg)
wrRAM MCZx(), rg
END SUB

SUB mw.zy (rg)
wrRAM MCZY(), rg
END SUB

FUNCTION nop6502 (rg AS pcc)
a& = WORD(rg)
HDR& = 1'512
SEEK #1, a& + HDR&
b$ = INPUT$(1, 1)
nop6502 = ASC(b$)
a& = a& + 1
words rg, a&


END FUNCTION

FUNCTION op6502 (a&)
IF a& < 0 THEN a& = 65536 + a&
HDR& = 1'512
SEEK #1, a& + HDR&
b$ = INPUT$(1, 1)
op6502 = ASC(b$)

END FUNCTION

FUNCTION OP6502W (a&)
'error h,l order?

a1% = op6502(a&)
a2% = op6502(a& + 1)
OP6502W = CVI(CHR$(a1%) + CHR$(a2%))

END FUNCTION

FUNCTION rd6502 (a&)

SEEK #2, a& + 10001
b$ = INPUT$(1, 2)

rd6502 = ASC(b$)



END FUNCTION

FUNCTION RdRAM% (a%)

SEEK #2, a% + 1
b$ = INPUT$(1, 2)
'RdRAM% = pram(a%)
RdRAM% = ASC(b$)


END FUNCTION

FUNCTION RDRAMW (a%)
'error h,l order?
SEEK #2, a% + 1
GET #2, , a%
'RdRAM% = pram(a%)
RDRAMW% = a%

END FUNCTION

SUB RESET6502 ()
  reg.mpr(7) = &H0: BANK.SET 7, &H0

   reg.mpr(6) = &H5: BANK.SET 6, &H5

   reg.mpr(5) = &H4: BANK.SET 5, &H4

   reg.mpr(4) = &H3: BANK.SET 4, &H3

   reg.mpr(3) = &H2: BANK.SET 3, &H2

   reg.mpr(2) = &H1: BANK.SET 2, &H1

   reg.mpr(1) = &HF8: BANK.SET 1, &HF8

   reg.mpr(0) = &HFF: BANK.SET 0, &HFF
  reg.a = 0: reg.x = 0: reg.y = 0
  reg.P = I.FLAG

  reg.NF = 0: reg.VF = 0

  reg.ZF = &HFF
  reg.s = &HFF

  reg.pc.l = op6502(VEC.RESET)
  reg.pc.h = op6502(VEC.RESET + 1)
  reg.ICount = reg.IPeriod
  reg.IRequest = INT.NONE
  reg.AfterCLI = 0
  '//_CycleCount=0;
  '(int)(R->User)=0;
  reg.USER = 0
END SUB

SUB RUN6502 ()
RESET6502
words reg.pc, 0
x = 1
DO
y = y + 1
IF y = 24 THEN y = 1: x = x + 8'+3
I = op6502(WORD(reg.pc))
LOCATE y, x
'PRINT x, y
PRINT HEX$(WORD(reg.pc)); ":"; opcode$(I); 'i;


words reg.pc, WORD(reg.pc) + 1
CYCLE = CYCLES(I)
CODES I
LOOP
END SUB

SUB T_INIT ()

END SUB

FUNCTION WORD& (rg AS pcc)
'A% = CVI(CHR$(RG.L) + CHR$(RG.H))
'WORD& = CVL(MKI$(A%) + MKI$(0))
WORD& = CVL(CHR$(rg.l) + CHR$(rg.h) + MKI$(0))



END FUNCTION

SUB words (rg AS pcc, a&)
'A% = CVI(MKL$(A&))
'RG.L = ASC(MKI$(A%))
'RG.H = ASC(MID$(MKI$(A%), 2))

rg.l = ASC(MKL$(a&))
rg.h = ASC(MID$(MKL$(a&), 2))


END SUB

SUB Wr6502 (a&, b%)
SEEK #2, a& + 10001
b$ = CHR$(b%)
PUT #2, , b$


END SUB

SUB wrRAM (a%, b%)
'pram(a%) = b%

b$ = CHR$(b%)
PUT #2, a% + 1, b$

END SUB

