DECLARE FUNCTION notb% (a%)
DECLARE SUB cmdc (cmd%, rg AS ANY)
DECLARE SUB T_INIT (src&, dist&, length&)
DECLARE FUNCTION rdvmmb% (a&)
DECLARE SUB loadpce (f%)
DECLARE FUNCTION allocvmm& (size&)
DECLARE SUB wrvmm (adr&, d$)
DECLARE FUNCTION io_read% (a&)
DECLARE SUB reginc (rg AS ANY)
DECLARE SUB instr.init ()
DECLARE FUNCTION opcode$ (I AS INTEGER)
DECLARE FUNCTION op6502i% (rg AS ANY)
DECLARE SUB BANK.SET (a%, b%)
DECLARE SUB CODES (I%)
DECLARE SUB io_write (a%, b%)
DECLARE SUB M.LDWORD (rg AS ANY)
DECLARE FUNCTION MCAB% ()
DECLARE FUNCTION MCAX% ()
DECLARE FUNCTION MCAY% ()
DECLARE FUNCTION MCIX% ()
DECLARE FUNCTION MCIY% ()
DECLARE FUNCTION MCZp% ()
DECLARE FUNCTION MCZx% ()
DECLARE FUNCTION MCZY% ()
DECLARE FUNCTION nop6502% (rg AS ANY)
DECLARE FUNCTION op6502% (a&)
DECLARE FUNCTION OP6502W% (a&)
DECLARE FUNCTION rd6502% (a&)
DECLARE FUNCTION RdRAM% (a%)
DECLARE FUNCTION RDRAMW% (a%)
DECLARE SUB RESET6502 ()
DECLARE SUB RUN6502 ()
DECLARE FUNCTION word& (rg AS ANY)
DECLARE SUB words (rg AS ANY, a&)
DECLARE SUB Wr6502 (a&, b%)
DECLARE SUB wrRAM (a%, b%)
DECLARE SUB cmdr (cmd%, rg%)
DECLARE SUB M.CMP (rg1%, rg2%)
DECLARE SUB M.JR ()
DEFINT A-Z

'TYPE bb  'change this around for lsb fists, last
'L AS INTEGER
'H AS INTEGER
'END TYPE


'TYPE PCC
' W AS INTEGER
' B AS bb
'END TYPE

TYPE pcc
 l AS INTEGER
 H AS INTEGER
END TYPE

TYPE regg
 p AS INTEGER        'on byte register
 a AS INTEGER
 x AS INTEGER
 y AS INTEGER
 s AS INTEGER
 pc AS pcc
 nf AS INTEGER 'one byte flag (last set)
 vf AS INTEGER
 zf AS INTEGER
 mpr(7) AS INTEGER
 IRequest AS INTEGER
 ICount AS INTEGER
 IBackup AS INTEGER
 AfterCLI AS INTEGER
 IPeriod AS INTEGER
 USER AS INTEGER
END TYPE

TYPE ioo
 VDC(32) AS pcc              'pair
 VCE(&H200) AS pcc
 vce_reg AS pcc
 'vdc
 vdc_inc AS LONG             'word
 vdc_raster_count AS LONG
 vdc_reg AS INTEGER          'byte
 vdc_status AS INTEGER
 vdc_ratch AS INTEGER
 vce_ratch AS INTEGER
 vdc_satb AS INTEGER
 vdc_pendvsync AS INTEGER
 bg_h AS INTEGER             'integer
 bg_w AS INTEGER
 scroll_y AS INTEGER
 minline AS INTEGER
 maxline AS INTEGER
 'joypad
 JOY(16) AS INTEGER          'byte
 joy_select AS INTEGER
 joy_counter AS INTEGER
 'psg
  psg(6, 8) AS INTEGER
  wave(6, 32) AS INTEGER
  wavofs(6) AS INTEGER

  '// PSG STRUCTURE
  '// 0 : dda_out
  '// 2 : freq (lo byte)  In reality it's a divisor
  '// 3 : freq (hi byte)
  '// 4 : dda_ctrl
  '//     000XXXXX
  '//     ^^  ^
  '//     ||  ch. vol
  '//     ||
  '//     |direct access (everything at byte 0)
  '//     |
  '//    enable
  '// 5 : pan (left vol = hi nibble, right vol = low nibble)
  '// 7 : noise_ctrl
  psg_ch AS INTEGER         'byte
  psg_volume AS INTEGER
  psg_lfo_freq AS INTEGER
  psg_lfo_ctrl AS INTEGER
  '/* TIMER */
  timer_reload AS INTEGER  'byte
  timer_start AS INTEGER
  timer_counter AS INTEGER
  '/* IRQ */
    irq_mask AS INTEGER    'byte
    irq_status AS INTEGER
  '/* CDROM extention */
   backup AS INTEGER          'integer
   adpcm_firstread AS INTEGER 'integwer
   adpcm AS pcc               'pair
   adpcm_rptr AS LONG         'word
   adpcm_wptr AS LONG
 END TYPE





'byte = unsigned char (1)
'word = unsigned short (2)
'offset = signed char

'UNION pair
' word w
' int b {byte l,h}
'end type
' n
' n.w
' n.b (n.b.l,n.b.h)


                       '       /* 6502 status flags:         */
CONST C.FLAG = &H1     '       /* 1: Carry occured           */
CONST Z.FLAG = &H2     '       /* 1: Result is zero          */
CONST I.FLAG = &H4     '       /* 1: Interrupts disabled     */
CONST d.flag = &H8     '       /* 1: Decimal mode            */
CONST b.flag = &H10    '       /* Break [0 on stk after int] */
CONST r.flag = &H20    '       /* Always 1                   */
CONST V.FLAG = &H40    '       /* 1: Overflow occured        */
CONST N.FLAG = &H80    '       /* 1: Result is negative      */

'                      '       /* Loop6502() returns:        */
CONST INT.NONE = 0     '       /* No interrupt required      */
CONST INT.IRQ = 1      '       /* Standard IRQ interrupt     */
CONST INT.NMI = 2      '       /* Non-maskable interrupt     */
CONST INT.QUIT = 3     '       /* Exit the emulation         */

CONST INT.TIMER = 4
CONST INT.IRQ2 = 8
CONST VEC.RESET = &HFFFE
CONST VER.NMI = &HFFFC
CONST VEC.TIMER = &HFFFA
CONST VEC.IRQ = &HFFF8
CONST VER.IRQ2 = &HFFF6
CONST VEC.BRK = &HFFFE
CONST zp = 0
CONST sp = 0





DIM SHARED reg AS regg, k AS pcc, J AS pcc, CYCLES%(255), zntable%(255), I, laststr
DIM SHARED cycle&, page&(7), rommap&(255), ram&, popram&, rom&, ioarea&, io AS ioo

OPEN "BONK3.PCE" FOR BINARY ACCESS READ AS #1

OPEN "pram.ram" FOR OUTPUT AS #2
CLOSE #2
OPEN "pram.ram" FOR BINARY ACCESS READ WRITE AS #2
CONST vmmfile = 2
popram& = allocvmm&(&H10000) 'byte
ram& = allocvmm&(32768)      'byte
vram& = allocvmm&(&H10000)   'byte
ioarea& = allocvmm&(&H2000)  'byte

loadpce 1




RESTORE cycledata
FOR Ii = 0 TO 255: READ CYCLES%(Ii): NEXT Ii
RESTORE zntabledata
FOR Ii = 0 TO 255: READ zntable%(Ii): NEXT Ii
CLS
RUN6502
END



cycledata:
'static byte Cycles[256] =
DATA     8,7,3, 4,6,4,6,7,3,2,2,0,7,5,7,6
DATA     2,7,7, 4,6,4,6,7,2,5,2,0,7,5,7,6
DATA     7,7,3, 4,4,4,6,7,3,2,2,0,5,5,7,6
DATA     2,7,7, 0,4,4,6,7,2,5,2,0,5,5,7,6
DATA     7,7,3, 4,8,4,6,7,3,2,2,0,4,5,7,6
DATA     2,7,7, 5,0,4,6,7,2,5,3,0,0,5,7,6
DATA     7,7,2, 0,4,4,6,7,3,2,2,0,7,5,7,6
DATA     2,7,7,17,4,4,6,7,2,5,3,0,7,5,7,6
DATA     4,7,2, 7,4,4,4,7,2,2,2,0,5,5,5,6
DATA     2,7,7, 8,4,4,4,7,2,5,2,0,5,5,5,6
DATA     2,7,2, 7,4,4,4,7,2,2,2,0,5,5,5,6
DATA     2,7,7, 8,4,4,4,7,2,5,2,0,5,5,5,6
DATA     2,7,2,17,4,4,6,7,2,2,2,0,5,5,7,6
DATA     2,7,7,17,0,4,6,7,2,5,3,0,0,5,7,6
DATA     2,7,0,17,4,4,6,7,2,2,2,0,5,5,7,6
DATA     2,7,7,17,2,4,6,7,2,5,3,0,0,5,7,0









'DATA  7,6,2,8,3,3,5,5,3,2,2,2,4,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  6,6,2,8,3,3,5,5,4,2,2,2,4,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  6,6,2,8,3,3,5,5,3,2,2,2,3,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  6,6,2,8,3,3,5,5,4,2,2,2,5,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  2,6,2,6,3,3,3,3,2,2,2,2,4,4,4,4
'DATA  2,6,2,6,4,4,4,4,2,5,2,5,5,5,5,5
'DATA  2,6,2,6,3,3,3,3,2,2,2,2,4,4,4,4
'DATA  2,5,2,5,4,4,4,4,2,4,2,5,4,4,4,4
'DATA  2,6,2,8,3,3,5,5,2,2,2,2,4,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  2,6,2,8,3,3,5,5,2,2,2,2,4,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'


zntabledata:

DATA  2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128



 
CONST MNUL = 0, minc = 1, MDEC = 2, MROR = 3, MROL = 4, MLSR = 5, masl = 6, MTRB = 7, MTSB = 8
CONST M.NUL = 0, m.inc = 1, M.DEC = 2, M.ROR = 3, M.ROL = 4, M.LSR = 5, m.asl = 6, TRB = 7, TSB = 8
CONST m.adc = 9, m.and = 10, m.andx = 11, m.bit = 12, m.eor = 13, m.eorx = 14
CONST m.fl = 15, m.ora = 16, m.orax = 17, m.pop = 18, m.push = 19, m.rmb = 20
CONST mm.zx = 21, MM.Zp = 22, mm.ax = 23, MM.Ab = 24
CONST mr.ab = 25, mr.ax = 26, mr.ay = 27, mr.id = 28, mr.im = 29, mr.ix = 30, mr.iy = 31, mr.zp = 32, mr.zx = 33, mr.zy = 34
CONST mw.ab = 35, mw.ax = 36, mw.ay = 37, mw.ix = 38, mw.iy = 39, mw.zp = 40, mw.zx = 41, mw.zy = 42
CONST m.sbc = 43
CONST m.smb = 44
CONST m.adcx = 45
CONST mc.ab = 46, mc.ax = 47, mc.ay = 48, mc.id = 49, mc.ix = 50, mc.iy = 51, mc.zp = 52, mc.zx = 53, mc.zy = 54
CONST m.pop.p = 55, m.push.p = 56

FUNCTION allocvmm& (size&)
s& = size&
'const vmmfile = f#
fs& = LOF(vmmfile)
SEEK #vmmfile, fs& + 1
DO

IF s& > 32766 THEN l% = 32767 ELSE l% = s&
d$ = STRING$(l%, 0)
PUT #vmmfile, , d$
d$ = ""
s& = s& - l%
LOOP UNTIL s& = 0
allocvmm& = fs& + 1

END FUNCTION

SUB BANK.SET (p, V)


IF rommap&(V) = ioarea& THEN
page&(p) = ioarea&
ELSE
'PRINT rommap&(v), v, p
page&(p) = rommap&(V) - p * 8192&
'PRINT page&(p)

END IF
END SUB

SUB cmdc (cmd, rg AS pcc)
SELECT CASE cmd
CASE 0: PRINT "error cmdc": END

CASE mc.ab
   M.LDWORD rg
CASE mc.ax
  M.LDWORD rg
  words rg, word(rg) + reg.x

CASE mc.ay
  M.LDWORD rg
  words rg, word(rg) + reg.y

CASE mc.id
  words k, MCZp()
  rg.l = RdRAM(word(k))
  rg.H = RdRAM(word(k) + 1)
CASE mc.ix
  words k, MCZx()
  rg.l = RdRAM(word(k))
  rg.H = RdRAM(word(k) + 1)
CASE mc.iy
  words k, MCZp()
  rg.l = RdRAM(word(k)): rg.H = RdRAM(word(k) + 1)
  words rg, word(rg) + reg.y
CASE mc.zp
  rg.l = nop6502(reg.pc)
  rg.H = zp \ 2 ^ 8
CASE mc.zx
  rg.l = nop6502(reg.pc) + reg.x
  rg.H = zp \ 2 ^ 8
CASE mc.zy
  rg.l = nop6502(reg.pc) + reg.y
  rg.H = zp \ 2 ^ 8
CASE ELSE
  PRINT "Invalid CmdC"; cmd: END
END SELECT


END SUB

SUB cmdr (cmd, rg)
SELECT CASE cmd
CASE M.NUL:
PRINT "error: CmdRg Null": END
CASE m.adc 'm.adc

  IF (reg.p AND d.flag) THEN

  k.l = (reg.a AND &HF) + (rg AND &HF) + (reg.p AND C.FLAG)
  k.H = (reg.a \ 2 ^ 4) + (rg \ 2 ^ 4)
    IF (k.l > 9) THEN k.l = k.l + 6: k.H = k.H + 1
    IF (k.H > 9) THEN k.H = k.H + 6
    reg.a = ((k.l AND &HF) OR (k.H * 2 ^ 4)) AND &HFF
    IF k.H > 15 THEN tmp = C.FLAG:  ELSE tmp = 0
    reg.p = (reg.p AND notb(C.FLAG)) OR tmp
    'ZF = NF = A
    reg.zf = reg.a
    reg.nf = reg.a
                cycle& = cycle& + 1

  ELSE

    words k, reg.a + rg + (reg.p AND C.FLAG)
    reg.p = reg.p AND notb(C.FLAG)
    IF k.H THEN tmp = C.FLAG:  ELSE tmp = 0
    reg.p = reg.p OR tmp
    'ZF=NF=K.L
    reg.zf = k.l
    reg.nf = k.l
    reg.a = k.l
   END IF
CASE m.adcx
 'MX = AdrRAM(reg.X + ZP)
  mx = RdRAM(reg.x + zp)
  IF (reg.p AND d.flag) THEN

    k.l = (mx AND &HF) + (rg AND &HF) + (reg.p AND C.FLAG)
    k.H = (mx \ 2 ^ 4) + (rg \ 2 ^ 4)';/*+(K.l>>4);*/ \
    IF (k.l > 9) THEN k.l = k.l + 6: k.H = k.H + 1
    IF (k.H > 9) THEN k.H = k.H + 6
    mx = ((k.l AND &HF) OR (k.H * 2 ^ 4)) AND &HFF
            cycle& = cycle& + 1

  ELSE

    words k, mx + rg + (reg.p AND C.FLAG)
                    mx = k.l

 END IF
 'AdrRAM(reg.X + ZP) = MX
  wrRAM reg.x + zp, mx

CASE m.and
  reg.a = reg.a AND rg
  cmdr m.fl, reg.a
CASE m.andx
   'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) AND RG
   wrRAM reg.x + zp, RdRAM(reg.x + zp) AND rg
   cmdr m.fl, RdRAM(reg.x + zp)

CASE m.asl
   reg.p = reg.p AND notb(C.FLAG)
   reg.p = reg.p OR rg \ 2 ^ 7
   rg = rg * 2 ^ 1
   cmdr m.fl, rg

CASE m.bit
  reg.nf = rg
  reg.vf = rg
  reg.zf = rg AND reg.a
CASE m.inc
  rg = rg + 1
  cmdr m.fl, rg

CASE M.DEC
  rg = rg - 1
  cmdr m.fl, rg


CASE M.ROR
  k.l = (rg \ 2 ^ 1) OR (reg.p * 2 ^ 7)
  reg.p = reg.p AND notb(C.FLAG)
  reg.p = reg.p OR (rg AND C.FLAG)
  'rg = k.l     'to fix possible overflow
  cmdr m.fl, k.l
  rg = k.l
CASE M.ROL
  k.l = (rg * 2 ^ 1) OR (reg.p AND C.FLAG)
  reg.p = reg.p AND notb(C.FLAG)
  reg.p = reg.p OR (rg \ 2 ^ 7)
  'rg = k.l to fix possible overflow
  cmdr m.fl, k.l
  rg = k.l
CASE M.LSR
  reg.p = reg.p AND notb(C.FLAG)
  reg.p = reg.p OR (rg AND C.FLAG)
  rg = rg \ 2 ^ 1
  cmdr m.fl, rg

CASE TRB

  'NF=VF=RG
  reg.nf = rg
  reg.vf = rg
  rg = rg AND notb(reg.a)
  reg.zf = rg

CASE TSB:
  'NF=VF=RG
  reg.nf = rg
  reg.vf = rg
  rg = rg OR reg.a
  reg.zf = rg
CASE m.eor
  reg.a = reg.a XOR rg
  cmdr m.fl, reg.a
CASE m.eorx
  'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) XOR RG
  wrRAM reg.x + zp, RdRAM(reg.x + zp) XOR rg
  cmdr m.fl, RdRAM(reg.x + zp)
CASE m.fl
  'ZF=NF=RG

  'RG = RG MOD &H100
  'IF RG < 0 THEN RG = &H100 + RG
  rg = rg AND &HFF

  reg.zf = rg
  reg.nf = rg
CASE m.ora
  reg.a = reg.a OR rg
  cmdr m.fl, reg.a
CASE m.orax
  'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) OR RG
  wrRAM reg.x + zp, RdRAM(reg.x + zp) OR rg
  cmdr m.fl, RdRAM(reg.x + zp)
CASE m.pop
  reg.s = (reg.s + 1) AND &HFF      'does this fix overflow
  rg = RdRAM(sp + reg.s)
CASE m.push
  wrRAM sp + reg.s, rg
  reg.s = (reg.s - 1) AND &HFF      'does this fix overflow
CASE m.pop.p
'NF=VF=RG
cmdr m.pop, rg
reg.nf = rg
reg.vf = rg
IF rg AND Z.FLAG THEN tmp = 0 ELSE tmp = 1
reg.zf = rg AND tmp
CASE m.push.p
IF reg.zf THEN tmp = 0 ELSE tmp = Z.FLAG
cmdr m.push, ((rg) AND notb(N.FLAG OR V.FLAG OR Z.FLAG)) OR (reg.nf AND N.FLAG) OR (reg.vf AND V.FLAG) OR tmp

CASE m.rmb
  'AdrRAM(MCZp()) = AdrRAM(MCZp()) AND NOT (N)
  wrRAM MCZp(), RdRAM(MCZp()) AND notb(rg)
CASE m.sbc
  '/* Warning! C_FLAG is inverted before SBC and after it */
    IF (reg.p AND d.flag) THEN

      k.l = ((reg.a AND &HF) - (rg AND &HF) - (notb(reg.p) AND C.FLAG)) AND &HFF
      IF (k.l AND &H10) THEN k.l = k.l - 6
      k.H = ((reg.a \ 2 ^ 4) - (rg \ 2 ^ 4) + ((k.l AND &H10) = &H10)) AND &HFF
      IF (k.H AND &H10) THEN k.H = k.H - 6
                  cycle& = cycle& + 1

    ELSE

      words k, reg.a - rg - (notb(reg.p) AND C.FLAG)
    END IF
CASE m.smb
  'AdrRAM(MCZp()) = AdrRAM(MCZp()) OR N
  wrRAM MCZp(), RdRAM(MCZp()) OR rg
CASE MM.Ab
  cmdc mc.ab, J
  I = rd6502(word(J))
  cmdr rg, I
  Wr6502 word(J), I
CASE mm.ax
  cmdc mc.ax, J
  I = rd6502(word(J))
  cmdr rg, I
  Wr6502 word(J), I
CASE MM.Zp
  words J, MCZp()
  I = RdRAM(word(J))
  cmdr rg, I
  wrRAM word(J), I
CASE mm.zx
  words J, MCZx()
  I = RdRAM(word(J))
  cmdr rg, I
  wrRAM word(J), I

CASE mr.ab
 cmdc mc.ab, J
 rg = rd6502(word(J))
CASE mr.ax
  cmdc mc.ax, J
  rg = rd6502(word(J))
CASE mr.ay
  cmdc mc.ay, J
  rg = rd6502(word(J))
CASE mr.id
  cmdc mc.id, J
  rg = rd6502(word(J))
CASE mr.im
  rg = nop6502(reg.pc)

CASE mr.ix
  cmdc mc.ix, J
  rg = rd6502(word(J))
CASE mr.iy
  cmdc mc.iy, J
  rg = rd6502(word(J))
CASE mr.zp
  rg = RdRAM(MCZp())
CASE mr.zx
  rg = RdRAM(MCZx())
CASE mr.zy
  rg = RdRAM(MCZY())
CASE mw.ab
  cmdc mc.ab, J
  Wr6502 word(J), rg
CASE mw.ax
  cmdc mc.ax, J
  Wr6502 word(J), rg
CASE mw.ay
  cmdc mc.ay, J
  Wr6502 word(J), rg
CASE mw.ix
  cmdc mc.ix, J
  Wr6502 word(J), rg
CASE mw.iy
  cmdc mc.iy, J
  Wr6502 word(J), rg
CASE mw.zp
  wrRAM MCZp(), rg
CASE mw.zx
  wrRAM MCZx(), rg
CASE mw.zy
  wrRAM MCZY(), rg



CASE ELSE
PRINT "error: CmdRg not found(" + HEX$(cmd) + ")": END
END SELECT
IF rg > 255 OR rg < 0 THEN PRINT "ERROR": END



END SUB

SUB CODES (I)
laststr = I
PRINT "PC="; HEX$(word(reg.pc) - 1); " A="; HEX$(reg.a); " X="; HEX$(reg.x); " Y="; HEX$(reg.y); " S="; HEX$(reg.s); " P="; HEX$(reg.p);
PRINT " zf="; HEX$(reg.zf); " vf="; HEX$(reg.vf); " nf="; HEX$(reg.nf); " ";
PRINT opcode$(I); " "; HEX$(I), cycle&



'LINE INPUT #3, f$
'PRINT f$

SELECT CASE I
CASE &HD4'/* CSH set clock highspeed */
CASE &H54'/* CSL set clock lowspeed */

CASE &H44: '/* BSR * REL */
           cmdr m.push, reg.pc.H
           cmdr m.push, reg.pc.l

CASE &H80: '/* BRA * REL */

          'error:convert op6502 to offset
          I = op6502i(reg.pc)
          I = I + (I > 127) * 256
          words reg.pc, word(reg.pc) + I + 1
          'words reg.pc, WORD(reg.pc) + (offset)op6502i(reg.pc) + 1


CASE &H7C: '/* JMP ($ssss,x) */
        M.LDWORD k: words k, word(k) + reg.x
        reg.pc.l = op6502i(k)
        reg.pc.H = op6502(word(k) + 1)
        
CASE &HDA: cmdr m.push, reg.x  '  /* PHX */
CASE &H5A: cmdr m.push, reg.y '               /* PHY */
CASE &HFA: cmdr m.pop, reg.x: cmdr m.fl, reg.x '    /* PLX */
CASE &H7A: cmdr m.pop, reg.y: cmdr m.fl, reg.y'      /* PLY */

CASE &H62: reg.a = 0' /* CLA */
CASE &H82: reg.x = 0' /* CLX */
CASE &HC2: reg.y = 0' /* CLY */

CASE &H2: I = reg.x: reg.x = reg.y: reg.y = I'  /* SXY */
CASE &H22: I = reg.a: reg.a = reg.x: reg.x = I'  /* SAX */
CASE &H42: I = reg.a: reg.a = reg.y: reg.y = I'  /* SAY */

CASE &H3A: cmdr M.DEC, reg.a                  ' /* DEC A */

CASE &H1A: cmdr m.inc, reg.a                  ' /* INC A */


CASE &H72: cmdr mr.id, I: cmdr m.adc, I              '/* ADC ($ss) INDIR */
CASE &H32: cmdr mr.id, I: cmdr m.and, I               '/* AND ($ss) INDIR */
CASE &HD2: cmdr mr.id, I: M.CMP reg.a, I        '/* CMP ($ss) INDIR */
CASE &H52: cmdr mr.id, I: cmdr m.eor, I               '/* EOR ($ss) INDIR */
CASE &HB2: cmdr mr.id, reg.a: cmdr m.fl, reg.a        '/* LDA ($ss) INDIR */
CASE &H12: cmdr mr.id, I: cmdr m.ora, I               '/* ORA ($ss) INDIR */
CASE &H92: cmdc mc.id, J: Wr6502 word(J), reg.a     '/* STA ($ss) INDIR */
CASE &HF2: cmdr mr.id, I: cmdr m.sbc, I             '  /* SBC ($ss) INDIR */

CASE &H89: cmdr mr.im, I: cmdr m.bit, I  '              /* BIT #$ss IMM */
CASE &H34: cmdr mr.zx, I: cmdr m.bit, I  '              /* BIT $ss,x ZP,x */
CASE &H3C: cmdr mr.ax, I: cmdr m.bit, I  '              /* BIT $ssss,x ABS,x */

CASE &H64: cmdr mw.zp, &H0            '          /* STZ $ss ZP */
CASE &H74: cmdr mw.zx, &H0            '          /* STZ $ss,x ZP,x */
CASE &H9C: cmdr mw.ab, &H0            '          /* STZ $ssss ABS */
CASE &H9E: cmdr mw.ax, &H0            '          /* STZ $ssss,x ABS,x */

CASE &HF4: ' /* SET */
        I = op6502i(reg.pc)
        cycle& = cycle& + CYCLES(I) + 3
        SELECT CASE I
        CASE &H65: cmdr mr.zp, I: cmdr m.adcx, I'       /* ADC $ss ZP */
        CASE &H6D: cmdr mr.ab, I: cmdr m.adcx, I'       /* ADC $ssss ABS */
        CASE &H69: cmdr mr.im, I: cmdr m.adcx, I'       /* ADC #$ss IMM */
        CASE &H75: cmdr mr.zx, I: cmdr m.adcx, I'       /* ADC $ss,x ZP,x */
        CASE &H79: cmdr mr.ay, I: cmdr m.adcx, I'       /* ADC $ssss,y ABS,y */
        CASE &H7D: cmdr mr.ax, I: cmdr m.adcx, I'       /* ADC $ssss,x ABS,x */
        CASE &H61: cmdr mr.ix, I: cmdr m.adcx, I'       /* ADC ($ss,x) INDEXINDIR */
        CASE &H71: cmdr mr.iy, I: cmdr m.adcx, I'       /* ADC ($ss),y INDIRINDEX */
        CASE &H72: cmdr mr.id, I: cmdr m.adcx, I'       /* ADC ($ss) INDIR */

        CASE &H25: cmdr mr.zp, I: cmdr m.andx, I'       /* AND $ss ZP */
        CASE &H2D: cmdr mr.ab, I: cmdr m.andx, I'       /* AND $ssss ABS */
        CASE &H29: cmdr mr.im, I: cmdr m.andx, I'       /* AND #$ss IMM */
        CASE &H35: cmdr mr.zx, I: cmdr m.andx, I'       /* AND $ss,x ZP,x */
        CASE &H39: cmdr mr.ay, I: cmdr m.andx, I'       /* AND $ssss,y ABS,y */
        CASE &H3D: cmdr mr.ax, I: cmdr m.andx, I'       /* AND $ssss,x ABS,x */
        CASE &H21: cmdr mr.ix, I: cmdr m.andx, I'       /* AND ($ss,x) INDEXINDIR */
        CASE &H31: cmdr mr.iy, I: cmdr m.andx, I'       /* AND ($ss),y INDIRINDEX */
        CASE &H32: cmdr mr.id, I: cmdr m.andx, I'       /* AND ($ss) INDIR */

        CASE &H45: cmdr mr.zp, I: cmdr m.eorx, I '       /* EOR $ss ZP */
        CASE &H4D: cmdr mr.ab, I: cmdr m.eorx, I '       /* EOR $ssss ABS */
        CASE &H49: cmdr mr.im, I: cmdr m.eorx, I '       /* EOR #$ss IMM */
        CASE &H55: cmdr mr.zx, I: cmdr m.eorx, I '       /* EOR $ss,x ZP,x */
        CASE &H59: cmdr mr.ay, I: cmdr m.eorx, I '       /* EOR $ssss,y ABS,y */
        CASE &H5D: cmdr mr.ax, I: cmdr m.eorx, I '       /* EOR $ssss,x ABS,x */
        CASE &H41: cmdr mr.ix, I: cmdr m.eorx, I '       /* EOR ($ss,x) INDEXINDIR */
        CASE &H51: cmdr mr.iy, I: cmdr m.eorx, I '       /* EOR ($ss),y INDIRINDEX */
        CASE &H52: cmdr mr.id, I: cmdr m.eorx, I '       /* EOR ($ss) INDIR */

        CASE &H5: cmdr mr.zp, I: cmdr m.orax, I  '       /* ORA $ss ZP */
        CASE &HD: cmdr mr.ab, I: cmdr m.orax, I  '       /* ORA $ssss ABS */
        CASE &H9: cmdr mr.im, I: cmdr m.orax, I  '       /* ORA #$ss IMM */
        CASE &H15: cmdr mr.zx, I: cmdr m.orax, I '       /* ORA $ss,x ZP,x */
        CASE &H19: cmdr mr.ay, I: cmdr m.orax, I '       /* ORA $ssss,y ABS,y */
        CASE &H1D: cmdr mr.ax, I: cmdr m.orax, I '       /* ORA $ssss,x ABS,x */
        CASE &H1: cmdr mr.ix, I: cmdr m.orax, I  '       /* ORA ($ss,x) INDEXINDIR */
        CASE &H11: cmdr mr.iy, I: cmdr m.orax, I '       /* ORA ($ss),y INDIRINDEX */
        CASE &H12: cmdr mr.id, I: cmdr m.orax, I '       /* ORA ($ss) INDIR */

        CASE ELSE
        PRINT ERR, "no sense SET"
        cycle& = cycle& - CYCLES(I)


        END SELECT

CASE &H3: io_write 0, nop6502(reg.pc)  '/* ST0 */

CASE &H13: io_write 2, nop6502(reg.pc) '/* ST1 */

CASE &H23: io_write 3, nop6502(reg.pc) '/* ST2 */

CASE &H43: '/* TMAi */
        I = nop6502(reg.pc)

          FOR Ii = 0 TO 7

              IF (I AND 1) THEN EXIT FOR

          '//reg.a = Reg.MPR[ii]
          '//reg.a = Reg.MPR[ii]
          reg.a = reg.mpr(Ii)
              I = I \ 2 ^ 1
          NEXT Ii

CASE &H53: '/* TAMi */
        I = nop6502(reg.pc)

         FOR Ii = 0 TO 7

                IF (I AND 1) THEN
                        '//R->MPR[ii]=reg.a;
                        '//R.MPR[ii]=reg.a;
                        reg.mpr(Ii) = reg.a
                        BANK.SET Ii, reg.a
                END IF
                I = I \ 2 ^ 1
         NEXT Ii

CASE &HC3: ' /* TDD */
        T_INIT src&, dist&, length&
        DO
        Wr6502 dist&, rd6502(src&)
        dist& = dist& - 1

        src& = src& - 1
        length& = length& - 1
        LOOP WHILE length&
'        } while(--length);




CASE &H73: ' /* TII */
        T_INIT src&, dist&, length&
        DO
             Wr6502 dist&, rd6502(src&)
             dist& = dist& + 1
                src& = src& + 1
        length& = length& - 1
        LOOP WHILE length&
'        } while(--length);


CASE &HE3: ' /* TIA */
        T_INIT src&, dist&, length&
        DO
                Wr6502 dist&, rd6502(src&)
                src& = src& + 1

                IF NOT length& THEN EXIT DO
                ' if (!(--length)):break
                length& = length& - 1
                Wr6502 dist& + 1, rd6502(src&)
                src& = src& + 1
'        } while(--length);
        lenght& = length& - 1
        LOOP WHILE length&


CASE &HF3: ' /* TAI */
        T_INIT src&, dist&, length&
        DO
                Wr6502 dist&, rd6502(src&)
                dist& = dist& + 1
                'if (!(--length)) break;
                length& = length& - 1
                IF NOT length& THEN EXIT DO
                Wr6502 dist&, rd6502(src& + 1)
                dist& = dist& + 1

         length& = length& - 1
         LOOP WHILE length&
'        } while(--length);

CASE &HD3: ' /* TIN */
        T_INIT src&, dist&, length&
        DO
                Wr6502 dist&, rd6502(src&)
                src& = src& + 1
        length& = length& - 1
        LOOP WHILE length&

CASE &H14: cmdr MM.Zp, TRB '      /* TRB $ss ZP */

CASE &H1C: cmdr MM.Ab, TRB '      /* TRB $ssss ABS */
CASE &H4: cmdr MM.Zp, TSB  '      /* TSB $ss ZP */

CASE &HC: cmdr MM.Ab, TSB  '      /* TSB $ssss ABS */

CASE &H83: '/* TST #$ss,$ss IMM,ZP */
        I = nop6502(reg.pc): J.l = RdRAM(MCZp())
        
'error    NF = VF = J.L
        reg.nf = J.l
        reg.vf = J.l: reg.zf = I AND J.l

CASE &HA3: '/* TST #$ss,$ss,x IMM,ZP,x */
        I = nop6502(reg.pc): J.l = RdRAM(MCZx())
        

'error REG,NF = REG.VF = J.L
        reg.nf = J.l
        reg.vf = J.l: reg.zf = I AND J.l
CASE &H93: '/* TST #$ss,$ssss IMM,ABS */
        I = nop6502(reg.pc): cmdr mr.ab, J.l
        
'error
        reg.nf = J.l
         reg.vf = J.l: reg.zf = I AND J.l

CASE &HB3: '/* TST #$ss,$ssss,x IMM,ABS,x */
        I = nop6502(reg.pc): cmdr mr.ax, J.l
        
'error
        reg.nf = J.l
        reg.vf = J.l: reg.zf = I AND J.l

CASE &HF: IF RdRAM(MCZp()) AND &H1 THEN reginc reg.pc ELSE M.JR   '      /* BBRi */
CASE &H1F: IF RdRAM(MCZp()) AND &H2 THEN reginc reg.pc ELSE M.JR
CASE &H2F: IF RdRAM(MCZp()) AND &H4 THEN reginc reg.pc ELSE M.JR
CASE &H3F: IF RdRAM(MCZp()) AND &H8 THEN reginc reg.pc ELSE M.JR
CASE &H4F: IF RdRAM(MCZp()) AND &H10 THEN reginc reg.pc ELSE M.JR
CASE &H5F: IF RdRAM(MCZp()) AND &H20 THEN reginc reg.pc ELSE M.JR
CASE &H6F: IF RdRAM(MCZp()) AND &H40 THEN reginc reg.pc ELSE M.JR
CASE &H7F: IF RdRAM(MCZp()) AND &H80 THEN reginc reg.pc ELSE M.JR

CASE &H8F: IF RdRAM(MCZp()) AND &H1 THEN M.JR ELSE reginc reg.pc '      /* BBSi */
CASE &H9F: IF RdRAM(MCZp()) AND &H2 THEN M.JR ELSE reginc reg.pc
CASE &HAF: IF RdRAM(MCZp()) AND &H4 THEN M.JR ELSE reginc reg.pc
CASE &HBF: IF RdRAM(MCZp()) AND &H8 THEN M.JR ELSE reginc reg.pc
CASE &HCF: IF RdRAM(MCZp()) AND &H10 THEN M.JR ELSE reginc reg.pc
CASE &HDF: IF RdRAM(MCZp()) AND &H20 THEN M.JR ELSE reginc reg.pc
CASE &HEF: IF RdRAM(MCZp()) AND &H40 THEN M.JR ELSE reginc reg.pc
CASE &HFF: IF RdRAM(MCZp()) AND &H80 THEN M.JR ELSE reginc reg.pc


CASE &H7: cmdr m.rmb, &H1   '        /* RMBi */
CASE &H17: cmdr m.rmb, &H2  '        /* RMBi */
CASE &H27: cmdr m.rmb, &H4  '        /* RMBi */
CASE &H37: cmdr m.rmb, &H8  '        /* RMBi */
CASE &H47: cmdr m.rmb, &H10 '        /* RMBi */
CASE &H57: cmdr m.rmb, &H20 '        /* RMBi */
CASE &H67: cmdr m.rmb, &H40 '        /* RMBi */
CASE &H77: cmdr m.rmb, &H80 '        /* RMBi */

CASE &H87: cmdr m.smb, &H1  '        /* SMBi */
CASE &H97: cmdr m.smb, &H2  '        /* SMBi */
CASE &HA7: cmdr m.smb, &H4  '        /* SMBi */
CASE &HB7: cmdr m.smb, &H8  '        /* SMBi */
CASE &HC7: cmdr m.smb, &H10 '        /* SMBi */
CASE &HD7: cmdr m.smb, &H20 '        /* SMBi */
CASE &HE7: cmdr m.smb, &H40 '        /* SMBi */
CASE &HF7: cmdr m.smb, &H80 '        /* SMBi */




CASE &H10: IF (reg.nf AND N.FLAG) THEN reginc reg.pc ELSE M.JR  '/* BPL * REL */
CASE &H30: IF (reg.nf AND N.FLAG) THEN M.JR ELSE reginc reg.pc  '/* BMI * REL */
CASE &HD0:

IF reg.zf = 0 THEN reginc reg.pc ELSE M.JR       '/* BNE * REL */
CASE &HF0: IF reg.zf = 0 THEN M.JR ELSE reginc reg.pc     '/* BEQ * REL */
CASE &H90: IF (reg.p AND C.FLAG) THEN reginc reg.pc ELSE M.JR '/* BCC * REL */
CASE &HB0: IF (reg.p AND C.FLAG) THEN M.JR ELSE reginc reg.pc '/* BCS * REL */
CASE &H50: IF (reg.vf AND V.FLAG) THEN reginc reg.pc ELSE M.JR'/* BVC * REL */
CASE &H70: IF (reg.vf AND V.FLAG) THEN M.JR ELSE reginc reg.pc '/* BVS * REL */


CASE &H40: '/* RTI */

  I = reg.p


  cmdr m.pop.p, reg.p

  IF ((reg.IRequest <> INT.NONE) AND (I AND I.FLAG) <> 0 AND NOT (reg.p AND I.FLAG) <> 0) THEN
     REGAfterCLI = 1
    reg.IBackup = reg.ICount
    reg.ICount = 0
    END IF
    cmdr m.pop, reg.pc.l
    cmdr m.pop, reg.pc.H



CASE &H60: '/* RTS */
  cmdr m.pop, reg.pc.l: cmdr m.pop, reg.pc.H: reginc reg.pc


CASE &H20: '/* JSR $ssss ABS */
  k.l = nop6502(reg.pc)
  k.H = op6502i(reg.pc)

  cmdr m.push, reg.pc.H
  cmdr m.push, reg.pc.l
  reg.pc = k

CASE &H4C: M.LDWORD k: reg.pc = k'/* JMP $ssss ABS */


CASE &H6C: '/* JMP ($ssss) ABDINDIR */
  M.LDWORD k
  reg.pc.l = nop6502(k)
  
  reg.pc.H = op6502i(k)



CASE &H0: '/* BRK */
  reginc reg.pc
  cmdr m.push, reg.pc.H: cmdr m.push, reg.pc.l
  cmdr m.push.p, reg.p AND notb(T.FLAG) OR (b.flag)
  reg.p = (reg.p OR I.FLAG) AND notb(d.flag)
  reg.pc.l = op6502(VEC.BRK)
  reg.pc.H = op6502(VEC.BRK + 1)


  PRINT ERR, "BRK instruction"
  END



CASE &H58: '/* CLI */
  IF ((reg.IRequest <> INT.NONE) AND (reg.p AND I.FLAG) <> 0) THEN
  
    reg.AfterCLI = 1
    reg.IBackup = reg.ICount
    reg.ICount = 0

  END IF
  reg.p = reg.p AND notb(I.FLAG)



CASE &H28: '/* PLP */
  cmdr m.pop.p, I

  IF ((reg.IRequest <> INT.NONE) AND ((I XOR reg.p) AND notb(I) AND I.FLAG) <> 0) THEN

    reg.AfterCLI = 1
    reg.IBackup = reg.ICount
    reg.ICount = 0

  END IF
  reg.p = I



CASE &H8: cmdr m.push.p, reg.p AND notb(T.FLAG) OR b.flag'     /* PHP */
CASE &H18: reg.p = reg.p AND notb(C.FLAG)          '     /* CLC */
CASE &HB8: reg.vf = 0                              '     /* CLV */
CASE &HD8: reg.p = reg.p AND notb(d.flag)          '     /* CLD */
CASE &H38: reg.p = reg.p OR C.FLAG                 '     /* SEC */
CASE &HF8: reg.p = reg.p OR d.flag                 '     /* SED */
CASE &H78: reg.p = reg.p OR I.FLAG                 '     /* SEI */
CASE &H48: cmdr m.push, reg.a          '             /* PHA */
CASE &H68: cmdr m.pop, reg.a: cmdr m.fl, reg.a       '     /* PLA */
CASE &H98: reg.a = reg.y: cmdr m.fl, reg.a     '     /* TYA */
CASE &HA8: reg.y = reg.a: cmdr m.fl, reg.y     '     /* TAY */
CASE &HC8: reg.y = reg.y + 1: cmdr m.fl, reg.y '     /* INY */
CASE &H88: reg.y = reg.y - 1: cmdr m.fl, reg.y '     /* DEY */
CASE &H8A: reg.a = reg.x: cmdr m.fl, reg.a     '     /* TXA */
CASE &HAA: reg.x = reg.a: cmdr m.fl, reg.x     '     /* TAX */
CASE &HE8: reg.x = reg.x + 1: cmdr m.fl, reg.x '     /* INX */
CASE &HCA: reg.x = reg.x - 1: cmdr m.fl, reg.x '     /* DEX */
CASE &HEA:  '                                  /* NOP */
CASE &H9A: reg.s = reg.x                 '     /* TXS */
CASE &HBA: reg.x = reg.s: cmdr m.fl, reg.x     '     /* TSX */
CASE &H24: cmdr mr.zp, I: cmdr m.bit, I            '  /* BIT $ss ZP */
CASE &H2C: cmdr mr.ab, I: cmdr m.bit, I            '  /* BIT $ssss ABS */

CASE &H5: cmdr mr.zp, I: cmdr m.ora, I             '  /* ORA $ss ZP */
CASE &H6: cmdr MM.Zp, m.asl                 '  /* ASL $ss ZP */
CASE &H25: cmdr mr.zp, I: cmdr m.and, I            '  /* AND $ss ZP */
CASE &H26: cmdr MM.Zp, M.ROL                '  /* ROL $ss ZP */
CASE &H45: cmdr mr.zp, I: cmdr m.eor, I            '  /* EOR $ss ZP */
CASE &H46: cmdr MM.Zp, M.LSR                '  /* LSR $ss ZP */
CASE &H65: cmdr mr.zp, I: cmdr m.adc, I          '  /* ADC $ss ZP */
CASE &H66: cmdr MM.Zp, M.ROR                '  /* ROR $ss ZP */
CASE &H84: cmdr mw.zp, reg.y                 '  /* STY $ss ZP */
CASE &H85: cmdr mw.zp, reg.a                 '  /* STA $ss ZP */
CASE &H86: cmdr mw.zp, reg.x                 '  /* STX $ss ZP */
CASE &HA4: cmdr mr.zp, reg.y: cmdr m.fl, reg.y     '  /* LDY $ss ZP */
CASE &HA5: cmdr mr.zp, reg.a: cmdr m.fl, reg.a    '  /* LDA $ss ZP */
'/BaH
'/case &HA5: R.A = RAM[ (Op6502(R.PC.W++)) ]  ;break;
'/CAUTION ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
CASE &HA6: cmdr mr.zp, reg.x: cmdr m.fl, reg.x     '  /* LDX $ss ZP */
CASE &HC4: cmdr mr.zp, I: M.CMP reg.y, I     '  /* CPY $ss ZP */
CASE &HC5: cmdr mr.zp, I: M.CMP reg.a, I     '  /* CMP $ss ZP */
CASE &HC6: cmdr MM.Zp, M.DEC                '  /* DEC $ss ZP */
CASE &HE4: cmdr mr.zp, I: M.CMP reg.x, I     '  /* CPX $ss ZP */
CASE &HE5: cmdr mr.zp, I: cmdr m.sbc, I            '  /* SBC $ss ZP */
CASE &HE6: cmdr MM.Zp, m.inc                '  /* INC $ss ZP */
CASE &HD: cmdr mr.ab, I: cmdr m.ora, I             '  /* ORA $ssss ABS */
CASE &HE: cmdr MM.Ab, m.asl                 '  /* ASL $ssss ABS */
CASE &H2D: cmdr mr.ab, I: cmdr m.and, I            '  /* AND $ssss ABS */
CASE &H2E: cmdr MM.Ab, M.ROL                '  /* ROL $ssss ABS */

CASE &H4D: cmdr mr.ab, I: cmdr m.eor, I            '  /* EOR $ssss ABS */
CASE &H4E: cmdr MM.Ab, M.LSR                '  /* LSR $ssss ABS */

CASE &H6D: cmdr mr.ab, I: cmdr m.adc, I            '  /* ADC $ssss ABS */
CASE &H6E: cmdr MM.Ab, M.ROR                '  /* ROR $ssss ABS */

CASE &H8C: cmdr mw.ab, reg.y                 '  /* STY $ssss ABS */
CASE &H8D: cmdr mw.ab, reg.a                 '  /* STA $ssss ABS */
CASE &H8E: cmdr mw.ab, reg.x                 '  /* STX $ssss ABS */
CASE &HAC: cmdr mr.ab, reg.y: cmdr m.fl, reg.y     '  /* LDY $ssss ABS */
CASE &HAD: cmdr mr.ab, reg.a: cmdr m.fl, reg.a     '  /* LDA $ssss ABS */
CASE &HAE: cmdr mr.ab, reg.x: cmdr m.fl, reg.x     '  /* LDX $ssss ABS */
CASE &HCC: cmdr mr.ab, I: M.CMP reg.y, I     '  /* CPY $ssss ABS */
CASE &HCD: cmdr mr.ab, I: M.CMP reg.a, I     '  /* CMP $ssss ABS */
CASE &HCE: cmdr MM.Ab, M.DEC                '  /* DEC $ssss ABS */

CASE &HEC: cmdr mr.ab, I: M.CMP reg.x, I     '  /* CPX $ssss ABS */
CASE &HED: cmdr mr.ab, I: cmdr m.sbc, I            '  /* SBC $ssss ABS */
CASE &HEE: cmdr MM.Ab, m.inc                '  /* INC $ssss ABS */

CASE &H9: cmdr mr.im, I: cmdr m.ora, I             '  /* ORA #$ss IMM */
CASE &H29: cmdr mr.im, I: cmdr m.and, I            '  /* AND #$ss IMM */
CASE &H49: cmdr mr.im, I: cmdr m.eor, I            '  /* EOR #$ss IMM */
CASE &H69: cmdr mr.im, I: cmdr m.adc, I            '  /* ADC #$ss IMM */
CASE &HA0: cmdr mr.im, reg.y: cmdr m.fl, reg.y     '  /* LDY #$ss IMM */
CASE &HA2: cmdr mr.im, reg.x: cmdr m.fl, reg.x     '  /* LDX #$ss IMM */
CASE &HA9: cmdr mr.im, reg.a: cmdr m.fl, reg.a     '  /* LDA #$ss IMM */
CASE &HC0: cmdr mr.im, I: M.CMP reg.y, I     '  /* CPY #$ss IMM */
CASE &HC9: cmdr mr.im, I: M.CMP reg.a, I     '  /* CMP #$ss IMM */
CASE &HE0: cmdr mr.im, I: M.CMP reg.x, I     '  /* CPX #$ss IMM */
CASE &HE9: cmdr mr.im, I: cmdr m.sbc, I            '  /* SBC #$ss IMM */

CASE &H15: cmdr mr.zx, I: cmdr m.ora, I            '  /* ORA $ss,x ZP,x */
CASE &H16: cmdr mm.zx, m.asl                '  /* ASL $ss,x ZP,x */
CASE &H35: cmdr mr.zx, I: cmdr m.and, I            '  /* AND $ss,x ZP,x */
CASE &H36: cmdr mm.zx, M.ROL                '  /* ROL $ss,x ZP,x */
CASE &H55: cmdr mr.zx, I: cmdr m.eor, I          '  /* EOR $ss,x ZP,x */
CASE &H56: cmdr mm.zx, M.LSR                '  /* LSR $ss,x ZP,x */
CASE &H75: cmdr mr.zx, I: cmdr m.adc, I            '  /* ADC $ss,x ZP,x */
CASE &H76: cmdr mm.zx, M.ROR                '  /* ROR $ss,x ZP,x */
CASE &H94: cmdr mw.zx, reg.y                 '  /* STY $ss,x ZP,x */
CASE &H95: cmdr mw.zx, reg.a                 '  /* STA $ss,x ZP,x */
CASE &H96: cmdr mw.zy, reg.x                 '  /* STX $ss,y ZP,y */
CASE &HB4: cmdr mr.zx, reg.y: cmdr m.fl, reg.y     '  /* LDY $ss,x ZP,x */
CASE &HB5: cmdr mr.zx, reg.a: cmdr m.fl, reg.a     '  /* LDA $ss,x ZP,x */
CASE &HB6: cmdr mr.zy, reg.x: cmdr m.fl, reg.x     '  /* LDX $ss,y ZP,y */
CASE &HD5: cmdr mr.zx, I: M.CMP reg.a, I     '  /* CMP $ss,x ZP,x */
CASE &HD6: cmdr mm.zx, M.DEC                '  /* DEC $ss,x ZP,x */
CASE &HF5: cmdr mr.zx, I: cmdr m.sbc, I          '  /* SBC $ss,x ZP,x */
CASE &HF6: cmdr mm.zx, m.inc                '  /* INC $ss,x ZP,x */
CASE &H19: cmdr mr.ay, I: cmdr m.ora, I            '  /* ORA $ssss,y ABS,y */
CASE &H1D: cmdr mr.ax, I: cmdr m.ora, I            '  /* ORA $ssss,x ABS,x */
CASE &H1E: cmdr mm.ax, m.asl                '  /* ASL $ssss,x ABS,x */
CASE &H39: cmdr mr.ay, I: cmdr m.and, I            '  /* AND $ssss,y ABS,y */
CASE &H3D: cmdr mr.ax, I: cmdr m.and, I            '  /* AND $ssss,x ABS,x */
CASE &H3E: cmdr mm.ax, M.ROL                '  /* ROL $ssss,x ABS,x */
CASE &H59: cmdr mr.ay, I: cmdr m.eor, I            '  /* EOR $ssss,y ABS,y */
CASE &H5D: cmdr mr.ax, I: cmdr m.eor, I            '  /* EOR $ssss,x ABS,x */
CASE &H5E: cmdr mm.ax, M.LSR                '  /* LSR $ssss,x ABS,x */
CASE &H79: cmdr mr.ay, I: cmdr m.adc, I            '  /* ADC $ssss,y ABS,y */
CASE &H7D: cmdr mr.ax, I: cmdr m.adc, I            '  /* ADC $ssss,x ABS,x */
CASE &H7E: cmdr mm.ax, M.ROR                '  /* ROR $ssss,x ABS,x */
CASE &H99: cmdr mw.ay, reg.a                 '  /* STA $ssss,y ABS,y */
CASE &H9D: cmdr mw.ax, reg.a                 '  /* STA $ssss,x ABS,x */
CASE &HB9: cmdr mr.ay, reg.a: cmdr m.fl, reg.a     '  /* LDA $ssss,y ABS,y */
CASE &HBC: cmdr mr.ax, reg.y: cmdr m.fl, reg.y     '  /* LDY $ssss,x ABS,x */
CASE &HBD: cmdr mr.ax, reg.a: cmdr m.fl, reg.a     '  /* LDA $ssss,x ABS,x */
CASE &HBE: cmdr mr.ay, reg.x: cmdr m.fl, reg.x     '  /* LDX $ssss,y ABS,y */
CASE &HD9: cmdr mr.ay, I: M.CMP reg.a, I     '  /* CMP $ssss,y ABS,y */
CASE &HDD: cmdr mr.ax, I: M.CMP reg.a, I     '  /* CMP $ssss,x ABS,x */
CASE &HDE: cmdr mm.ax, M.DEC                '  /* DEC $ssss,x ABS,x */
CASE &HF9: cmdr mr.ay, I: cmdr m.sbc, I            '  /* SBC $ssss,y ABS,y */
CASE &HFD: cmdr mr.ax, I: cmdr m.sbc, I            '  /* SBC $ssss,x ABS,x */
CASE &HFE: cmdr mm.ax, m.inc                '  /* INC $ssss,x ABS,x */
CASE &H1: cmdr mr.ix, I: cmdr m.ora, I             '  /* ORA ($ss,x) INDEXINDIR */
CASE &H11: cmdr mr.iy, I: cmdr m.ora, I            '  /* ORA ($ss),y INDIRINDEX */
CASE &H21: cmdr mr.ix, I: cmdr m.and, I            '  /* AND ($ss,x) INDEXINDIR */
CASE &H31: cmdr mr.iy, I: cmdr m.and, I            '  /* AND ($ss),y INDIRINDEX */
CASE &H41: cmdr mr.ix, I: cmdr m.eor, I            '  /* EOR ($ss,x) INDEXINDIR */
CASE &H51: cmdr mr.iy, I: cmdr m.eor, I            '  /* EOR ($ss),y INDIRINDEX */
CASE &H61: cmdr mr.ix, I: cmdr m.adc, I            '  /* ADC ($ss,x) INDEXINDIR */
CASE &H71: cmdr mr.iy, I: cmdr m.adc, I            '  /* ADC ($ss),y INDIRINDEX */
CASE &H81: cmdr mw.ix, reg.a                 '  /* STA ($ss,x) INDEXINDIR */
CASE &H91: cmdr mw.iy, reg.a                 '  /* STA ($ss),y INDIRINDEX */
CASE &HA1: cmdr mr.ix, reg.a: cmdr m.fl, reg.a     '  /* LDA ($ss,x) INDEXINDIR */
CASE &HB1: cmdr mr.iy, reg.a: cmdr m.fl, reg.a     '  /* LDA ($ss),y INDIRINDEX */
CASE &HC1: cmdr mr.ix, I: M.CMP reg.a, I     '  /* CMP ($ss,x) INDEXINDIR */
CASE &HD1: cmdr mr.iy, I: M.CMP reg.a, I     '  /* CMP ($ss),y INDIRINDEX */
CASE &HE1: cmdr mr.ix, I: cmdr m.sbc, I            '  /* SBC ($ss,x) INDEXINDIR */
CASE &HF1: cmdr mr.iy, I: cmdr m.sbc, I            '  /* SBC ($ss),y INDIRINDEX */
CASE &HA: cmdr m.asl, reg.a                 '  /* ASL a ACC */
CASE &H2A: cmdr M.ROL, reg.a                '  /* ROL a ACC */
CASE &H4A: cmdr M.LSR, reg.a                '  /* LSR a ACC */
CASE &H6A: cmdr M.ROR, reg.a                '  /* ROR a ACC */

CASE ELSE
PRINT
PRINT "ERROR:"; HEX$(word(reg.pc) - 1), HEX$(I): END
'default:
'  if(_TrapBadOps) {
'    fprintf
'    ( stderr,
'      "[M6502 %lX] Unrecognized instruction: $%02X at PC=$%04X\n",
'      (unsigned)_User,Op6502(REG.PC.W-1),(word)(REG.PC.W-1)
'    );
'
'    _Trace=1;
'
'  }
'
'  break;
END SELECT



END SUB

FUNCTION io_read (a&)
'PRINT "io_read": END
'byte IO_read(word A)
'byte ret

  SELECT CASE a& AND &H1C00
  CASE &H0:    '/* VDC */
    SELECT CASE a& AND 3
    CASE 0:
        ret = io.vdc_status
        io.vdc_status = 0';//&=VDC_InVBlank;//&=~VDC_BSY;
        io_read = ret: EXIT FUNCTION
    CASE 1:
        io_read = 0: EXIT FUNCTION
    CASE 2:
        IF (io.vdc_reg = VRR) THEN
'            io_read = vram(word(io.VDC(MARR)) * 2): EXIT FUNCTION
            io_read = rdvmmb(word(io.VDC(MARR)) * 2 + vram&): EXIT FUNCTION

        ELSE
        io_read = io.VDC(io.vdc_reg).l: EXIT FUNCTION
        END IF
    CASE 3:
        IF (io.vdc_reg = VRR) THEN
'            ret = vram(word(io.VDC(MARR)) * 2 + 1)
            ret = rdvmmb(word(io.VDC(MARR)) * 2 + 1 + vram&)
            words io.VDC(MARR), word(io.VDC(MARR)) + io.vdc_inc
            io_read = ret: EXIT FUNCTION
        ELSE
        io_read = io.VDC(io.vdc_reg).H: EXIT FUNCTION
        END IF
    END SELECT
    

  CASE &H400: '/* VCE */
    SELECT CASE a& AND 7
    CASE 4: io_read = io.VCE(word(io.vce_reg)).l: EXIT FUNCTION
    CASE 5: io_read = io.VCE(word(io.vce_reg)).H: words io.vce_reg, word(io.vce_reg) + 1: EXIT FUNCTION
    END SELECT
    
'#ifndef FINAL_RELEASE
'  case 0x0800:  /* PSG */
'    switch(A&15){
'    case 0: return io.psg_ch;
'    case 1: return io.psg_volume;
'    case 2: return io.PSG[io.psg_ch][2];
'    case 3: return io.PSG[io.psg_ch][3];
'    case 4: return io.PSG[io.psg_ch][4];
'    case 5: return io.PSG[io.psg_ch][5];
'    CASE 6:
'        {
'            //int   ofs=io.wavofs[io.psg_ch];
'            //io.wavofs[io.psg_ch]=(io.wavofs[io.psg_ch]+1)&31;
'            //return io.wave[io.psg_ch][ofs];
'            int ofs=fixtoi(snd_pos[io.psg_ch]);
'            snd_pos[io.psg_ch]=itofix((fixtoi(snd_pos[io.psg_ch])+1)&31);
'            return io.wave[io.psg_ch][ofs];
'
'        }
'    case 7: return io.PSG[io.psg_ch][7];
'    case 8: return io.psg_lfo_freq;
'    case 9: return io.psg_lfo_ctrl;
'    default: return NODATA;
'    }
'    break;
'#endif
  CASE &HC00:  ' /* timer */
    io_read = io.timer_counter: EXIT FUNCTION

  CASE &H1000:  '/* joypad */
        ret = io.JOY(io.joy_counter) XOR &HFF
        IF io.joy_select AND 1 THEN
        ret = ret \ 2 ^ 4
        ELSE
        ret = ret AND 15: io.joy_counter = (io.joy_counter + 1) MOD 5
        END IF
        io_read = ret OR Country: EXIT FUNCTION'; /* country 0:JPN 1=US */


  CASE &H1400: ' /* IRQ */
    SELECT CASE a& AND 15
    CASE 2: io_read = io.irq_mask: EXIT FUNCTION
    CASE 3: ret = io.irq_status: io.irq_status = 0: io_read = ret: EXIT FUNCTION
    END SELECT
    

  CASE &H1800: ' /* CD-ROM extention */
    SELECT CASE a& AND 15
    CASE 3: io.backup = DISABLE: io_read = DISABLE: EXIT FUNCTION'return io.backup = disable
'//  case 0xa:
'//      if (!io.adpcm_firstread) return PCM[io.adpcm_rptr++];
'//      else {io.adpcm_firstread=FALSE; return NODATA;}
    END SELECT
    
    
  END SELECT
    io_read = NODATA


END FUNCTION

SUB io_write (a%, b%)
'PRINT "io_write": END
END SUB

SUB loadpce (f%)

    fs& = LOF(f%)
    hdr& = fs& AND &H1FFF
    fsize& = fs& AND NOT (&H1FFF)
    rom& = allocvmm&(fsize&)

    DO UNTIL adr& > fs&
    d$ = INPUT$(32767, f%)
    wrvmm rom& + adr&, d$
    d$ = ""
    adr& = adr& + 32767
    LOOP





    rom.size = fsize& \ &H2000

    rommask = 1


WHILE (rommask < rom.size)
    rommask = rommask * 2 ^ 1
    WEND
    rommask = rommask - 1

    FOR I = 0 TO &HF7

    
        IF (rom.size = &H30) THEN
        
            SELECT CASE (I AND &H70)
            
            CASE &H0:
            CASE &H10:
            CASE &H50:
                rommap&(I) = rom& + (I AND rommask) * &H2000
                
            CASE &H20:
            CASE &H60:
                rommap&(I) = rom& + ((I - &H20) AND rommask) * &H2000
                
            CASE &H30:
            CASE &H70:
                rommap&(I) = rom& + ((I - &H10) AND rommask) * &H2000
                
            CASE &H40:
                rommap&(I) = rom& + ((I - &H20) AND rommask) * &H2000
                
            END SELECT
        
        ELSE


     rommap&(I) = rom& + (I AND rommask) * 8192&'* &H2000
    'rommap&(i) = rom& + (i AND rommask) * &H2000
       END IF
    NEXT I


    rommap&(&HF8) = ram&
    rommap&(&HF9) = ram& + &H2000
    rommap&(&HFA) = ram& + &H4000
    rommap&(&HFB) = ram& + &H6000
    rommap&(&HFF) = ioarea&' //NULL; /* NULL = I/O area */









END SUB

SUB M.CMP (rg1, rg2)

  words k, rg1 - rg2
  reg.p = reg.p AND NOT (C.FLAG)
  IF k.H THEN tmp = 0 ELSE tmp = C.FLAG
  reg.p = reg.p OR tmp

  'ZF = NF = K.L
  reg.zf = k.l
  reg.nf = k.l

END SUB

SUB M.JR ()

'get code please
'op6502i is offset
I = op6502i(reg.pc)
I = I + (I > 127) * 256

words reg.pc, word(reg.pc) + I + 1
cycle& = cycle& + 2
END SUB

SUB M.LDWORD (rg AS pcc)
a& = word(reg.pc)
rg.l = op6502(a&)
rg.H = op6502(a& + 1)
words reg.pc, a& + 2
END SUB

DEFSNG A-Z
FUNCTION MCAB% ()
MCAB% = OP6502W(word(reg.pc))

END FUNCTION

FUNCTION MCAX% ()
MCAX% = OP6502W(word(reg.pc)) + reg.x
END FUNCTION

FUNCTION MCAY% ()
MCAY% = OP6502W(word(reg.pc)) + reg.y
END FUNCTION

FUNCTION MCIX% ()
MCIX% = RDRAMW(MCZx)

END FUNCTION

FUNCTION MCIY% ()
MCIY% = RDRAMW(MCZp) + reg.y
END FUNCTION

DEFINT A-Z
FUNCTION MCZp ()
MCZp = nop6502(reg.pc) + zp


END FUNCTION

FUNCTION MCZx ()
'error:op6502 isn't byte
MCZx = nop6502(reg.pc) + reg.x + zp

END FUNCTION

FUNCTION MCZY ()
'op6502 isn't byte
MCZY = nop6502(reg.pc) + reg.y + zp
END FUNCTION

FUNCTION nop6502 (rg AS pcc)
A1& = word(rg)
a& = A1&
p = a& \ 2 ^ 13
a& = page&(p) + a&

nop6502 = rdvmmb(a&)
a& = A1&
a& = a& + 1
words rg, a&
END FUNCTION

FUNCTION notb (a%)
notb = NOT (a%) AND &HFF
END FUNCTION

FUNCTION op6502 (A1&)
a& = A1&
IF a& < 0 THEN a& = 65536 + a&
'page = a& \ 2 ^ 13
p = a& \ 2 ^ 13
a& = page&(p) + a&

'IF a& >= 16384 AND a& < 20480 THEN a& = a& - 16384
'IF a& >= 24576 AND a& < 28672 THEN a& = a& - 24576
'IF a& >= 32768 AND a& < 36864 THEN a& = a& - 32768
'IF a& >= 40960 AND a& < 45056 THEN a& = a& - 40960
'IF a& >= 49152 AND a& < 53284 THEN a& = a& - 49152
'IF a& >= 57344 AND a& < 61440 THEN a& = a& - 57344
'IF a& < 24576 AND a& >= 20480 THEN a& = a& - 16384
'IF a& < 32768 AND a& >= 28672 THEN a& = a& - 24576
'IF a& < 40960 AND a& >= 36864 THEN a& = a& - 32768
'IF a& < 49152 AND a& >= 45056 THEN a& = a& - 40960
'IF a& < 57344 AND a& >= 53284 THEN a& = a& - 49152
'IF a& < 65536 AND a& >= 61440 THEN a& = a& - 57344



op6502 = rdvmmb(a&)


END FUNCTION

FUNCTION op6502i (rg AS pcc)
a& = word(rg)
op6502i = op6502(a&)
END FUNCTION

FUNCTION OP6502W (a&)
'error h,l order?

A1% = op6502(a&)'l
a2% = op6502(a& + 1)'h
OP6502W = CVI(CHR$(A1%) + CHR$(a2%))

END FUNCTION

FUNCTION rd6502 (a&)

p = a& \ 2 ^ 13

IF page&(p) <> ioarea& THEN
adr& = page&(p) + a&
SEEK #vmmfile, adr&
b$ = INPUT$(1, vmmfile)

' = page[p][a&]
rd6502 = ASC(b$)

ELSE

rd6502 = io_read(a&)
END IF



END FUNCTION

FUNCTION RdRAM% (a%)


SEEK #vmmfile, ram& + a%

b$ = INPUT$(1, 2)
'RdRAM% = pram(a%)
RdRAM% = ASC(b$)


END FUNCTION

FUNCTION RDRAMW (a%)
'error h,l order?
SEEK #2, a% + 1
GET #2, , a%
'RdRAM% = pram(a%)
RDRAMW% = a%

END FUNCTION

FUNCTION rdvmmb (a&)
SEEK #vmmfile, a&
b$ = INPUT$(1, vmmfile)

rdvmmb = ASC(b$)

END FUNCTION

SUB reginc (rg AS pcc)
a& = word(rg) + 1
words rg, a&

END SUB

SUB RESET6502 ()
  reg.mpr(7) = &H0: BANK.SET 7, &H0

   reg.mpr(6) = &H5: BANK.SET 6, &H5

   reg.mpr(5) = &H4: BANK.SET 5, &H4

   reg.mpr(4) = &H3: BANK.SET 4, &H3

   reg.mpr(3) = &H2: BANK.SET 3, &H2

   reg.mpr(2) = &H1: BANK.SET 2, &H1

   reg.mpr(1) = &HF8: BANK.SET 1, &HF8

   reg.mpr(0) = &HFF: BANK.SET 0, &HFF
  reg.a = 0: reg.x = 0: reg.y = 0
  reg.p = I.FLAG

  reg.nf = 0: reg.vf = 0

  reg.zf = &HFF
  reg.s = &HFF

  reg.pc.l = op6502(VEC.RESET)
  reg.pc.H = op6502(VEC.RESET + 1)

reg.ICount = reg.IPeriod
  reg.IRequest = INT.NONE
  reg.AfterCLI = 0
  '//_CycleCount=0;
  '(int)(R->User)=0;
  reg.USER = 0
END SUB

SUB RUN6502 ()
instr.init
RESET6502
'words reg.pc, &HE000
x = 1
DO
'y = y + 1
'IF y = 24 THEN y = 1: x = x + 8'+3

I = nop6502(reg.pc)
'LOCATE Y, X
'PRINT x, y
'PRINT HEX$(WORD(reg.pc)); ":"; opcode$(I); 'i;


cycle& = cycle& + CYCLES(I)
 
CODES I

LOOP
END SUB

SUB T_INIT (src&, dist&, length&)
a& = word(reg.pc)
src& = OP6502W(a&)
dist& = OP6502W(a& + 2)
length& = OP6502W(a& + 4)
a& = a& + 6
words reg.pc, a&
'cycle = length& * 6
'cycle& = cycle& + length& * 6

END SUB

FUNCTION word& (rg AS pcc)
'A% = CVI(CHR$(RG.L) + CHR$(RG.H))
'WORD& = CVL(MKI$(A%) + MKI$(0))

word& = rg.l + rg.H * 2 ^ 8
'word& = CVL(CHR$(RG.l) + CHR$(RG.h) + MKI$(0))



END FUNCTION

SUB words (rg AS pcc, A1&)
'A% = CVI(MKL$(A&))
'RG.L = ASC(MKI$(A%))
'RG.H = ASC(MID$(MKI$(A%), 2))
a& = A1& AND &HFFFF
rg.l = a& AND &HFF
'RG.L = ASC(MKL$(A&))

rg.H = a& \ 2 ^ 8
'RG.H = ASC(MID$(MKL$(A&), 2))


END SUB

SUB Wr6502 (a&, V)

p = a& \ 2 ^ 13

IF page&(p) <> ioarea& THEN
'page[p][a]=v
b$ = CHR$(V)
SEEK #vmmfile, page&(p) + a&
PUT #vmmfile, , b$
ELSE
io_write (a&), V
END IF




END SUB

SUB wrRAM (a%, b%)
'pram(a%) = b%
b$ = CHR$(b%)
PUT #vmmfile, a% + ram&, b$

END SUB

SUB wrvmm (adr&, d$)

SEEK #vmmfile, adr&
PUT #vmmfile, , d$


END SUB

SUB wrvmmb (a&, b%)
SEEK #vmmfile, a&
b$ = CHR$(b%)
PUT #vmmfile, , b$

END SUB

