SELECT CASE I
CASE &HD4'/* CSH set clock highspeed */
CASE &H54'/* CSL set clock lowspeed */

CASE &H44: '/* BSR * REL */
		   M.PUSH reg.PC.B.h
		   M.PUSH reg.PC.B.l
		  
CASE &H80: '/* BRA * REL */
		  reg.pc.w = reg.pc.w + (offset) * Op6502(reg.pc.w) + 1


CASE &H7C: '/* JMP ($ssss,x) */
		M.LDWORD K: K.W = K.W + reg.x
		reg.PC.B.l = Op6502(K.W)
		reg.PC.B.h = Op6502(K.W + 1)

CASE &HDA: M.PUSH reg.x  '  /* PHX */

CASE &H5A: M.PUSH reg.y '               /* PHY */
CASE &HFA: M.POP reg.x: M.FL reg.x '    /* PLX */
CASE &H7A: M.POP reg.y: M.FL reg.y'      /* PLY */

CASE &H62: reg.a = 0' /* CLA */
CASE &H82: reg.x = 0' /* CLX */
CASE &HC2: reg.y = 0' /* CLY */

CASE &H2: I = reg.x: reg.x = reg.y: reg.y = I'  /* SXY */
CASE &H22: I = reg.a: reg.a = reg.x: reg.x = I'  /* SAX */
CASE &H42: I = reg.a: reg.a = reg.y: reg.y = I'  /* SAY */

CASE &H3A: M.DEC reg.a                   ' /* DEC A */
CASE &H1A: M_INC reg.a                   ' /* INC A */

CASE &H72: MR.Id I: M.ADC I               '/* ADC ($ss) INDIR */
CASE &H32: MR.Id I: M.AND I               '/* AND ($ss) INDIR */
CASE &HD2: MR.Id I: M.CMP reg.a, I        '/* CMP ($ss) INDIR */
CASE &H52: MR.Id I: M.EOR I               '/* EOR ($ss) INDIR */
CASE &HB2: MR.Id reg.a: M.FL reg.a        '/* LDA ($ss) INDIR */
CASE &H12: MR.Id I: M.ORA I               '/* ORA ($ss) INDIR */
CASE &H92: MC.Id J: Wr6502 J.W, reg.a     '/* STA ($ss) INDIR */
CASE &HF2: MR.Id I: M.SBC I             '  /* SBC ($ss) INDIR */

CASE &H89: MR.Im I: M.BIT I  '              /* BIT #$ss IMM */
CASE &H34: MR.Zx I: M.BIT I  '              /* BIT $ss,x ZP,x */
CASE &H3C: MR.Ax I: M.BIT I  '              /* BIT $ssss,x ABS,x */

CASE &H64: MW.Zp &H0            '          /* STZ $ss ZP */
CASE &H74: MW.Zx &H0            '          /* STZ $ss,x ZP,x */
CASE &H9C: MW.Ab &H0            '          /* STZ $ssss ABS */
CASE &H9E: MW.Ax &H0            '          /* STZ $ssss,x ABS,x */

CASE &HF4: ' /* SET */
		I = Op6502(reg.pc.w)
		reg.pc.w = reg.pc.w + 1
		CYCLE = CYCLE + Cycles(I) + 3
		SELECT CASE I
		CASE &H65: MR.Zp I: M.ADCx I'       /* ADC $ss ZP */
		CASE &H6D: MR.Ab I: M.ADCx I'       /* ADC $ssss ABS */
		CASE &H69: MR.Im I: M.ADCx I'       /* ADC #$ss IMM */
		CASE &H75: MR.Zx I: M.ADCx I'       /* ADC $ss,x ZP,x */
		CASE &H79: MR.Ay I: M.ADCx I'       /* ADC $ssss,y ABS,y */
		CASE &H7D: MR.Ax I: M.ADCx I'       /* ADC $ssss,x ABS,x */
		CASE &H61: MR.Ix I: M.ADCx I'       /* ADC ($ss,x) INDEXINDIR */
		CASE &H71: MR.Iy I: M.ADCx I'       /* ADC ($ss),y INDIRINDEX */
		CASE &H72: MR.Id I: M.ADCx I'       /* ADC ($ss) INDIR */

		CASE &H25: MR.Zp I: M.ANDx I'       /* AND $ss ZP */
		CASE &H2D: MR.Ab I: M.ANDx I'       /* AND $ssss ABS */
		CASE &H29: MR.Im I: M.ANDx I'       /* AND #$ss IMM */
		CASE &H35: MR.Zx I: M.ANDx I'       /* AND $ss,x ZP,x */
		CASE &H39: MR.Ay I: M.ANDx I'       /* AND $ssss,y ABS,y */
		CASE &H3D: MR.Ax I: M.ANDx I'       /* AND $ssss,x ABS,x */
		CASE &H21: MR.Ix I: M.ANDx I'       /* AND ($ss,x) INDEXINDIR */
		CASE &H31: MR.Iy I: M.ANDx I'       /* AND ($ss),y INDIRINDEX */
		CASE &H32: MR.Id I: M.ANDx I'       /* AND ($ss) INDIR */

		CASE &H45: MR.Zp I: M.EORx I '       /* EOR $ss ZP */
		CASE &H4D: MR.Ab I: M.EORx I '       /* EOR $ssss ABS */
		CASE &H49: MR.Im I: M.EORx I '       /* EOR #$ss IMM */
		CASE &H55: MR.Zx I: M.EORx I '       /* EOR $ss,x ZP,x */
		CASE &H59: MR.Ay I: M.EORx I '       /* EOR $ssss,y ABS,y */
		CASE &H5D: MR.Ax I: M.EORx I '       /* EOR $ssss,x ABS,x */
		CASE &H41: MR.Ix I: M.EORx I '       /* EOR ($ss,x) INDEXINDIR */
		CASE &H51: MR.Iy I: M.EORx I '       /* EOR ($ss),y INDIRINDEX */
		CASE &H52: MR.Id I: M.EORx I '       /* EOR ($ss) INDIR */

		CASE &H5: MR.Zp I: M.ORAx I  '       /* ORA $ss ZP */
		CASE &HD: MR.Ab I: M.ORAx I  '       /* ORA $ssss ABS */
		CASE &H9: MR.Im I: M.ORAx I  '       /* ORA #$ss IMM */
		CASE &H15: MR.Zx I: M.ORAx I '       /* ORA $ss,x ZP,x */
		CASE &H19: MR.Ay I: M.ORAx I '       /* ORA $ssss,y ABS,y */
		CASE &H1D: MR.Ax I: M.ORAx I '       /* ORA $ssss,x ABS,x */
		CASE &H1: MR.Ix I: M.ORAx I  '       /* ORA ($ss,x) INDEXINDIR */
		CASE &H11: MR.Iy I: M.ORAx I '       /* ORA ($ss),y INDIRINDEX */
		CASE &H12: MR.Id I: M.ORAx I '       /* ORA ($ss) INDIR */

		CASE ELSE
		PRINT ERR, "no sense SET"
		CYCLE = CYCLE - Cycles(I)
				
	
		END SELECT

CASE &H3: IO.write 0, Op6502(reg.pc.w): reg.pc.w = reg.pc.w + 1'/* ST0 */
CASE &H13: IO.write 2, Op6502(reg.pc.w): reg.pc.w = reg.pc.w + 1'/* ST1 */
CASE &H23: IO.write 3, Op6502(reg.pc.w): reg.pc.w = reg.pc.w + 1'/* ST2 */

CASE &H43: '/* TMAi */
		I = Op6502(reg.pc.w): reg.pc.w = reg.pc.1 + 1
		
		  FOR ii = 0 TO 7
			  I = I \ 2 ^ 1

			  IF (I AND 1) THEN EXIT FOR
		  
		  '//reg.a = Reg.MPR[ii]
		  '//reg.a = Reg.MPR[ii]
		  reg.a = M.MPR(ii)
		  NEXT ii

CASE &H53: '/* TAMi */
		I = Op6502(reg.pc.w): reg.pc.w = reg.pc.w + 1
	
		 FOR ii = 0 TO 7
				I = I * 2 ^ 1
				IF (I AND 11) THEN
						'//R->MPR[ii]=reg.a;
						'//R.MPR[ii]=reg.a;
						M.MPR(ii) = reg.a
						BANK.SET ii, reg.a
				END IF
		 NEXT ii

CASE &HC3: ' /* TDD */
		T_INIT
		DO
		Wr6502 dist, Rd6502(src)
		dist = dist - 1

		src = src - 1
		LENGTH = LENGTH - 1
		LOOP WHILE LENGTH
'        } while(--length);
		
		
		

CASE &H73: ' /* TII */
		T_INIT
		DO
			 Wr6502 dist, Rd6502(src)
			 dist = dist + 1
				src = src + 1
		LENGTH = LENGTH - 1
		WHILE LENGTH
'        } while(--length);
		

CASE &HE3: ' /* TIA */
		T_INIT
		DO
				Wr6502 dist, Rd6502(src)
				src = src + 1

				IF NOT LENGTH THEN EXIT FOR
				' if (!(--length)):break
				LENGTH = LENGTH - 1
				Wr6502 dist + 1, Rd6502(src)
				src = src + 1
'        } while(--length);
		lenght = LENGTH - 1
		LOOP WHILE LENGTH
		

CASE &HF3: ' /* TAI */
		T_INIT
		DO
				Wr6502 dist, Rd6502(src)
				dist = dist + 1
				'if (!(--length)) break;
				LENGTH = LENGTH - 1
				IF NOT LENGTH THEN EXIT FOR
				Wr6502 dist, Rd6502(src + 1)
				dist = dist + 1

		 LENGTH = LENGTH - 1
		 LOOP WHILE LENGTH
'        } while(--length);

CASE &HD3: ' /* TIN */
		T_INIT
		DO
				Wr6502 dist, Rd6502(src)
				src = src + 1
		LENGTH = LENGTH - 1
		LOOP WHILE LENGTH

CASE &H14: MM.Zp TRB  '      /* TRB $ss ZP */
CASE &H1C: MM.Ab TRB  '      /* TRB $ssss ABS */

CASE &H4: MM.Zp TSB   '      /* TSB $ss ZP */
CASE &HC: MM.Ab TSB   '      /* TSB $ssss ABS */

CASE &H83: '/* TST #$ss,$ss IMM,ZP */
		I = Op6502(reg.pc.w): J.B.l = RdRAM(MCZp())
		reg.pc.w = reg.pc.w + 1
'error    NF = VF = J.B.L
		REG.NF = J.B.l
		REG.VF = J.B.l: REG.ZF = I AND J.B.l
		
CASE &HA3: '/* TST #$ss,$ss,x IMM,ZP,x */
		I = Op6502(regPC.w): J.B.l = RdRAM(MCZx())
		reg.pc.w = reg.pc.w + 1

'error REG,NF = REG.VF = J.B.L
		REG.NF = J.B.l
		REG.VF = J.B.l: REG.ZF = I AND J.B.l
CASE &H93: '/* TST #$ss,$ssss IMM,ABS */
		I = Op6502(reg.pc.w): MR.Ab J.B.l
		reg.pc.w = reg.pc.w + 1
'error
		REG.NF = J.B.l
		 REG.VF = J.B.l: REG.ZF = I AND J.B.l

CASE &HB3: '/* TST #$ss,$ssss,x IMM,ABS,x */
		I = Op6502(reg.pc.w): MR.Ax J.B.l
		reg.pc.w = reg.pc.w + 1
'error
		REG.NF = J.B.l
		REG.VF = J.B.l: REG.ZF = I AND J.B.l

CASE &HF: IF RdRAM(MCZp()) AND &H1 THEN reg.pc.w = reg.pc.w + reg.pc.w + 1:  ELSE M.JR          '      /* BBRi */
CASE &H1F: IF RdRAM(MCZp()) AND &H2 THEN reg.pc.w = reg.pc.w + reg.pc.w + 1:  ELSE M.JR
CASE &H2F: IF RdRAM(MCZp()) AND &H4 THEN reg.pc.w = reg.pc.w + reg.pc.w + 1:  ELSE M.JR
CASE &H3F: IF RdRAM(MCZp()) AND &H8 THEN reg.pc.w = reg.pc.w + reg.pc.w + 1:  ELSE M.JR
CASE &H4F: IF RdRAM(MCZp()) AND &H10 THEN reg.pc.w = reg.pc.w + reg.pc.w + 1:  ELSE M.JR
CASE &H5F: IF RdRAM(MCZp()) AND &H20 THEN reg.pc.w = reg.pc.w + reg.pc.w + 1:  ELSE M.JR
CASE &H6F: IF RdRAM(MCZp()) AND &H40 THEN reg.pc.w = reg.pc.w + reg.pc.w + 1:  ELSE M.JR
CASE &H7F: IF RdRAM(MCZp()) AND &H80 THEN reg.pc.w = reg.pc.w + reg.pc.w + 1:  ELSE M.JR

CASE &H8F: IF RdRAM(MCZp()) AND &H1 THEN M.JR:         ELSE reg.pc.w = reg.pc.w + reg.pc.w + 1  '      /* BBSi */
CASE &H9F: IF RdRAM(MCZp()) AND &H2 THEN M.JR:         ELSE reg.pc.w = reg.pc.w + reg.pc.w + 1
CASE &HAF: IF RdRAM(MCZp()) AND &H4 THEN M.JR:         ELSE reg.pc.w = reg.pc.w + reg.pc.w + 1
CASE &HBF: IF RdRAM(MCZp()) AND &H8 THEN M.JR:         ELSE reg.pc.w = reg.pc.w + reg.pc.w + 1
CASE &HCF: IF RdRAM(MCZp()) AND &H10 THEN M.JR:        ELSE reg.pc.w = reg.pc.w + reg.pc.w + 1
CASE &HDF: IF RdRAM(MCZp()) AND &H20 THEN M.JR:        ELSE reg.pc.w = reg.pc.w + reg.pc.w + 1
CASE &HEF: IF RdRAM(MCZp()) AND &H40 THEN M.JR:        ELSE reg.pc.w = reg.pc.w + reg.pc.w + 1
CASE &HFF: IF RdRAM(MCZp()) AND &H80 THEN M.JR:        ELSE reg.pc.w = reg.pc.w + reg.pc.w + 1

'#define M_RMB(n)        *AdrRAM(MCZp())&=~n
'#define M_SMB(n)        *AdrRAM(MCZp())|=n

CASE &H7: M.RMB &H1   '        /* RMBi */
CASE &H17: M.RMB &H2  '        /* RMBi */
CASE &H27: M.RMB &H4  '        /* RMBi */
CASE &H37: M.RMB &H8  '        /* RMBi */
CASE &H47: M.RMB &H10 '        /* RMBi */
CASE &H57: M.RMB &H20 '        /* RMBi */
CASE &H67: M.RMB &H40 '        /* RMBi */
CASE &H77: M.RMB &H80 '        /* RMBi */

CASE &H87: M.SMB &H1  '        /* SMBi */
CASE &H97: M.SMB &H2  '        /* SMBi */
CASE &HA7: M.SMB &H4  '        /* SMBi */
CASE &HB7: M.SMB &H8  '        /* SMBi */
CASE &HC7: M.SMB &H10 '        /* SMBi */
CASE &HD7: M.SMB &H20 '        /* SMBi */
CASE &HE7: M.SMB &H40 '        /* SMBi */
CASE &HF7: M.SMB &H80 '        /* SMBi */
END SELECT

