/* HuC6280 additional */
/* BRK addres = 0xFFF6 */

#define MC_Id(Rg)	K.W=MCZp(); \
			Rg.B.l=RdRAM(K.W);Rg.B.h=RdRAM(K.W+1)
#define MR_Id(Rg)	MC_Id(J);Rg=Rd6502(J.W)
//#define	M_FL2(Rg)	_P&=~(Z_FLAG|N_FLAG|V_FLAG);_P|=(Rg&0xc0)|ZNTable[Rg]
#define	TSB(Rg)	\
	_NF=_VF=Rg; \
	Rg|=_A; _ZF=Rg;
#define	TRB(Rg) \
	_NF=_VF=Rg; \
	Rg&=~_A; _ZF=Rg;
#define T_INIT() \
	word src,dist,length; \
	src  = Op6502w(_PC_); _PC_+=2; \
	dist = Op6502w(_PC_); _PC_+=2; \
	length = Op6502w(_PC_); _PC_+=2; \
	cycle=length*6
#define M_ADCx(Rg) \
 { byte *Mx=AdrRAM(_X+ZP); \
  if(_P&D_FLAG) \
  { \
    K.B.l=(*Mx&0x0F)+(Rg&0x0F)+(_P&C_FLAG); \
    K.B.h=(*Mx>>4)+(Rg>>4);/*+(K.B.l>>4);*/ \
    if(K.B.l>9) { K.B.l+=6;K.B.h++; } \
    if(K.B.h>9) K.B.h+=6; \
    *Mx=(K.B.l&0x0F)|(K.B.h<<4); \
    _P=(_P&~C_FLAG)|(K.B.h>15? C_FLAG:0); \
	_ZF=_NF=*Mx; \
	cycle++; \
  } \
  else \
  { \
    K.W=*Mx+Rg+(_P&C_FLAG); \
    _P&=~C_FLAG; \
    _P|=(K.B.h? C_FLAG:0); \
	_VF=(~(*Mx^Rg)&(*Mx^K.B.l))>>1; \
	_ZF=_NF=K.B.l; \
    *Mx=K.B.l; \
  } \
 }

#define M_ANDx(Rg)	*AdrRAM(_X+ZP)&=Rg;M_FL(RdRAM(_X+ZP))
#define M_EORx(Rg)	*AdrRAM(_X+ZP)^=Rg;M_FL(RdRAM(_X+ZP))
#define M_ORAx(Rg)	*AdrRAM(_X+ZP)|=Rg;M_FL(RdRAM(_X+ZP))

case &HD4'/* CSH set clock highspeed */
case &H54'/* CSL set clock lowspeed */

case &H44:'/* BSR * REL */
           m.push reg.pc.b.h
           m.push reg.pc.b.l
          
case &H80: '/* BRA * REL */
          reg.pc.w= reg.pc.w + (offset)op6502(reg.pc.w) + 1


case &H7C:'/* JMP ($ssss,x) */
        M.LDWORD K:K.W=k.w + reg.X
        reg.PC.B.l = Op6502(K.W);
        reg.PC.B.h = Op6502(K.W+1);

case &HDA: M.PUSH reg.X  '  /* PHX */

case &H5A: M.PUSH reg.Y '               /* PHY */
case &HFA: M.POP reg.X:M.FL reg.X  '    /* PLX */
case &H7A: M.POP reg.Y:M.FL reg.Y'      /* PLY */

case &H62: reg.a=0' /* CLA */
case &H82: reg.x=0' /* CLX */
case &HC2: reg.y=0' /* CLY */

case &H02: I=reg.x:reg.x=reg.y:reg.y=I  '  /* SXY */
case &H22: I=reg.a:reg.a=reg.x:reg.x=I  '  /* SAX */
case &H42: I=reg.a:reg.a=reg.y:reg.y=I  '  /* SAY */

case &H3A: M.DEC reg.a                   ' /* DEC A */
case &H1A: M_INC reg.a                   ' /* INC A */

case &H72: MR.Id I:M.ADC I                '/* ADC ($ss) INDIR */
case &H32: MR.Id I:M.AND I                '/* AND ($ss) INDIR */
case &HD2: MR.Id I:M.CMP reg.a,I          '/* CMP ($ss) INDIR */
case &H52: MR.Id I:M.EOR I                '/* EOR ($ss) INDIR */
case &HB2: MR.Id reg.a:M.FL reg.a         '/* LDA ($ss) INDIR */
case &H12: MR.Id I:M.ORA I;break          '/* ORA ($ss) INDIR */
case &H92: MC.Id J:Wr6502 J.W,reg.a       '/* STA ($ss) INDIR */
case &HF2: MR.Id I:M.SBC I              '  /* SBC ($ss) INDIR */

case &H89: MR.Im I:M.BIT(I) '              /* BIT #$ss IMM */
case &H34: MR.Zx I:M.BIT(I) '              /* BIT $ss,x ZP,x */
case &H3C: MR.Ax I:M.BIT(I) '              /* BIT $ssss,x ABS,x */

case &H64: MW.Zp &H00           '          /* STZ $ss ZP */
case &H74: MW.Zx &H00           '          /* STZ $ss,x ZP,x */
case &H9C: MW.Ab &H00           '          /* STZ $ssss ABS */
case &H9E: MW.Ax &H00           '          /* STZ $ssss,x ABS,x */

case &HF4: /* SET */
        I=Op6502(reg.PC.w);
        reg.pc.w = reg.pc.w + 1
        cycle=cycle + Cycles(I)+3;
        select case I 
        case &H65: MR.Zp I:M.ADCx I '       /* ADC $ss ZP */
        case &H6D: MR.Ab I:M.ADCx I '       /* ADC $ssss ABS */
        case &H69: MR.Im I:M.ADCx I '       /* ADC #$ss IMM */
        case &H75: MR.Zx I:m.ADCx I '       /* ADC $ss,x ZP,x */
        case &H79: MR.Ay I:M.ADCx I '       /* ADC $ssss,y ABS,y */
        case &H7D: MR.Ax I:M.ADCx I '       /* ADC $ssss,x ABS,x */
        case &H61: MR.Ix I:M.ADCx I '       /* ADC ($ss,x) INDEXINDIR */
        case &H71: MR.Iy I:M.ADCx I '       /* ADC ($ss),y INDIRINDEX */
        case &H72: MR.Id I:M.ADCx I '       /* ADC ($ss) INDIR */

        case &H25: MR.Zp I:M.ANDx I '       /* AND $ss ZP */
        case &H2D: MR.Ab I:M.ANDx I '       /* AND $ssss ABS */
        case &H29: MR.Im I:M.ANDx I '       /* AND #$ss IMM */
        case &H35: MR.Zx I:M.ANDx I '       /* AND $ss,x ZP,x */
        case &H39: MR.Ay I:M.ANDx I '       /* AND $ssss,y ABS,y */
        case &H3D: MR.Ax I:M.ANDx I '       /* AND $ssss,x ABS,x */
        case &H21: MR.Ix I:M.ANDx I '       /* AND ($ss,x) INDEXINDIR */
        case &H31: MR.Iy I:M.ANDx I '       /* AND ($ss),y INDIRINDEX */
        case &H32: MR.Id I:M.ANDx I '       /* AND ($ss) INDIR */

        case &H45: MR.Zp I):M.EORx I '       /* EOR $ss ZP */
        case &H4D: MR.Ab I):M.EORx i '       /* EOR $ssss ABS */
        case &H49: MR.Im I):M.EORx I '       /* EOR #$ss IMM */
        case &H55: MR.Zx I):M.EORx I '       /* EOR $ss,x ZP,x */
        case &H59: MR.Ay I):M.EORx I '       /* EOR $ssss,y ABS,y */
        case &H5D: MR.Ax I):M.EORx I '       /* EOR $ssss,x ABS,x */
        case &H41: MR.Ix I):M.EORx I '       /* EOR ($ss,x) INDEXINDIR */
        case &H51: MR.Iy I):M.EORx I '       /* EOR ($ss),y INDIRINDEX */
        case &H52: MR.Id I):M.EORx I '       /* EOR ($ss) INDIR */

        case &H05: MR.Zp I):M.ORAx I '       /* ORA $ss ZP */
        case &H0D: MR.Ab I):M.ORAx I '       /* ORA $ssss ABS */
        case &H09: MR.Im I):M.ORAx I '       /* ORA #$ss IMM */
        case &H15: MR.Zx I):M.ORAx I '       /* ORA $ss,x ZP,x */
        case &H19: MR.Ay I):M.ORAx I '       /* ORA $ssss,y ABS,y */
        case &H1D: MR.Ax I):M.ORAx I '       /* ORA $ssss,x ABS,x */
        case &H01: MR.Ix I):M.ORAx I '       /* ORA ($ss,x) INDEXINDIR */
        case &H11: MR.Iy I):M.ORAx I '       /* ORA ($ss),y INDIRINDEX */
        case &H12: MR.Id I):M.ORAx I '       /* ORA ($ss) INDIR */

	default:
		fprintf(stderr,"no sense SET\n");
		cycle-=Cycles[I];
		_PC_--;
		break;
	}
	break;

case &H03: IO.write 0,Op6502(reg.PC.w):reg.pc.w=reg.pc.w+1 '/* ST0 */
case &H13: IO.write 2,Op6502(reg.PC.w):reg.pc.w=reg.pc.w+1 '/* ST1 */
case &H23: IO.write 3,Op6502(reg.PC.w):reg.pc.w=reg.pc.w+1 '/* ST2 */

case &H43: '/* TMAi */
        I=Op6502(reg.PC.w):reg.pc.w=reg.pc.1+1
        
          for ii=0 to 7
              I = i \ 2 ^ 1

              if (I and 1) exit for
          
          '//reg.a = Reg.MPR[ii];
          '//reg.a = Reg.MPR[ii];
          reg.a = M.MPR[ii];
          next ii

case &H53: /* TAMi */
        I=Op6502(reg.PC.w):reg.pc.w = reg.pc.w + 1
	{int i;
         for ii=0 to 7
                I = I * 2 ^ 1
                if (I and 11) then
                        //R->MPR[ii]=reg.a;
                        //R.MPR[ii]=reg.a;
                        M.MPR[ii]=reg.a;
                        BANK_SET(ii,reg.a);
                end if
         next ii

case &HC3:' /* TDD */
        T_INIT
        do 
        Wr6502 dist,Rd6502(src)
        dist = dist - 1

        src= src -1
        length = length - 1
        loop while length+1
'        } while(--length);
        
        
        

case &H73:' /* TII */
        T_INIT
        do 
             Wr6502 dist,Rd6502(src)
             dist = dist + 1
                src = src + 1
        length = length - 1
        while length + 1
'        } while(--length);
        

case &HE3:' /* TIA */
        T_INIT
        do 
                Wr6502 dist  ,Rd6502(src)
                src=src + 1

                if not length then exit for
                ' if (!(--length)):break
                length = length - 1
                Wr6502 dist+1,Rd6502(src)
                src=src  +1
'        } while(--length);
        lenght = length - 1
        loop while length + 1
        

case &HF3:' /* TAI */
        T_INIT
        do 
                Wr6502 dist, Rd6502(src)
                dist = dist + 1
                'if (!(--length)) break;
                if not length - 1 then exit for
                Wr6502 dist,Rd6502(src+1);
                dist = dist + 1
         loop while length - 1
'        } while(--length);

case &HD3:' /* TIN */
        T_INIT
        do 
                Wr6502 dist,Rd6502(src)
                src=src + 1
        loop while length - 1

case &H14: MM.Zp TRB  '      /* TRB $ss ZP */
case &H1C: MM.Ab TRB  '      /* TRB $ssss ABS */

case &H04: MM.Zp TSB  '      /* TSB $ss ZP */
case &H0C: MM.Ab TSB  '      /* TSB $ssss ABS */

case &H83: '/* TST #$ss,$ss IMM,ZP */
        I=Op6502(reg.pc.w): J.B.l=RdRAM(MCZp())
        reg.pc.w = reg.pc.w + 1
'error
'        _nf=_VF=J.B.l: _ZF=I&J.B.l;
        
case &HA3: '/* TST #$ss,$ss,x IMM,ZP,x */
        I=Op6502(regPC.w): J.B.l=RdRAM(MCZx());
        reg.pc.w = reg.pc.w + 1
'error
'        _NF=_VF=J.B.l: _ZF=I&J.B.l;
case &H93: '/* TST #$ss,$ssss IMM,ABS */
        I=Op6502(reg.PC.w): MR.Ab J.B.l
        reg.pc.w = reg.pc.w + 1
'error
'        _NF=_VF=J.B.l; _ZF=I&J.B.l;

case &HB3: '/* TST #$ss,$ssss,x IMM,ABS,x */
        I=Op6502(reg.pc.w);MR.Ax J.B.l
        reg.pc.w = reg.pc.w + 1
'error
'        _NF=_VF=J.B.l; _ZF=I&J.B.l;

case &H0F: if  RdRAM(MCZp()) and &H01 then  reg.pc.w = reg.pc.w + reg.pc.w + 1 : else   M.JR    '      /* BBRi */
case &H1F: if  RdRAM(MCZp()) and &H02 then  reg.pc.w = reg.pc.w + reg.pc.w + 1 : else   M.JR           
case &H2F: if  RdRAM(MCZp()) and &H04 then  reg.pc.w = reg.pc.w + reg.pc.w + 1 : else   M.JR           
case &H3F: if  RdRAM(MCZp()) and &H08 then  reg.pc.w = reg.pc.w + reg.pc.w + 1 : else   M.JR          
case &H4F: if  RdRAM(MCZp()) and &H10 then  reg.pc.w = reg.pc.w + reg.pc.w + 1 : else   M.JR          
case &H5F: if  RdRAM(MCZp()) and &H20 then  reg.pc.w = reg.pc.w + reg.pc.w + 1 : else   M.JR          
case &H6F: if  RdRAM(MCZp()) and &H40 then  reg.pc.w = reg.pc.w + reg.pc.w + 1 : else   M.JR          
case &H7F: if  RdRAM(MCZp()) and &H80 then  reg.pc.w = reg.pc.w + reg.pc.w + 1 : else   M.JR          

case &H8F: if  RdRAM(MCZp()) and &H01 then    M.JR :   else reg.pc.w = reg.pc.w + reg.pc.w + 1  '      /* BBSi */
case &H9F: if  RdRAM(MCZp()) and &H02 then    M.JR :   else reg.pc.w = reg.pc.w + reg.pc.w + 1        
case &HAF: if  RdRAM(MCZp()) and &H04 then    M.JR :   else reg.pc.w = reg.pc.w + reg.pc.w + 1        
case &HBF: if  RdRAM(MCZp()) and &H08 then    M.JR :   else reg.pc.w = reg.pc.w + reg.pc.w + 1         
case &HCF: if  RdRAM(MCZp()) and &H10 then    M.JR :   else reg.pc.w = reg.pc.w + reg.pc.w + 1        
case &HDF: if  RdRAM(MCZp()) and &H20 then    M.JR :   else reg.pc.w = reg.pc.w + reg.pc.w + 1        
case &HEF: if  RdRAM(MCZp()) and &H40 then    M.JR :   else reg.pc.w = reg.pc.w + reg.pc.w + 1        
case &HFF: if  RdRAM(MCZp()) and &H80 then    M.JR :   else reg.pc.w = reg.pc.w + reg.pc.w + 1        

'#define M_RMB(n)        *AdrRAM(MCZp())&=~n
'#define M_SMB(n)        *AdrRAM(MCZp())|=n

case &H07: M.RMB &H01 '        /* RMBi */
case &H17: M.RMB &H02 '        /* RMBi */
case &H27: M.RMB &H04 '        /* RMBi */
case &H37: M.RMB &H08 '        /* RMBi */
case &H47: M.RMB &H10 '        /* RMBi */
case &H57: M.RMB &H20 '        /* RMBi */
case &H67: M.RMB &H40 '        /* RMBi */
case &H77: M.RMB &H80 '        /* RMBi */

case &H87: M.SMB &H01 '        /* SMBi */
case &H97: M.SMB &H02 '        /* SMBi */
case &HA7: M.SMB &H04 '        /* SMBi */
case &HB7: M.SMB &H08 '        /* SMBi */
case &HC7: M.SMB &H10 '        /* SMBi */
case &HD7: M.SMB &H20 '        /* SMBi */
case &HE7: M.SMB &H40 '        /* SMBi */
case &HF7: M.SMB &H80 '        /* SMBi */
