DECLARE FUNCTION MCAB% ()
DECLARE FUNCTION MCAX% ()
DECLARE FUNCTION MCAY% ()
DECLARE FUNCTION MCIX% ()
DECLARE FUNCTION MCIY% ()
DECLARE FUNCTION MCZY% ()
DECLARE SUB M.ADC (Rg%)
DECLARE SUB M.AND (Rg%)
DECLARE FUNCTION M.ASL% ()
DECLARE SUB M.BIT (Rg%)
DECLARE SUB M.CMP (RG1%, RG2%)
DECLARE FUNCTION M.DEC% ()
DECLARE SUB M.EOR (Rg%)
DECLARE SUB M.FL (Rg%)
DECLARE FUNCTION m.inc% ()
DECLARE SUB M.JR ()
DECLARE SUB M.LDWORD (Rg AS ANY)
DECLARE FUNCTION M.LSR% ()
DECLARE SUB M.ORA (Rg%)
DECLARE SUB M.POP (Rg%)
DECLARE SUB M.POP.P (Rg%)
DECLARE SUB M.PUSH (Rg%)
DECLARE SUB M.PUSH.P (Rg%)
DECLARE FUNCTION M.ROL% ()
DECLARE FUNCTION M.ROR% ()
DECLARE SUB M.SBC (Rg%)
DECLARE SUB MC.ID (Rg AS ANY)
DECLARE FUNCTION MCZp% ()
DECLARE FUNCTION MCZx% ()
DECLARE SUB MM.Ab (Rg%)
DECLARE SUB mm.ax (Rg%)
DECLARE SUB MM.Zp (RP%)
DECLARE SUB mm.zx (Rg%)
DECLARE SUB MR.Ax (Rg%)
DECLARE SUB MR.Ay (Rg%)
DECLARE SUB MR.ID (Rg%)
DECLARE SUB MR.Im (Rg%)
DECLARE SUB MR.Ix (Rg%)
DECLARE SUB MR.Iy (Rg%)
DECLARE SUB MR.Zp (Rg%)
DECLARE SUB MR.Zx (Rg%)
DECLARE SUB mr.zy (Rg%)
DECLARE SUB MW.Ab (Rg%)
DECLARE SUB MW.Ax (Rg%)
DECLARE SUB mw.ay (Rg%)
DECLARE SUB mw.ix (Rg%)
DECLARE SUB mw.iy (Rg%)
DECLARE SUB MW.Zp (Rg%)
DECLARE SUB MW.Zx (Rg%)
DECLARE SUB mw.zy (Rg%)
DECLARE FUNCTION op6502% (A%)
DECLARE SUB Wr6502 (A%, B%)
DECLARE SUB M.ADCx (Rg%)
DECLARE SUB MR.Ab (Rg%)
DECLARE SUB M.ANDx (Rg%)
DECLARE SUB M.EORx (Rg%)
DECLARE SUB M.ORAx (Rg%)
DECLARE SUB IO.write (A%, B%)
DECLARE SUB BANK.SET (A%, B%)
DECLARE SUB T_INIT ()
DECLARE FUNCTION rd6502% (A%)
DECLARE SUB M.RMB (Rg%)
DECLARE SUB M.SMB (Rg%)
DEFINT A-Z

TYPE bb  'change this around for lsb fists, last
l AS INTEGER
h AS INTEGER
END TYPE


TYPE PCC
 W AS INTEGER
 B AS bb
END TYPE
TYPE regg
 P AS INTEGER        'on byte register
 A AS INTEGER
 X AS INTEGER
 Y AS INTEGER
 S AS INTEGER
 PC AS PCC
 NF AS INTEGER
 VF AS INTEGER
 ZF AS INTEGER
 IRequest AS INTEGER
 ICount AS INTEGER
 IBackup AS INTEGER
 AfterCLI AS INTEGER
 IPeriod AS INTEGER
END TYPE


'byte = unsigned char (1)
'word = unsigned short (2)
'offset = signed char

'type pair
' word w
' int b {byte l,h}
'end type
' n
' n.w
' n.b (n.b.l,n.b.h)


                       '       /* 6502 status flags:         */
CONST C.FLAG = &H1     '       /* 1: Carry occured           */
CONST Z.FLAG = &H2     '       /* 1: Result is zero          */
CONST I.FLAG = &H4     '       /* 1: Interrupts disabled     */
CONST D.FLAG = &H8     '       /* 1: Decimal mode            */
CONST b.flag = &H10    '       /* Break [0 on stk after int] */
CONST r.flag = &H20    '       /* Always 1                   */
CONST V.FLAG = &H40    '       /* 1: Overflow occured        */
CONST N.FLAG = &H80    '       /* 1: Result is negative      */

'                      '       /* Loop6502() returns:        */
CONST int.none = 0     '       /* No interrupt required      */
CONST INT.IRQ = 1      '       /* Standard IRQ interrupt     */
CONST INT.NMI = 2      '       /* Non-maskable interrupt     */
CONST INT.QUIT = 3     '       /* Exit the emulation         */


DIM SHARED REG AS regg, K AS PCC, J AS PCC, Cycles%(255), zntable%(255), I
DIM SHARED m.mpr(), RdRAM(), AdrRAM()



RESTORE cycledata
FOR ii = 0 TO 255: READ Cycles%(ii): NEXT ii
RESTORE zntabledata
FOR ii = 0 TO 255: READ zntable%(ii): NEXT ii
END


cycledata:
'static byte Cycles[256] =
DATA  7,6,2,8,3,3,5,5,3,2,2,2,4,4,6,6
DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
DATA  6,6,2,8,3,3,5,5,4,2,2,2,4,4,6,6
DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
DATA  6,6,2,8,3,3,5,5,3,2,2,2,3,4,6,6
DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
DATA  6,6,2,8,3,3,5,5,4,2,2,2,5,4,6,6
DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
DATA  2,6,2,6,3,3,3,3,2,2,2,2,4,4,4,4
DATA  2,6,2,6,4,4,4,4,2,5,2,5,5,5,5,5
DATA  2,6,2,6,3,3,3,3,2,2,2,2,4,4,4,4
DATA  2,5,2,5,4,4,4,4,2,4,2,5,4,4,4,4
DATA  2,6,2,8,3,3,5,5,2,2,2,2,4,4,6,6
DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
DATA  2,6,2,8,3,3,5,5,2,2,2,2,4,4,6,6
DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7



zntabledata:
'byte ZNTable[256] =

'DATA  Z.FLAG,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

'new
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128









'old
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG

SUB BANK.SET (A%, B%)
END SUB

SUB codes (I)
SELECT CASE I
CASE &HD4'/* CSH set clock highspeed */
CASE &H54'/* CSL set clock lowspeed */

CASE &H44: '/* BSR * REL */
           M.PUSH REG.PC.B.h
           M.PUSH REG.PC.B.l

CASE &H80: '/* BRA * REL */
          REG.PC.W = REG.PC.W + (offset) * op6502(REG.PC.W) + 1


CASE &H7C: '/* JMP ($ssss,x) */
        M.LDWORD K: K.W = K.W + REG.X
        REG.PC.B.l = op6502(K.W)
        REG.PC.B.h = op6502(K.W + 1)

CASE &HDA: M.PUSH REG.X  '  /* PHX */

CASE &H5A: M.PUSH REG.Y '               /* PHY */
CASE &HFA: M.POP REG.X: M.FL REG.X '    /* PLX */
CASE &H7A: M.POP REG.Y: M.FL REG.Y'      /* PLY */

CASE &H62: REG.A = 0' /* CLA */
CASE &H82: REG.X = 0' /* CLX */
CASE &HC2: REG.Y = 0' /* CLY */

CASE &H2: I = REG.X: REG.X = REG.Y: REG.Y = I'  /* SXY */
CASE &H22: I = REG.A: REG.A = REG.X: REG.X = I'  /* SAX */
CASE &H42: I = REG.A: REG.A = REG.Y: REG.Y = I'  /* SAY */

CASE &H3A

': M.DEC reg.a                   ' /* DEC A */


CASE &H1A:
'
'M_INC reg.a                   ' /* INC A */
'

CASE &H72: MR.ID I: M.ADC I               '/* ADC ($ss) INDIR */
CASE &H32: MR.ID I: M.AND I               '/* AND ($ss) INDIR */
CASE &HD2: MR.ID I: M.CMP REG.A, I        '/* CMP ($ss) INDIR */
CASE &H52: MR.ID I: M.EOR I               '/* EOR ($ss) INDIR */
CASE &HB2: MR.ID REG.A: M.FL REG.A        '/* LDA ($ss) INDIR */
CASE &H12: MR.ID I: M.ORA I               '/* ORA ($ss) INDIR */
CASE &H92: MC.ID J: Wr6502 J.W, REG.A     '/* STA ($ss) INDIR */
CASE &HF2: MR.ID I: M.SBC I             '  /* SBC ($ss) INDIR */

CASE &H89: MR.Im I: M.BIT I  '              /* BIT #$ss IMM */
CASE &H34: MR.Zx I: M.BIT I  '              /* BIT $ss,x ZP,x */
CASE &H3C: MR.Ax I: M.BIT I  '              /* BIT $ssss,x ABS,x */

CASE &H64: MW.Zp &H0            '          /* STZ $ss ZP */
CASE &H74: MW.Zx &H0            '          /* STZ $ss,x ZP,x */
CASE &H9C: MW.Ab &H0            '          /* STZ $ssss ABS */
CASE &H9E: MW.Ax &H0            '          /* STZ $ssss,x ABS,x */

CASE &HF4: ' /* SET */
        I = op6502(REG.PC.W)
        REG.PC.W = REG.PC.W + 1
        CYCLE = CYCLE + Cycles(I) + 3
        SELECT CASE I
        CASE &H65: MR.Zp I: M.ADCx I'       /* ADC $ss ZP */
        CASE &H6D: MR.Ab I: M.ADCx I'       /* ADC $ssss ABS */
        CASE &H69: MR.Im I: M.ADCx I'       /* ADC #$ss IMM */
        CASE &H75: MR.Zx I: M.ADCx I'       /* ADC $ss,x ZP,x */
        CASE &H79: MR.Ay I: M.ADCx I'       /* ADC $ssss,y ABS,y */
        CASE &H7D: MR.Ax I: M.ADCx I'       /* ADC $ssss,x ABS,x */
        CASE &H61: MR.Ix I: M.ADCx I'       /* ADC ($ss,x) INDEXINDIR */
        CASE &H71: MR.Iy I: M.ADCx I'       /* ADC ($ss),y INDIRINDEX */
        CASE &H72: MR.ID I: M.ADCx I'       /* ADC ($ss) INDIR */

        CASE &H25: MR.Zp I: M.ANDx I'       /* AND $ss ZP */
        CASE &H2D: MR.Ab I: M.ANDx I'       /* AND $ssss ABS */
        CASE &H29: MR.Im I: M.ANDx I'       /* AND #$ss IMM */
        CASE &H35: MR.Zx I: M.ANDx I'       /* AND $ss,x ZP,x */
        CASE &H39: MR.Ay I: M.ANDx I'       /* AND $ssss,y ABS,y */
        CASE &H3D: MR.Ax I: M.ANDx I'       /* AND $ssss,x ABS,x */
        CASE &H21: MR.Ix I: M.ANDx I'       /* AND ($ss,x) INDEXINDIR */
        CASE &H31: MR.Iy I: M.ANDx I'       /* AND ($ss),y INDIRINDEX */
        CASE &H32: MR.ID I: M.ANDx I'       /* AND ($ss) INDIR */

        CASE &H45: MR.Zp I: M.EORx I '       /* EOR $ss ZP */
        CASE &H4D: MR.Ab I: M.EORx I '       /* EOR $ssss ABS */
        CASE &H49: MR.Im I: M.EORx I '       /* EOR #$ss IMM */
        CASE &H55: MR.Zx I: M.EORx I '       /* EOR $ss,x ZP,x */
        CASE &H59: MR.Ay I: M.EORx I '       /* EOR $ssss,y ABS,y */
        CASE &H5D: MR.Ax I: M.EORx I '       /* EOR $ssss,x ABS,x */
        CASE &H41: MR.Ix I: M.EORx I '       /* EOR ($ss,x) INDEXINDIR */
        CASE &H51: MR.Iy I: M.EORx I '       /* EOR ($ss),y INDIRINDEX */
        CASE &H52: MR.ID I: M.EORx I '       /* EOR ($ss) INDIR */

        CASE &H5: MR.Zp I: M.ORAx I  '       /* ORA $ss ZP */
        CASE &HD: MR.Ab I: M.ORAx I  '       /* ORA $ssss ABS */
        CASE &H9: MR.Im I: M.ORAx I  '       /* ORA #$ss IMM */
        CASE &H15: MR.Zx I: M.ORAx I '       /* ORA $ss,x ZP,x */
        CASE &H19: MR.Ay I: M.ORAx I '       /* ORA $ssss,y ABS,y */
        CASE &H1D: MR.Ax I: M.ORAx I '       /* ORA $ssss,x ABS,x */
        CASE &H1: MR.Ix I: M.ORAx I  '       /* ORA ($ss,x) INDEXINDIR */
        CASE &H11: MR.Iy I: M.ORAx I '       /* ORA ($ss),y INDIRINDEX */
        CASE &H12: MR.ID I: M.ORAx I '       /* ORA ($ss) INDIR */

        CASE ELSE
        PRINT ERR, "no sense SET"
        CYCLE = CYCLE - Cycles(I)


        END SELECT

CASE &H3: IO.write 0, op6502(REG.PC.W): REG.PC.W = REG.PC.W + 1'/* ST0 */
CASE &H13: IO.write 2, op6502(REG.PC.W): REG.PC.W = REG.PC.W + 1'/* ST1 */
CASE &H23: IO.write 3, op6502(REG.PC.W): REG.PC.W = REG.PC.W + 1'/* ST2 */

CASE &H43: '/* TMAi */
        I = op6502(REG.PC.W): REG.PC.W = REG.PC.W + 1

          FOR ii = 0 TO 7
              I = I \ 2 ^ 1

              IF (I AND 1) THEN EXIT FOR

          '//reg.a = Reg.MPR[ii]
          '//reg.a = Reg.MPR[ii]
          REG.A = m.mpr(ii)
          NEXT ii

CASE &H53: '/* TAMi */
        I = op6502(REG.PC.W): REG.PC.W = REG.PC.W + 1

         FOR ii = 0 TO 7
                I = I * 2 ^ 1
                IF (I AND 11) THEN
                        '//R->MPR[ii]=reg.a;
                        '//R.MPR[ii]=reg.a;
                        m.mpr(ii) = REG.A
                        BANK.SET ii, REG.A
                END IF
         NEXT ii

CASE &HC3: ' /* TDD */
        T_INIT
        DO
        Wr6502 dist, rd6502(src)
        dist = dist - 1

        src = src - 1
        length = length - 1
        LOOP WHILE length
'        } while(--length);




CASE &H73: ' /* TII */
        T_INIT
        DO
             Wr6502 dist, rd6502(src)
             dist = dist + 1
                src = src + 1
        length = length - 1
        LOOP WHILE length
'        } while(--length);


CASE &HE3: ' /* TIA */
        T_INIT
        DO
                Wr6502 dist, rd6502(src)
                src = src + 1

                IF NOT length THEN EXIT DO
                ' if (!(--length)):break
                length = length - 1
                Wr6502 dist + 1, rd6502(src)
                src = src + 1
'        } while(--length);
        lenght = length - 1
        LOOP WHILE length


CASE &HF3: ' /* TAI */
        T_INIT
        DO
                Wr6502 dist, rd6502(src)
                dist = dist + 1
                'if (!(--length)) break;
                length = length - 1
                IF NOT length THEN EXIT DO
                Wr6502 dist, rd6502(src + 1)
                dist = dist + 1

         length = length - 1
         LOOP WHILE length
'        } while(--length);

CASE &HD3: ' /* TIN */
        T_INIT
        DO
                Wr6502 dist, rd6502(src)
                src = src + 1
        length = length - 1
        LOOP WHILE length

CASE &H14: MM.Zp TRB  '      /* TRB $ss ZP */
CASE &H1C: MM.Ab TRB  '      /* TRB $ssss ABS */

CASE &H4: MM.Zp TSB   '      /* TSB $ss ZP */
CASE &HC: MM.Ab TSB   '      /* TSB $ssss ABS */

CASE &H83: '/* TST #$ss,$ss IMM,ZP */
        I = op6502(REG.PC.W): J.B.l = RdRAM(MCZp())
        REG.PC.W = REG.PC.W + 1
'error    NF = VF = J.B.L
        REG.NF = J.B.l
        REG.VF = J.B.l: REG.ZF = I AND J.B.l

CASE &HA3: '/* TST #$ss,$ss,x IMM,ZP,x */
        I = op6502(regPC.w): J.B.l = RdRAM(MCZx())
        REG.PC.W = REG.PC.W + 1

'error REG,NF = REG.VF = J.B.L
        REG.NF = J.B.l
        REG.VF = J.B.l: REG.ZF = I AND J.B.l
CASE &H93: '/* TST #$ss,$ssss IMM,ABS */
        I = op6502(REG.PC.W): MR.Ab J.B.l
        REG.PC.W = REG.PC.W + 1
'error
        REG.NF = J.B.l
         REG.VF = J.B.l: REG.ZF = I AND J.B.l

CASE &HB3: '/* TST #$ss,$ssss,x IMM,ABS,x */
        I = op6502(REG.PC.W): MR.Ax J.B.l
        REG.PC.W = REG.PC.W + 1
'error
        REG.NF = J.B.l
        REG.VF = J.B.l: REG.ZF = I AND J.B.l

CASE &HF: IF RdRAM(MCZp()) AND &H1 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR          '      /* BBRi */
CASE &H1F: IF RdRAM(MCZp()) AND &H2 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR
CASE &H2F: IF RdRAM(MCZp()) AND &H4 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR
CASE &H3F: IF RdRAM(MCZp()) AND &H8 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR
CASE &H4F: IF RdRAM(MCZp()) AND &H10 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR
CASE &H5F: IF RdRAM(MCZp()) AND &H20 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR
CASE &H6F: IF RdRAM(MCZp()) AND &H40 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR
CASE &H7F: IF RdRAM(MCZp()) AND &H80 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR

CASE &H8F: IF RdRAM(MCZp()) AND &H1 THEN M.JR:         ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1  '      /* BBSi */
CASE &H9F: IF RdRAM(MCZp()) AND &H2 THEN M.JR:         ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1
CASE &HAF: IF RdRAM(MCZp()) AND &H4 THEN M.JR:         ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1
CASE &HBF: IF RdRAM(MCZp()) AND &H8 THEN M.JR:         ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1
CASE &HCF: IF RdRAM(MCZp()) AND &H10 THEN M.JR:        ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1
CASE &HDF: IF RdRAM(MCZp()) AND &H20 THEN M.JR:        ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1
CASE &HEF: IF RdRAM(MCZp()) AND &H40 THEN M.JR:        ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1
CASE &HFF: IF RdRAM(MCZp()) AND &H80 THEN M.JR:        ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1

'#define M_RMB(n)        *AdrRAM(MCZp())&=~n
'#define M_SMB(n)        *AdrRAM(MCZp())|=n

CASE &H7: M.RMB &H1   '        /* RMBi */
CASE &H17: M.RMB &H2  '        /* RMBi */
CASE &H27: M.RMB &H4  '        /* RMBi */
CASE &H37: M.RMB &H8  '        /* RMBi */
CASE &H47: M.RMB &H10 '        /* RMBi */
CASE &H57: M.RMB &H20 '        /* RMBi */
CASE &H67: M.RMB &H40 '        /* RMBi */
CASE &H77: M.RMB &H80 '        /* RMBi */

CASE &H87: M.SMB &H1  '        /* SMBi */
CASE &H97: M.SMB &H2  '        /* SMBi */
CASE &HA7: M.SMB &H4  '        /* SMBi */
CASE &HB7: M.SMB &H8  '        /* SMBi */
CASE &HC7: M.SMB &H10 '        /* SMBi */
CASE &HD7: M.SMB &H20 '        /* SMBi */
CASE &HE7: M.SMB &H40 '        /* SMBi */
CASE &HF7: M.SMB &H80 '        /* SMBi */








CASE &H10: IF (REG.NF AND N.FLAG) THEN REG.PC.W = REG.PC.W + 1:  ELSE M.JR'/* BPL * REL */
CASE &H30: IF (REG.NF AND N.FLAG) THEN M.JR:  ELSE REG.PC.W = REG.PC.W + 1'/* BMI * REL */
CASE &HD0: IF (NOT REG.ZF) THEN REG.PC.W = REG.PC.W + 1 ELSE : M.JR      '/* BNE * REL */
CASE &HF0: IF (NOT REG.ZF) THEN M.JR ELSE : REG.PC.W = REG.PC.W + 1      '/* BEQ * REL */
CASE &H90: IF (REG.P AND C.FLAG) THEN REG.PC.W = REG.PC.W + 1 ELSE : M.JR'/* BCC * REL */
CASE &HB0: IF (REG.P AND C.FLAG) THEN M.JR ELSE : REG.PC.W = REG.PC.W + 1'/* BCS * REL */
CASE &H50: IF (REG.VF AND V.FLAG) THEN REG.PC.W = REG.PC.W + 1 ELSE M.JR'/* BVC * REL */
CASE &H70: IF (REG.VF AND V.FLAG) THEN M.JR ELSE : REG.PC.W = REG.PC.W + 1'/* BVS * REL */


CASE &H40: '/* RTI */

  I = REG.P


  M.POP.P REG.P

  IF ((REG.IRequest <> int.none) AND (I AND I.FLAG) <> 0 AND NOT (REG.P AND I.FLAG) <> 0) THEN
     REGAfterCLI = 1
    REG.IBackup = REG.ICount
    REG.ICount = 0
    END IF
    M.POP REG.PC.B.l
    M.POP REG.PC.B.h



CASE &H60: '/* RTS */
  M.POP REG.PC.B.l: M.POP REG.PC.B.h: REG.PC.W = REG.PC.W + 1


CASE &H20: '/* JSR $ssss ABS */
  K.B.l = op6502(REG.PC.W)
  REG.PC.W = REG.PC.W + 1
  K.B.h = op6502(REG.PC.W)
  M.PUSH (REG.PC.B.h)
  M.PUSH (REG.PC.B.l)
  REG.PC = K


CASE &H4C: M.LDWORD K: REG.PC = K'/* JMP $ssss ABS */


CASE &H6C: '/* JMP ($ssss) ABDINDIR */
  M.LDWORD K
  REG.PC.B.l = op6502(K.W)
  K.W = K.W + 1
  REG.PC.B.h = op6502(K.W)



CASE &H0: '/* BRK */
  REG.PC.W = REG.PC.W + 1
  M.PUSH REG.PC.B.h: M.PUSH REG.PC.B.l
  M.PUSH.P REG.P AND NOT (T.FLAG) OR (b.flag)
  REG.P = (REG.P OR I.FLAG) AND NOT (D.FLAG)
  REG.PC.B.l = op6502(VEC.BRK)
  REG.PC.B.h = op6502(VEC.BRK + 1)

  PRINT ERR, "BRK instruction"
  END



CASE &H58: '/* CLI */
  IF ((REG.IRequest <> int.none) AND (REG.P AND I.FLAG) <> 0) THEN
  
    REG.AfterCLI = 1
    REG.IBackup = REG.ICount
    REG.ICount = 0

  END IF
  REG.P = REG.P AND NOT (I.FLAG)



CASE &H28: '/* PLP */
  M.POP.P I

  IF ((REG.IRequest <> int.none) AND ((I XOR REG.P) AND NOT (I) AND I.FLAG) <> 0) THEN

    REG.AfterCLI = 1
    REG.IBackup = REG.ICount
    REG.ICount = 0

  END IF
  REG.P = I



CASE &H8: M.PUSH.P REG.P AND NOT (T.FLAG) OR b.flag'     /* PHP */
CASE &H18: REG.P = REG.P AND NOT (C.FLAG)          '     /* CLC */
CASE &HB8: REG.VF = 0                              '     /* CLV */
CASE &HD8: REG.P = REG.P AND NOT (D.FLAG)          '     /* CLD */
CASE &H38: REG.P = REG.P OR C.FLAG                 '     /* SEC */
CASE &HF8: REG.P = REG.P OR D.FLAG                 '     /* SED */
CASE &H78: REG.P = REG.P OR I.FLAG                 '     /* SEI */
CASE &H48: M.PUSH REG.A          '             /* PHA */
CASE &H68: M.POP REG.A: M.FL REG.A       '     /* PLA */
CASE &H98: REG.A = REG.Y: M.FL REG.A     '     /* TYA */
CASE &HA8: REG.Y = REG.A: M.FL REG.Y     '     /* TAY */
CASE &HC8: REG.Y = REG.Y + 1: M.FL REG.Y '     /* INY */
CASE &H88: REG.Y = REG.Y - 1: M.FL REG.Y '     /* DEY */
CASE &H8A: REG.A = REG.X: M.FL REG.A     '     /* TXA */
CASE &HAA: REG.X = REG.A: M.FL REG.X     '     /* TAX */
CASE &HE8: REG.X = REG.X + 1: M.FL REG.X '     /* INX */
CASE &HCA: REG.X = REG.X - 1: M.FL REG.X '     /* DEX */
CASE &HEA:  '                                  /* NOP */
CASE &H9A: REG.S = REG.X                 '     /* TXS */
CASE &HBA: REG.X = REG.S: M.FL REG.X     '     /* TSX */

CASE &H24: MR.Zp I: M.BIT I            '  /* BIT $ss ZP */
CASE &H2C: MR.Ab I: M.BIT I            '  /* BIT $ssss ABS */

CASE &H5: MR.Zp I: M.ORA I             '  /* ORA $ss ZP */
CASE &H6: MM.Zp M.ASL                  '  /* ASL $ss ZP */
CASE &H25: MR.Zp I: M.AND I            '  /* AND $ss ZP */
CASE &H26: MM.Zp M.ROL                 '  /* ROL $ss ZP */
CASE &H45: MR.Zp I: M.EOR I            '  /* EOR $ss ZP */
CASE &H46: MM.Zp M.LSR                 '  /* LSR $ss ZP */
CASE &H65: MR.Zp I: M.ADC (I)          '  /* ADC $ss ZP */
CASE &H66: MM.Zp M.ROR                 '  /* ROR $ss ZP */
CASE &H84: MW.Zp REG.Y                 '  /* STY $ss ZP */
CASE &H85: MW.Zp REG.A                 '  /* STA $ss ZP */
CASE &H86: MW.Zp REG.X                 '  /* STX $ss ZP */
CASE &HA4: MR.Zp REG.Y: M.FL REG.Y     '  /* LDY $ss ZP */
CASE &HA5: MR.Zp REG.A: M.FL REG.A     '  /* LDA $ss ZP */
'/BaH
'/case &HA5: R.A = RAM[ (Op6502(R.PC.W++)) ]  ;break;
'/CAUTION ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
CASE &HA6: MR.Zp REG.X: M.FL REG.X     '  /* LDX $ss ZP */
CASE &HC4: MR.Zp I: M.CMP REG.Y, I     '  /* CPY $ss ZP */
CASE &HC5: MR.Zp I: M.CMP REG.A, I     '  /* CMP $ss ZP */
CASE &HC6: MM.Zp M.DEC                 '  /* DEC $ss ZP */
CASE &HE4: MR.Zp I: M.CMP REG.X, I     '  /* CPX $ss ZP */
CASE &HE5: MR.Zp I: M.SBC I            '  /* SBC $ss ZP */
CASE &HE6: MM.Zp m.inc                 '  /* INC $ss ZP */

CASE &HD: MR.Ab I: M.ORA I             '  /* ORA $ssss ABS */
CASE &HE: MM.Ab M.ASL                  '  /* ASL $ssss ABS */
CASE &H2D: MR.Ab I: M.AND I            '  /* AND $ssss ABS */
CASE &H2E: MM.Ab M.ROL                 '  /* ROL $ssss ABS */
CASE &H4D: MR.Ab I: M.EOR I            '  /* EOR $ssss ABS */
CASE &H4E: MM.Ab M.LSR                 '  /* LSR $ssss ABS */
CASE &H6D: MR.Ab I: M.ADC I            '  /* ADC $ssss ABS */
CASE &H6E: MM.Ab M.ROR                 '  /* ROR $ssss ABS */
CASE &H8C: MW.Ab REG.Y                 '  /* STY $ssss ABS */
CASE &H8D: MW.Ab REG.A                 '  /* STA $ssss ABS */
CASE &H8E: MW.Ab REG.X                 '  /* STX $ssss ABS */
CASE &HAC: MR.Ab REG.Y: M.FL REG.Y     '  /* LDY $ssss ABS */
CASE &HAD: MR.Ab REG.A: M.FL REG.A     '  /* LDA $ssss ABS */
CASE &HAE: MR.Ab REG.X: M.FL REG.X     '  /* LDX $ssss ABS */
CASE &HCC: MR.Ab I: M.CMP REG.Y, I     '  /* CPY $ssss ABS */
CASE &HCD: MR.Ab I: M.CMP REG.A, I     '  /* CMP $ssss ABS */
CASE &HCE: MM.Ab M.DEC                 '  /* DEC $ssss ABS */
CASE &HEC: MR.Ab I: M.CMP REG.X, I     '  /* CPX $ssss ABS */
CASE &HED: MR.Ab I: M.SBC I            '  /* SBC $ssss ABS */
CASE &HEE: MM.Ab m.inc                 '  /* INC $ssss ABS */

CASE &H9: MR.Im I: M.ORA I             '  /* ORA #$ss IMM */
CASE &H29: MR.Im I: M.AND I            '  /* AND #$ss IMM */
CASE &H49: MR.Im I: M.EOR I            '  /* EOR #$ss IMM */
CASE &H69: MR.Im I: M.ADC I            '  /* ADC #$ss IMM */
CASE &HA0: MR.Im REG.Y: M.FL REG.Y     '  /* LDY #$ss IMM */
CASE &HA2: MR.Im REG.X: M.FL REG.X     '  /* LDX #$ss IMM */
CASE &HA9: MR.Im REG.A: M.FL REG.A     '  /* LDA #$ss IMM */
CASE &HC0: MR.Im I: M.CMP REG.Y, I     '  /* CPY #$ss IMM */
CASE &HC9: MR.Im I: M.CMP REG.A, I     '  /* CMP #$ss IMM */
CASE &HE0: MR.Im I: M.CMP REG.X, I     '  /* CPX #$ss IMM */
CASE &HE9: MR.Im I: M.SBC I            '  /* SBC #$ss IMM */

CASE &H15: MR.Zx I: M.ORA I            '  /* ORA $ss,x ZP,x */
CASE &H16: mm.zx M.ASL                 '  /* ASL $ss,x ZP,x */
CASE &H35: MR.Zx I: M.AND I            '  /* AND $ss,x ZP,x */
CASE &H36: mm.zx M.ROL                 '  /* ROL $ss,x ZP,x */
CASE &H55: MR.Zx I: M.EOR (I)          '  /* EOR $ss,x ZP,x */
CASE &H56: mm.zx M.LSR                 '  /* LSR $ss,x ZP,x */
CASE &H75: MR.Zx I: M.ADC I            '  /* ADC $ss,x ZP,x */
CASE &H76: mm.zx M_ROR                 '  /* ROR $ss,x ZP,x */
CASE &H94: MW.Zx REG.Y                 '  /* STY $ss,x ZP,x */
CASE &H95: MW.Zx REG.A                 '  /* STA $ss,x ZP,x */
CASE &H96: mw.zy REG.X                 '  /* STX $ss,y ZP,y */
CASE &HB4: MR.Zx REG.Y: M.FL REG.Y     '  /* LDY $ss,x ZP,x */
CASE &HB5: MR.Zx REG.A: M.FL REG.A     '  /* LDA $ss,x ZP,x */
CASE &HB6: mr.zy REG.X: M.FL REG.X     '  /* LDX $ss,y ZP,y */
CASE &HD5: MR.Zx I: M.CMP REG.A, I     '  /* CMP $ss,x ZP,x */
CASE &HD6: mm.zx M.DEC                 '  /* DEC $ss,x ZP,x */
CASE &HF5: MR.Zx I: M.SBC (I)          '  /* SBC $ss,x ZP,x */
CASE &HF6: mm.zx m.inc                 '  /* INC $ss,x ZP,x */

CASE &H19: MR.Ay I: M.ORA I            '  /* ORA $ssss,y ABS,y */
CASE &H1D: MR.Ax I: M.ORA I            '  /* ORA $ssss,x ABS,x */
CASE &H1E: mm.ax M.ASL                 '  /* ASL $ssss,x ABS,x */
CASE &H39: MR.Ay I: M.AND I            '  /* AND $ssss,y ABS,y */
CASE &H3D: MR.Ax I: M.AND I            '  /* AND $ssss,x ABS,x */
CASE &H3E: mm.ax M.ROL                 '  /* ROL $ssss,x ABS,x */
CASE &H59: MR.Ay I: M.EOR I            '  /* EOR $ssss,y ABS,y */
CASE &H5D: MR.Ax I: M.EOR I            '  /* EOR $ssss,x ABS,x */
CASE &H5E: mm.ax M.LSR                 '  /* LSR $ssss,x ABS,x */
CASE &H79: MR.Ay I: M.ADC I            '  /* ADC $ssss,y ABS,y */
CASE &H7D: MR.Ax I: M.ADC I            '  /* ADC $ssss,x ABS,x */
CASE &H7E: mm.ax M.ROR                 '  /* ROR $ssss,x ABS,x */
CASE &H99: mw.ay REG.A                 '  /* STA $ssss,y ABS,y */
CASE &H9D: MW.Ax REG.A                 '  /* STA $ssss,x ABS,x */
CASE &HB9: MR.Ay REG.A: M.FL REG.A     '  /* LDA $ssss,y ABS,y */
CASE &HBC: MR.Ax REG.Y: M.FL REG.Y     '  /* LDY $ssss,x ABS,x */
CASE &HBD: MR.Ax REG.A: M.FL REG.A     '  /* LDA $ssss,x ABS,x */
CASE &HBE: MR.Ay REG.X: M.FL REG.X     '  /* LDX $ssss,y ABS,y */
CASE &HD9: MR.Ay I: M.CMP REG.A, I     '  /* CMP $ssss,y ABS,y */
CASE &HDD: MR.Ax I: M.CMP REG.A, I     '  /* CMP $ssss,x ABS,x */
CASE &HDE: mm.ax M.DEC                 '  /* DEC $ssss,x ABS,x */
CASE &HF9: MR.Ay I: M.SBC I            '  /* SBC $ssss,y ABS,y */
CASE &HFD: MR.Ax I: M.SBC I            '  /* SBC $ssss,x ABS,x */
CASE &HFE: mm.ax m.inc                 '  /* INC $ssss,x ABS,x */

CASE &H1: MR.Ix I: M.ORA I             '  /* ORA ($ss,x) INDEXINDIR */
CASE &H11: MR.Iy I: M.ORA I            '  /* ORA ($ss),y INDIRINDEX */
CASE &H21: MR.Ix I: M.AND I            '  /* AND ($ss,x) INDEXINDIR */
CASE &H31: MR.Iy I: M.AND I            '  /* AND ($ss),y INDIRINDEX */
CASE &H41: MR.Ix I: M.EOR I            '  /* EOR ($ss,x) INDEXINDIR */
CASE &H51: MR.Iy I: M.EOR I            '  /* EOR ($ss),y INDIRINDEX */
CASE &H61: MR.Ix I: M.ADC I            '  /* ADC ($ss,x) INDEXINDIR */
CASE &H71: MR.Iy I: M.ADC I            '  /* ADC ($ss),y INDIRINDEX */
CASE &H81: mw.ix REG.A                 '  /* STA ($ss,x) INDEXINDIR */
CASE &H91: mw.iy REG.A                 '  /* STA ($ss),y INDIRINDEX */
CASE &HA1: MR.Ix REG.A: M.FL REG.A     '  /* LDA ($ss,x) INDEXINDIR */
CASE &HB1: MR.Iy REG.A: M.FL REG.A     '  /* LDA ($ss),y INDIRINDEX */
CASE &HC1: MR.Ix I: M.CMP REG.A, I     '  /* CMP ($ss,x) INDEXINDIR */
CASE &HD1: MR.Iy I: M.CMP REG.A, I     '  /* CMP ($ss),y INDIRINDEX */
CASE &HE1: MR.Ix I: M.SBC I            '  /* SBC ($ss,x) INDEXINDIR */
CASE &HF1: MR.Iy I: M.SBC I            '  /* SBC ($ss),y INDIRINDEX */

CASE &HA:
'
'M.ASL reg.a                  '  /* ASL a ACC */
'
CASE &H2A:
'
'M.ROL reg.a                 '  /* ROL a ACC */
'

CASE &H4A:
'
'M.LSR reg.a                 '  /* LSR a ACC */
'
CASE &H6A:
'
'M.ROR reg.a                 '  /* ROR a ACC */
'
CASE ELSE
'default:
'  if(_TrapBadOps) {
'    fprintf
'    ( stderr,
'      "[M6502 %lX] Unrecognized instruction: $%02X at PC=$%04X\n",
'      (unsigned)_User,Op6502(REG.PC.W-1),(word)(REG.PC.W-1)
'    );
'
'    _Trace=1;
'
'  }
'
'  break;
END SELECT



END SUB

SUB IO.write (A%, B%)
END SUB

SUB M.ADC (Rg)
  IF (REG.P AND D.FLAG) THEN
  
  K.B.l = (REG.A AND &HF) + (Rg AND &HF) + (REG.P AND C.FLAG)
  K.B.h = (REG.A \ 2 ^ 4) + (Rg \ 2 ^ 4)
    IF (K.B.l > 9) THEN K.B.l = K.B.l + 6: K.B.h = K.B.h + 1
    IF (K.B.h > 9) THEN K.B.h = K.B.h + 6
    REG.A = (K.B.l AND &HF) OR (K.B.h * 2 ^ 4)
    IF K.B.h > 15 THEN TMP = C.FLAG:  ELSE TMP = 0
    REG.P = (REG.P AND NOT (C.FLAG)) OR TMP
    'ZF = NF = A
    REG.ZF = REG.A
    REG.NF = REG.A
                CYCLE = CYCLE + 1
  
  ELSE
  
    K.W = REG.A + Rg + (REG.P AND C.FLAG)
    REG.P = REG.P AND NOT (C.FLAG)
    IF K.B.h THEN TMP = C.FLAG:  ELSE TMP = 0
    REG.P = REG.P OR TMP
    'ZF=NF=K.B.L
    REG.ZF = K.B.l
    REG.NF = K.B.l
    REG.A = K.B.l
   END IF

END SUB

SUB M.ADCx (Rg)

 MX = ADRAM(REG.X + ZP)
  IF (REG.P AND D.FLAG) THEN
  
    K.B.l = (MX AND &HF) + (Rg AND &HF) + (REG.P AND C.FLAG)
    K.B.h = (MX \ 2 ^ 4) + (Rg \ 2 ^ 4)';/*+(K.B.l>>4);*/ \
    IF (K.B.l > 9) THEN K.B.l = K.B.l + 6: K.B.h = K.B.h + 1
    IF (K.B.h > 9) THEN K.B.h = K.B.h + 6
    MX = (K.B.l AND &HF) OR (K.B.h * 2 ^ 4)
            CYCLE = CYCLE + 1
  
  ELSE
  
    K.W = MX + Rg + (REG.P AND C.FLAG)
                    MX = K.B.l
  
 END IF
 ADRAM(REG.X + ZP) = MX
END SUB

SUB M.AND (Rg)
REG.A = REG.A AND Rg
M.FL REG.A
END SUB

SUB M.ANDx (Rg)
ADRAM(REG.X + ZP) = ADRAM(REG.X + ZP) AND Rg
M.FL RdRAM(REG.X + ZP)
END SUB

FUNCTION M.ASL ()
REG.P = REG.P AND NOT (C.FLAG)
REG.P = REG.P OR Rg \ 2 ^ 7
Rg = Rg * 2 ^ 1
M.FL Rg
END FUNCTION

SUB M.BIT (Rg)
REG.NF = Rg
REG.VF = Rg
REG.ZF = Rg AND REG.A

END SUB

SUB M.CMP (RG1, RG2)
K.W = RG1 - RG2
REG.P = REG.P AND NOT (C.FLAG)
IF K.B.K THEN TMP = 0 ELSE TMP = C.FLAG
REG.P = REG.P OR TMP
'ZF = NF = K.B.L
REG.ZF = K.B.l
REG.NF = K.B.l

END SUB

FUNCTION M.DEC (Rg)
Rg = Rg - 1
M.FL Rg
END FUNCTION

SUB M.EOR (Rg)
REG.A = REG.A XOR Rg
M.FL REG.A
END SUB

SUB M.EORx (Rg)
ADRAM(REG.X + ZP) = ADRAM(REG.X + ZP) XOR Rg
M.FL RdRAM(REG.X + ZP)

END SUB

SUB M.FL (Rg)
'ZF=NF=RG
REG.ZF = Rg
REG.NF = Rg
END SUB

FUNCTION m.inc (Rg)
Rg = Rg + 1
M.FL Rg
END FUNCTION

DEFSNG A-Z
SUB M.JR ()
END SUB

DEFINT A-Z
SUB M.LDWORD (Rg AS PCC)
Rg.B.l = op6502(REG.PC.W)
Rg.B.h = op6502(REG.PC.W + 1)
REG.PC.W = REG.PC.W + 2
END SUB

FUNCTION M.LSR (Rg)
REG.P = REG.P AND NOT (C.FLAG)
REG.P = REG.P OR (Rg AND C.FLAG)
Rg = Rg \ 2 ^ 1
M.FL Rg

END FUNCTION

SUB M.ORA (Rg)
REG.A = REG.A OR Rg
M.FL REG.A
END SUB

SUB M.ORAx (Rg)
ADRAM(REG.X + ZP) = ADRAM(REG.X + ZP) OR Rg
M.FL RdRAM(REG.X + ZP)

END SUB

SUB M.POP (Rg)
REG.S = REG.S + 1
Rg = RdRAM(SP + 6)
END SUB

SUB M.POP.P (Rg)
'NF=VF=RG
M.POP Rg
REG.NF = Rg
REG.VF = Rg
IF Rg AND Z.FLAG THEN TMP = 0 ELSE TMP = 1
REG.ZF = Rg AND TMP
END SUB

SUB M.PUSH (Rg)
WRRAM SP + REG.S, Rg
REG.S = REG.S - 1

END SUB

SUB M.PUSH.P (Rg)
IF REG.ZF THEN TMP = 0 ELSE TMP = Z.FLAG
M.PUSH ((Rg) AND NOT (N.FLAG OR V.FLAG OR Z.FLAG)) OR (REG.NF AND N.FLAG) OR (REG.VF AND V.FLAG) OR TMP
END SUB

SUB M.RMB (Rg)
END SUB

FUNCTION M.ROL (Rg)
K.B.l = (Rg * 2 ^ 1) OR (REG.P AND C.FLAG)
REG.P = REG.P AND NOT (C.FLAG)
REG.P = REG.P OR (Rg \ 2 ^ 7)
Rg = K.B.l
M.FL Rg
END FUNCTION

FUNCTION M.ROR ()
K.B.l = (Rg \ 2 ^ 1) OR (REG.P * 2 ^ 7)
REG.P = REGT.P AND NOT (C.FLAG)
REG.P = REG.P OR (Rg AND C.FLAG)
Rg = K.B.l
M.FL Rg
END FUNCTION

SUB M.SBC (Rg)
'/* Warning! C_FLAG is inverted before SBC and after it */
  IF (REG.P AND D.FLAG) THEN
  
    K.B.l = (REG.A AND &HF) - (Rg AND &HF) - (NOT (REG.P) AND C.FLAG)
    IF (K.B.l AND &H10) THEN K.B.l = K.B.l - 6
    K.B.h = (REG.A \ 2 ^ 4) - (Rg \ 2 ^ 4) - ((K.B.l AND &H10) = &H10)
    IF (K.B.h AND &H10) THEN K.B.h = K.B.h - 6
                CYCLE = CYCLE + 1
  
  ELSE
  
    K.W = REG.A - Rg - (NOT (REG.P) AND C.FLAG)
  END IF

END SUB

SUB M.SMB (Rg)
END SUB

SUB mc.ab (Rg AS PCC)
M.LDWORD Rg

END SUB

SUB mc.ax (Rg AS PCC)
M.LDWORD Rg
Rg.W = Rg.W + REG.X
END SUB

SUB mc.ay (Rg AS PCC)
M.LDWORD Rg
Rg.W = Rg.W + REG.Y
END SUB

SUB MC.ID (Rg AS PCC)
K.W = MCZp()
Rg.B.l = RdRAM(K.W)
Rg.B.h = RdRAM(K.W + 1)
END SUB

SUB mc.ix (Rg AS PCC)
K.W = MCZx()
Rg.B.l = RdRAM(K.W)
Rg.B.h = RdRAM(K.W + 1)
END SUB

SUB mc.iy (Rg AS PCC)
K.W = MCZp()
Rg.B.l = RdRAM(K.W): Rg.B.h = RdRAM(K.W + 1)
Rg.W = Rg.W + REG.Y
END SUB

SUB mc.zp (Rg AS PCC)
Rg.B.l = op6502(REG.PC.W)
REG.PC.W = REG.PC.W + 1
Rg.B.h = ZP \ 2 ^ 8

END SUB

DEFSNG A-Z
SUB mc.zx (Rg AS PCC)
Rg.B.l = op6502(REG.PC.W) + REG.X
REG.PC.W = REG.PC.W + 1
Rg.B.h = ZP \ 2 ^ 8

END SUB

SUB mc.zy ()
Rg.B.l = op6502(REG.PC.W) + REG.Y
REG.PC.W = REG.PC.W + 1
Rg.B.h = ZP \ 2 ^ 8

END SUB

FUNCTION MCAB% ()
MCAB% = OP6502W(REG.PC.W)

END FUNCTION

FUNCTION MCAX% ()
MCAX% = OP6502W(REG.PC.W) + REG.X
END FUNCTION

FUNCTION MCAY% ()
MCAY% = OP6502W(REG.PC.W) + REG.Y
END FUNCTION

FUNCTION MCIX% ()
MCIX% = RDRAMW(MCZx)

END FUNCTION

FUNCTION MCIY% ()
MCIY% = RDRAMW(MCZp) + REG.Y
END FUNCTION

DEFINT A-Z
FUNCTION MCZp ()
MCZp = op6502(REG.PC.W) + ZP
REG.PC.W = REG.PC.W + 1

END FUNCTION

FUNCTION MCZx ()
MCZx = (byte) * op6502(REG.PC.W) + REG.X + ZP
REG.PC.W = REG.PC.W + 1

END FUNCTION

FUNCTION MCZY ()
MCZY = (byte) * op6502(REG.PC.W) + REG.Y + ZP
REG.PC.W = REG.PC.W + 1
END FUNCTION

SUB MM.Ab (Rg)
#define MM_Ab(Cmd)  MC_Ab(J);I=Rd6502(J.W);Cmd(I);Wr6502(J.W,I)
END SUB

SUB mm.ax (Rg)
#define MM_Ax(Cmd)  MC_Ax(J);I=Rd6502(J.W);Cmd(I);Wr6502(J.W,I)
END SUB

SUB MM.Zp (RP)
#define MM_Zp(Cmd)  J.W=MCZp();I=RdRAM(J.W);Cmd(I);WrRAM(J.W,I)
END SUB

SUB mm.zx (Rg)
#define MM_Zx(Cmd)  J.W=MCZx();I=RdRAM(J.W);Cmd(I);WrRAM(J.W,I)
END SUB

SUB MR.Ab (Rg)
#define MR_Ab(Rg)   MC_Ab(J);Rg=Rd6502(J.W)

END SUB

SUB MR.Ax (Rg)
#define MR_Ax(Rg)   MC_Ax(J);Rg=Rd6502(J.W)
END SUB

SUB MR.Ay (Rg)
#define MR_Ay(Rg)   MC_Ay(J);Rg=Rd6502(J.W)
END SUB

SUB MR.ID (Rg)
MC.ID J
Rg = DR6502(J.W)

END SUB

SUB MR.Im (Rg)
#define MR_Im(Rg)   Rg=Op6502(_PC_++)
END SUB

SUB MR.Ix (Rg)
#define MR_Ix(Rg)   MC_Ix(J);Rg=Rd6502(J.W)
END SUB

SUB MR.Iy (Rg)
#define MR_Iy(Rg)   MC_Iy(J);Rg=Rd6502(J.W)
END SUB

SUB MR.Zp (Rg)
#define MR_Zp(Rg)   Rg=RdRAM(MCZp())

END SUB

SUB MR.Zx (Rg)
#define MR_Zx(Rg)   Rg=RdRAM(MCZx())
END SUB

SUB mr.zy (Rg)
#define MR_Zy(Rg)   Rg=RdRAM(MCZy())
END SUB

SUB MW.Ab (Rg)
#define MW_Ab(Rg)   MC_Ab(J);Wr6502(J.W,Rg)
END SUB

SUB MW.Ax (Rg)
#define MW_Ax(Rg)   MC_Ax(J);Wr6502(J.W,Rg)
END SUB

SUB mw.ay (Rg)
#define MW_Ay(Rg)   MC_Ay(J);Wr6502(J.W,Rg)
END SUB

SUB mw.ix (Rg)
#define MW_Ix(Rg)   MC_Ix(J);Wr6502(J.W,Rg)
END SUB

SUB mw.iy (Rg)
#define MW_Iy(Rg)   MC_Iy(J);Wr6502(J.W,Rg)
END SUB

SUB MW.Zp (Rg)
#define MW_Zp(Rg)   WrRAM(MCZp(),Rg)
END SUB

SUB MW.Zx (Rg)
#define MW_Zx(Rg)   WrRAM(MCZx(),Rg)
END SUB

SUB mw.zy (Rg)
#define MW_Zy(Rg)   WrRAM(MCZy(),Rg)
END SUB

FUNCTION op6502 (A%)
END FUNCTION

FUNCTION rd6502 (A%)
END FUNCTION

SUB Reset6502 (r)
  REG.MPR(7) = &H0: BANK.SET 7, &H0

   REG.MPR(6) = &H5: BANK.SET 6, &H5

   REG.MPR(5) = &H4: BANK.SET 5, &H4

   REG.MPR(4) = &H3: BANK.SET 4, &H3

   REG.MPR(3) = &H2: BANK.SET 3, &H2

   REG.MPR(2) = &H1: BANK.SET 2, &H1

   REG.MPR(1) = &HF8: BANK.SET 1, &HF8

   REG.MPR(0) = &HFF: BANK.SET 0, &HFF
   R->A=R->X=R->Y=0x00;
  R->P=I_FLAG;

  R->NF=R->VF=0;

  R->ZF=0xFF;
  R->S=0xFF;

  R->PC.B.l=Op6502(VEC_RESET);
  R->PC.B.h=Op6502(VEC_RESET+1);
  R->ICount=R->IPeriod;
  R->IRequest=INT_NONE;
  R->AfterCLI=0;
  //_CycleCount=0;
  (int)(R->User)=0;

END SUB

SUB TRB (Rg)
'NF=VF=RG
REG.NF = Rg
REG.VF = Rg
Rg = Rg AND NOT (REG.A)
REG.ZF = Rg

END SUB

SUB TSB (Rg)
'NF=VF=RG
REG.NF = Rg
REG.VF = Rg
Rg = Rg OR REG.A
REG.ZF = Rg

END SUB

SUB T_INIT ()
END SUB

SUB Wr6502 (A%, B%)
END SUB

