DECLARE FUNCTION opcode$ (I%)
DECLARE SUB BANK.SET (p%, v%)
DECLARE SUB cmdc (cmd%, rg AS ANY)
DECLARE SUB cmdd (cmd1%, CMD2%)
DECLARE SUB cmdr (cmd%, rg%)
DECLARE SUB codes (I%)
DECLARE SUB endprog ()
DECLARE FUNCTION io_read% (a&)
DECLARE SUB io_write (a AS LONG, v%)
DECLARE SUB loadpce (f%)
DECLARE SUB M.CMP (rg1%, rg2%)
DECLARE SUB M.JR ()
DECLARE SUB M.LDWORD (rg AS ANY)
DECLARE FUNCTION MCZp% ()
DECLARE FUNCTION MCZx% ()
DECLARE FUNCTION MCZY% ()
DECLARE FUNCTION nop6502% (rg AS ANY)
DECLARE FUNCTION notb% (a%)
DECLARE FUNCTION op6502% (a1&)
DECLARE FUNCTION op6502i% (rg AS ANY)
DECLARE FUNCTION OP6502W& (a&)
DECLARE FUNCTION RAMG% (a&)
DECLARE SUB RAMP (a&, b%)
DECLARE FUNCTION Rd6502% (a&)
DECLARE SUB REGINC (rg AS ANY)
DECLARE SUB RESET6502 ()
DECLARE SUB RUN6502 ()
DECLARE SUB T_INIT (src&, dist&, length&)
DECLARE FUNCTION vramg% (a%)
DECLARE SUB VRAMp (a%, b%)
DECLARE FUNCTION word& (rg AS ANY)
DECLARE SUB WORDS (rg AS ANY, a1&)
DECLARE SUB Wr6502 (a&, v%)
DECLARE SUB instr.init ()
DECLARE SUB INITVMM (SIZE%)
DECLARE SUB lockvmm (a&, b&)
DECLARE SUB VMMEND ()
DECLARE SUB vmmP (adr&, D$)
DECLARE SUB vmmPb (adr&, b%)
DECLARE FUNCTION allocVMM& (SIZE&)
DECLARE FUNCTION vmmGb% (adr&)
DECLARE FUNCTION vmmGw% (adr&)

DEFINT A-Z




'TYPE bb  'change this around for lsb fists, last
'L AS INTEGER
'H AS INTEGER
'END TYPE


'TYPE PCC
' W AS INTEGER
' B AS bb
'END TYPE

TYPE PCC
 L AS INTEGER
 H AS INTEGER
END TYPE

TYPE regg
 p AS INTEGER        'one byte register
 a AS INTEGER        '
 x AS INTEGER        '
 y AS INTEGER        '
 S AS INTEGER        '
 pc AS PCC           'word
 NF AS INTEGER 'one byte flag (last set)
 VF AS INTEGER '
 ZF AS INTEGER '
 MPR(7) AS INTEGER   'memory mapping registers pagr<->mmap (byte)
 IRequest AS INTEGER
 ICount AS INTEGER
 IBackup AS INTEGER
 AfterCLI AS INTEGER
 IPeriod AS INTEGER
 USER AS INTEGER
END TYPE

TYPE ioo
 VDC(32) AS PCC              'pair
 VCE(&H200) AS PCC
 vce_reg AS PCC
 'vdc
 vdc_inc AS LONG             'word
 vdc_raster_count AS LONG
 vdc_reg AS INTEGER          'byte
 vdc_status AS INTEGER
 VDC_ratch AS INTEGER
 vce_ratch AS INTEGER
 vdc_satb AS INTEGER
 vdc_pendvsync AS INTEGER
 bg_h AS INTEGER             'integer
 bg_w AS INTEGER
 scroll_y AS INTEGER
 minline AS INTEGER
 MaxLine AS INTEGER
 'joypad
 JOY(16) AS INTEGER          'byte
 joy_select AS INTEGER
 joy_counter AS INTEGER
 'psg
  PSG(6, 8) AS INTEGER
  wave(6, 32) AS INTEGER
  wavofs(6) AS INTEGER

  '// PSG STRUCTURE
  '// 0 : dda_out
  '// 2 : freq (lo byte)  In reality it's a divisor
  '// 3 : freq (hi byte)
  '// 4 : dda_ctrl
  '//     000XXXXX
  '//     ^^  ^
  '//     ||  ch. vol
  '//     ||
  '//     |direct access (everything at byte 0)
  '//     |
  '//    enable
  '// 5 : pan (left vol = hi nibble, right vol = low nibble)
  '// 7 : noise_ctrl
  psg_ch AS INTEGER         'byte
  psg_volume AS INTEGER
  psg_lfo_freq AS INTEGER
  psg_lfo_ctrl AS INTEGER
  '/* TIMER */
  timer_reload AS INTEGER  'byte
  timer_start AS INTEGER
  timer_counter AS INTEGER
  '/* IRQ */
    irq_mask AS INTEGER    'byte
    irq_status AS INTEGER
  '/* CDROM extention */
   backup AS INTEGER          'integer
   adpcm_firstread AS INTEGER 'integwer
   adpcm AS PCC               'pair
   adpcm_rptr AS LONG         'word
   adpcm_wptr AS LONG
 END TYPE





'byte = unsigned char (1)
'word = unsigned short (2)
'offset = signed char

'UNION pair
' word w
' int b {byte l,h}
'end type
' n
' n.w
' n.b (n.b.l,n.b.h)


                       '       /* 6502 status flags:         */
CONST c.flag = &H1     '       /* 1: Carry occured           */
                       '       /* notb c.flag
CONST z.flag = &H2     '       /* 1: Result is zero          */
CONST I.flag = &H4     '       /* 1: Interrupts disabled     */
CONST D.flag = &H8     '       /* 1: Decimal mode            */
CONST b.flag = &H10    '       /* Break [0 on stk after int] */
CONST T.flag = &H20    '       /* Memory Operation Flag      */
CONST v.flag = &H40    '       /* 1: Overflow occured        */
CONST n.flag = &H80    '       /* 1: Result is negative      */

CONST nvzN.flag = NOT (z.flag OR n.flag OR v.flag) AND &HFF
CONST cn.flag = NOT c.flag AND &HFF
CONST DN.FLAG = NOT D.flag AND &HFF
CONST IN.FLAG = NOT I.flag AND &HFF
CONST Tn.flag = NOT T.flag AND &HFF



CONST byt = &HFF       '       /* byte
CONST wrd = &HFFFF&    '       /* word

CONST SH1 = &H2    'LSHIFT / RSHIFT FUNCTIONS
CONST SH2 = &H4
CONST SH3 = &H8
CONST SH4 = &H10
CONST SH5 = &H20
CONST SH6 = &H40
CONST SH7 = &H80
CONST SH8 = &H100&
CONST SH9 = &H200
CONST SHA = &H400
CONST SHB = &H800
CONST SHC = &H1000
CONST SHD = &H2000
CONST SHE = &H4000
CONST SHF = &H8000

'                      '       /* Loop6502() returns:        */
CONST INT.NONE = 0     '       /* No interrupt required      */
CONST INT.IRQ = 1      '       /* Standard IRQ interrupt     */
CONST INT.NMI = 2      '       /* Non-maskable interrupt     */
CONST INT.QUIT = 3     '       /* Exit the emulation         */

CONST INT.TIMER = 4
CONST INT.IRQ2 = 8
CONST VEC.RESET = &HFFFE&
CONST VER.NMI = &HFFFC&
CONST vec.timer = &HFFFA&
CONST VEC.IRQ = &HFFF8&
CONST VER.IRQ2 = &HFFF6&
CONST VEC.BRK = &HFFFE&
CONST zp = 0              'stack page
CONST sp = &H100          'zero page





DIM SHARED REG AS regg, k AS PCC, j AS PCC, CYCLES%(255), I, LASTSTR, II
DIM SHARED CYCLE&, page&(7), rommap&(255), Vram&, RAM&, popram&, ROM&, ioarea&, io AS ioo
DIM SHARED ta AS PCC, COUNTER&, ts!, Pal(512)
DIM SHARED JUMPSTA(255) AS PCC, JS, JSS, JUMPSTAA(255)
DIM SHARED CMDSET1(255), CMDSET2(255), cmd1(255), CMD2(255), cmr1(255), CMr2(255), CMDf1(255)
CLS
CONST FILE1 = "neutop1.pce", file2 = "bonk3.pce", FILE3 = "BOMB94.PCE", file4 = "WONDRBOY.PCE", FILE5 = "SF2.PCE"
OPEN FILE3 FOR BINARY ACCESS READ AS #1
CLS
INITVMM 2048 * 4
loadpce 1

RESTORE cycledata
FOR II = 0 TO 255: READ CYCLES%(II): NEXT II
RESTORE CMDDSETDATA
FOR II = 0 TO 255: READ CMDSET1(II), CMDSET2(II)
NEXT II
RESTORE CMDDDATA
FOR II = 0 TO 255: READ cmd1(II), CMD2(II)
NEXT II
RESTORE CMDrDATA
FOR II = 0 TO 255: READ cmr1(II), CMr2(II)
NEXT II



CLS
 RUN6502
endprog



cycledata:
'static byte Cycles[256] =
DATA     8,7,3, 4,6,4,6,7,3,2,2,0,7,5,7,6
DATA     2,7,7, 4,6,4,6,7,2,5,2,0,7,5,7,6
DATA     7,7,3, 4,4,4,6,7,3,2,2,0,5,5,7,6
DATA     2,7,7, 0,4,4,6,7,2,5,2,0,5,5,7,6
DATA     7,7,3, 4,8,4,6,7,3,2,2,0,4,5,7,6
DATA     2,7,7, 5,0,4,6,7,2,5,3,0,0,5,7,6
DATA     7,7,2, 0,4,4,6,7,3,2,2,0,7,5,7,6
DATA     2,7,7,17,4,4,6,7,2,5,3,0,7,5,7,6
DATA     4,7,2, 7,4,4,4,7,2,2,2,0,5,5,5,6
DATA     2,7,7, 8,4,4,4,7,2,5,2,0,5,5,5,6
DATA     2,7,2, 7,4,4,4,7,2,2,2,0,5,5,5,6
DATA     2,7,7, 8,4,4,4,7,2,5,2,0,5,5,5,6
DATA     2,7,2,17,4,4,6,7,2,2,2,0,5,5,7,6
DATA     2,7,7,17,0,4,6,7,2,5,3,0,0,5,7,6
DATA     2,7,0,17,4,4,6,7,2,2,2,0,5,5,7,6
DATA     2,7,7,17,2,4,6,7,2,5,3,0,0,5,7,0
 

CONST M.NUL = 0, m.inc = 1, M.DEC = 2, M.ROR = 3, M.ROL = 4, M.LSR = 5, m.asl = 6, TRB = 7, TSB = 8
CONST m.adc = 9, m.and = 10, m.andx = 11, m.bit = 12, m.eor = 13, m.eorx = 14
CONST m.fl = 15, m.ora = 16, m.orax = 17, m.pop = 18, m.push = 19, M.RMB = 20
CONST mm.zx = 21, MM.Zp = 22, mm.ax = 23, MM.Ab = 24
CONST mr.ab = 25, mr.ax = 26, mr.ay = 27, mr.id = 28, mr.im = 29, mr.ix = 30, mr.iy = 31, mr.zp = 32, mr.zx = 33, mr.zy = 34
CONST mw.ab = 35, mw.ax = 36, mw.ay = 37, mw.ix = 38, mw.iy = 39, mw.zp = 40, mw.zx = 41, mw.zy = 42
CONST m.sbc = 43
CONST M.SMB = 44
CONST m.adcx = 45
CONST mc.ab = 46, mc.ax = 47, mc.ay = 48, mc.id = 49, mc.ix = 50, mc.iy = 51, mc.zp = 52, mc.zx = 53, mc.zy = 54
CONST m.pop.p = 55, m.push.p = 56
'148KHZ with DEBUG OFF
'152KHZ with CMDDSETDATA
'195KHZ with (cmdr, cmdd) data
'289KHZ with LS, RS VALUES DEFINED AS CONST NOT 2 ^ B AT RUNTIME
'306khz compact code (nullerror lib) + runtime modual
'25MHZ MAX SPEED (LONG INC)


'SPEED HINTS:  -DEFINE ALL CALCULATIOS THAT HAVE EXPECTED RESULTS AS CONSTS
'              -ELEMINATE WORD[S]
'              -MAKE MORE DATA TABLES
'              -SIMPLIFY CODE (BEST ALTERNATIVE)




CMDDSETDATA: 'SET(F4) COMMANDS(0-FF):CMDD CMD1,CMD2  00,00 = NULL
DATA ,,30,17,,,,,,,32,17,,,,,,,29,17,,,,,,,25,17,,,,,,,31,17,28,17,,,,,33,17
DATA ,,,,,,27,17,,,,,,,26,17,,,,,,,30,11,,,,,,,32,11,,,,,,,29,11,,,,,,,25,11
DATA ,,,,,,31,11,28,11,,,,,33,11,,,,,,,27,11,,,,,,,26,11,,,,,,,30,14,,,,,,
DATA 32,14,,,,,,,29,14,,,,,,,25,14,,,,,,,31,14,28,14,,,,,33,14,,,,,,,27,14
DATA ,,,,,,26,14,,,,,,,30,45,,,,,,,32,45,,,,,,,29,45,,,,,,,25,45,,,,,,,31,45
DATA 28,45,,,,,33,45,,,,,,,27,45,,,,,,,26,45,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,,,,,,,,,,

CMDDDATA:
DATA ,,30,16,,,,,,,32,16,,,,,,,29,16,,,,,,,25,16,,,,,,,31,16,28,16,,,,,33,16
DATA ,,,,,,27,16,,,,,,,26,16,,,,,,,30,10,,,,,32,12,32,10,,,,,,,29,10,,,,,25,12
DATA 25,10,,,,,,,31,10,28,10,,,33,12,33,10,,,,,,,27,10,,,,,26,12,26,10,,,,
DATA ,,30,13,,,,,,,32,13,,,,,,,29,13,,,,,,,25,13,,,,,,,31,13,28,13,,,,,33,13
DATA ,,,,,,27,13,,,,,,,26,13,,,,,,,30,9,,,,,,,32,9,,,,,,,29,9,,,,,,,25,9,,
DATA ,,,,31,9,28,9,,,,,33,9,,,,,,,27,9,,,,,,,26,9,,,,,,,,,,,,,,,,,,,,,,,29,12
DATA ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,30,43,,,,,,,32,43,,,,,,,29,43,,,,,,
DATA 25,43,,,,,,,31,43,28,43,,,,,33,43,,,,,,,27,43,,,,,,,26,43,,,,

CMDrDATA:
DATA ,,,,,,,,22,8,,,22,6,20,1,,,,,,,,,24,8,,,24,6,,,,,,,,,,,22,7,,,21,6,20,2
DATA ,,,,,,,,24,7,,,23,6,,,,,,,,,,,,,,,22,4,20,4,,,,,,,,,,,,,24,4,,,,,,,,
DATA ,,,,,,21,4,20,8,,,,,,,,,,,,,23,4,,,,,,,,,,,,,,,22,5,20,16,,,,,,,,,,,,
DATA 24,5,,,,,,,,,,,,,,,21,5,20,32,,,,,,,,,,,,,23,5,,,,,,,,,,,40,,,,22,3,20,64
DATA ,,,,,,,,,,,,24,3,,,,,,,,,,,41,,,,21,3,20,128,,,,,,,,,,,,,23,3,,,,,,,,
DATA ,,,,,,,,44,1,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,44,2,,,,,,,,,35,,,,36,,,,,
DATA ,,,,,,,,,,,,44,4,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,44,8,,,,,,,,,,,,,,,,,,
DATA ,,,,,,,,,,22,2,44,16,,,,,,,,,,,,,24,2,,,,,,,,,,,,,,,21,2,44,32,,,,,,
DATA ,,,,,,23,2,,,,,,,,,,,,,,,22,1,44,64,,,,,,,,,,,,,24,1,,,,,,,,,,,,,,,21,1
DATA 44,128,,,,,,,,,,,,,23,1,,

CMDfDATA: 'first cmdr or cmdc executed by an funvtion 0 - ff
DATA ,,,,,,,,56,,6,,,,,,,,,,,,,,,,1,,,,,,,,,,,,,,55,,4,,,,,,,,,,,,,,,,2,,
DATA ,,,,,,,,,,,19,,5,,,,,,,,,,,,,,,,19,,,,,,,,,,,,,,18,,3,,,,,,,,,,,,,,,
DATA 18,,,,,,,38,,,40,40,40,,15,,15,,35,35,35,,,39,49,25,41,41,42,,15,37,
DATA ,,36,,,29,30,29,,32,32,32,,15,29,15,,25,25,25,,,31,28,26,33,33,34,,,27
DATA 15,,26,26,27,,29,30,,,32,32,,,15,29,15,,25,25,,,,31,28,,,33,,,,27,19

SUB BANK.SET (p, v)

IF rommap&(v) = ioarea& THEN
page&(p) = ioarea&
ELSE
page&(p) = rommap&(v) - p * 8192&


END IF
END SUB

SUB cmdc (cmd, rg AS PCC)
SELECT CASE cmd
CASE 0: PRINT "error cmdc": endprog

CASE mc.ab
   M.LDWORD rg
CASE mc.ax
   M.LDWORD rg
   WORDS rg, word(rg) + REG.x

CASE mc.ay
  M.LDWORD rg
  WORDS rg, word(rg) + REG.y

CASE mc.id
  WORDS k, MCZp()
  rg.L = RAMG(word(k))
  rg.H = RAMG(word(k) + 1)
CASE mc.ix
  WORDS k, MCZx()
  rg.L = RAMG(word(k))
  rg.H = RAMG(word(k) + 1)
CASE mc.iy
  WORDS k, MCZp()
  rg.L = RAMG(word(k)): rg.H = RAMG(word(k) + 1)
  WORDS rg, word(rg) + REG.y
CASE mc.zp
  rg.L = nop6502(REG.pc)
  rg.H = zp \ SH8
CASE mc.zx
  rg.L = nop6502(REG.pc) + REG.x
  rg.H = zp \ SH8
CASE mc.zy
  rg.L = nop6502(REG.pc) + REG.y
  rg.H = zp \ SH8
CASE ELSE
  PRINT "Invalid CmdC"; cmd: endprog
END SELECT


END SUB

SUB cmdcf (rg)
cmdr CMDf1(I), rg
END SUB

SUB cmdd (cmd1, CMD2)
cmdr cmd1, I
cmdr CMD2, I
END SUB

STATIC SUB cmdr (cmd, rg)

SELECT CASE cmd
CASE M.NUL:
PRINT "error: CmdRg Null "; HEX$(LASTSTR): endprog
CASE m.adc 'm.adc 'NOTE: NOT (K AS PCC DEPENDENT)

  IF (REG.p AND D.flag) THEN

  k.L = (REG.a AND &HF) + (rg AND &HF) + (REG.p AND c.flag)
  k.H = (REG.a \ SH4) + (rg \ SH4)
    IF (k.L > 9) THEN k.L = k.L + 6: k.H = k.H + 1
    IF (k.H > 9) THEN k.H = k.H + 6
    REG.a = ((k.L AND &HF) OR (k.H * SH4)) AND &HFF

    IF k.H > 15 THEN REG.p = REG.p OR c.flag ELSE REG.p = REG.p AND cn.flag
    
    
    'ZF = NF = A
    REG.ZF = REG.a
    REG.NF = REG.a
                CYCLE& = CYCLE& + 1

  ELSE
    a% = REG.a + rg + (REG.p AND c.flag)
    IF a% AND &HFF00 THEN REG.p = REG.p OR c.flag:  ELSE REG.p = REG.p AND cn.flag
    a% = a% AND &HFF
    REG.VF = (notb(REG.a XOR rg) AND (REG.a XOR a%)) \ SH1
    REG.ZF = a%
    REG.NF = a%
    REG.a = a%
   END IF
CASE m.adcx  'NOTE: NOT (K AS PCC DEPENDENT)
 'MX = AdrRAM(reg.X + ZP)
  MX = RAMG(REG.x + zp)
  IF (REG.p AND D.flag) THEN

    k.L = (MX AND &HF) + (rg AND &HF) + (REG.p AND c.flag)
    k.H = (MX \ SH4) + (rg \ SH4)';/*+(K.l>>4);*/ \
    IF (k.L > 9) THEN k.L = k.L + 6: k.H = k.H + 1
    IF (k.H > 9) THEN k.H = k.H + 6
    MX = ((k.L AND &HF) OR (k.H * SH4)) AND &HFF

    IF k.H > 15 THEN REG.p = REG.p OR c.flag ELSE REG.p = REG.p AND cn.flag
    'ZF = NF = A
    REG.ZF = MX
    REG.NF = MX


    CYCLE& = CYCLE& + 1

  ELSE

    a% = MX + rg + (REG.p AND c.flag)
    
    IF a% AND &HFF00 THEN REG.p = REG.p OR c.flag ELSE REG.p = REG.p AND cn.flag
    a% = a% AND &HFF
    REG.VF = (notb(MX XOR rg) AND (MX XOR a%)) \ SH1
    REG.ZF = a%
    REG.NF = a%

    MX = a%

 END IF
 'AdrRAM(reg.X + ZP) = MX
  RAMP REG.x + zp, MX

CASE m.and
  REG.a = REG.a AND rg
  cmdr m.fl, REG.a
CASE m.andx
   'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) AND RG
   RAMP REG.x + zp, RAMG(REG.x + zp) AND rg
   cmdr m.fl, RAMG(REG.x + zp)

CASE m.asl
   REG.p = REG.p AND cn.flag
   REG.p = REG.p OR rg \ SH7
   rg = (rg * SH1) AND &HFF
   cmdr m.fl, rg

CASE m.bit
  REG.NF = rg
  REG.VF = rg
  REG.ZF = rg AND REG.a
CASE m.inc
  rg = rg + 1
  cmdr m.fl, rg

CASE M.DEC
  rg = rg - 1
  cmdr m.fl, rg


CASE M.ROR
  a% = (rg \ SH1) OR (REG.p * SH7)
  REG.p = REG.p AND cn.flag
  REG.p = REG.p OR (rg AND c.flag)
  'rg = A%     'to fix possible overflow
  cmdr m.fl, a%
  rg = a%
CASE M.ROL
  a% = (rg * SH1) OR (REG.p AND c.flag)
  REG.p = REG.p AND cn.flag
  REG.p = REG.p OR (rg \ SH7)
  'rg = A% to fix possible overflow
  cmdr m.fl, a%
  rg = a%
CASE M.LSR
  REG.p = REG.p AND cn.flag
  REG.p = REG.p OR (rg AND c.flag)
  rg = rg \ SH1
  cmdr m.fl, rg

CASE TRB

  'NF=VF=RG
  REG.NF = rg
  REG.VF = rg
  rg = rg AND notb(REG.a)
  REG.ZF = rg

CASE TSB:
  'NF=VF=RG
  REG.NF = rg
  REG.VF = rg
  rg = rg OR REG.a
  REG.ZF = rg
CASE m.eor
  REG.a = REG.a XOR rg
  cmdr m.fl, REG.a
CASE m.eorx
  'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) XOR RG
  RAMP REG.x + zp, RAMG(REG.x + zp) XOR rg
  cmdr m.fl, RAMG(REG.x + zp)
CASE m.fl
  'ZF=NF=RG


  rg = rg AND &HFF  'flow control if needed 0 -> ff -> 0
  REG.ZF = rg
  REG.NF = rg
CASE m.ora
  REG.a = REG.a OR rg
  cmdr m.fl, REG.a
CASE m.orax
  'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) OR RG
  RAMP REG.x + zp, RAMG(REG.x + zp) OR rg
  cmdr m.fl, RAMG(REG.x + zp)
CASE m.pop
  REG.S = (REG.S + 1) AND &HFF      'does this fix overflow
  rg = RAMG(sp + REG.S)
CASE m.push
  RAMP sp + REG.S, rg
  REG.S = (REG.S - 1) AND &HFF      'does this fix overflow
CASE m.pop.p
cmdr m.pop, rg
REG.NF = rg
REG.VF = rg
IF rg AND z.flag THEN REG.ZF = 0 ELSE REG.ZF = 1
CASE m.push.p

IF REG.ZF THEN tmp = 0 ELSE tmp = z.flag
cmdr m.push, ((rg) AND nvzN.flag) OR (REG.NF AND n.flag) OR (REG.VF AND v.flag) OR tmp

CASE M.RMB
  'AdrRAM(MCZp()) = AdrRAM(MCZp()) AND NOT (N)
  RAMP MCZp(), RAMG(MCZp()) AND notb(rg)
CASE m.sbc 'NOTE: NOT (K AS PCC) DEPENDENT
  '/* Warning! C_FLAG is inverted before SBC and after it */
    IF (REG.p AND D.flag) THEN

      k.L = ((REG.a AND &HF) - (rg AND &HF) - (notb(REG.p) AND c.flag)) AND &HFF
      IF (k.L AND &H10) THEN k.L = k.L - 6
      k.H = ((REG.a \ SH4) - (rg \ SH4) + ((k.L AND &H10) = &H10)) AND &HFF
      IF (k.H AND &H10) THEN k.H = k.H - 6
      REG.a = (k.L AND &HF) OR (k.H * SH4) AND &HFF

      IF k.H AND &H10 THEN REG.p = REG.p AND cn.flag ELSE REG.p = REG.p OR c.flag

                  CYCLE& = CYCLE& + 1

    ELSE

      a% = REG.a - rg - (notb(REG.p) AND c.flag)
      IF a% AND &HFF00 THEN REG.p = REG.p AND cn.flag ELSE REG.p = REG.p OR c.flag
      REG.VF = ((REG.a XOR rg) AND (REG.a XOR a%)) \ SH1
      REG.ZF = a%
      REG.NF = a%
    END IF
CASE M.SMB
  'AdrRAM(MCZp()) = AdrRAM(MCZp()) OR N
  RAMP MCZp(), RAMG(MCZp()) OR rg
CASE MM.Ab
  cmdc mc.ab, j
  I = Rd6502(word(j))
  cmdr rg, I
  Wr6502 word(j), I
CASE mm.ax
  cmdc mc.ax, j
  I = Rd6502(word(j))
  cmdr rg, I
  Wr6502 word(j), I
CASE MM.Zp
  WORDS j, MCZp()
  I = RAMG(word(j))
  cmdr rg, I
  RAMP word(j), I
CASE mm.zx
  WORDS j, MCZx()
  I = RAMG(word(j))
  cmdr rg, I
  RAMP word(j), I

CASE mr.ab
 cmdc mc.ab, j
 rg = Rd6502(word(j))

CASE mr.ax
  cmdc mc.ax, j
  rg = Rd6502(word(j))
CASE mr.ay
  cmdc mc.ay, j
  rg = Rd6502(word(j))
CASE mr.id
  cmdc mc.id, j
  rg = Rd6502(word(j))
CASE mr.im
  rg = nop6502(REG.pc)
CASE mr.ix
  cmdc mc.ix, j
  rg = Rd6502(word(j))
CASE mr.iy
  cmdc mc.iy, j
  rg = Rd6502(word(j))
CASE mr.zp
  rg = RAMG(MCZp())
CASE mr.zx
  rg = RAMG(MCZx())
CASE mr.zy
  rg = RAMG(MCZY())
CASE mw.ab
  cmdc mc.ab, j
  Wr6502 word(j), rg

CASE mw.ax
  cmdc mc.ax, j
  Wr6502 word(j), rg
CASE mw.ay
  cmdc mc.ay, j
  Wr6502 word(j), rg
CASE mw.ix
  cmdc mc.ix, j
  Wr6502 word(j), rg
CASE mw.iy
  cmdc mc.iy, j
  Wr6502 word(j), rg
CASE mw.zp
  RAMP MCZp(), rg
CASE mw.zx
  RAMP MCZx(), rg
CASE mw.zy
  RAMP MCZY(), rg



CASE ELSE
PRINT "error: CmdRg not found(" + HEX$(cmd) + ")": endprog
END SELECT
IF (rg AND byt) <> rg THEN PRINT "Error:byte overflow"; rg: endprog



END SUB

SUB cmdrf (a)
cmdr CMDf1(I), a

END SUB

STATIC SUB codes (I)
COUNTER& = COUNTER& + 1
LASTSTR = I
'PRINT "PC="; HEX$(word(reg.pc) - 1); " A="; HEX$(reg.a); " X="; HEX$(reg.x); " Y="; HEX$(reg.y); " S="; HEX$(reg.S); " P="; HEX$(reg.p);
'PRINT " zf="; HEX$(reg.ZF); " vf="; HEX$(reg.VF); " nf="; HEX$(reg.NF); " ";
'PRINT CYCLE& / (TIMER - ts!);
'PRINT counter&;
'PRINT cycle&;
'PRINT opcode$(I); " "; 'HEX$(I), cycle&
'PRINT
'KK$ = INPUT$(1)

'LINE INPUT #3, f$
'PRINT f$

SELECT CASE I
CASE &HD4'/* CSH set clock highspeed */
CASE &H54'/* CSL set clock lowspeed */

CASE &H44: '/* BSR * REL */   'FIXED
           cmdr m.push, REG.pc.H
           cmdr m.push, REG.pc.L
           'I = op6502i(reg.pc)
           'I = I + (I > 127) * 256
           'WORDS reg.pc, word(reg.pc) + I + 1
           


CASE &H80: '/* BRA * REL */
          I = op6502i(REG.pc)
          I = I + (I > 127) * 256
          WORDS REG.pc, word(REG.pc) + I + 1
          
CASE &H7C: '/* JMP ($ssss,x) */
        M.LDWORD k: WORDS k, word(k) + REG.x
        REG.pc.L = op6502i(k)
        REG.pc.H = op6502(word(k) + 1)
        
CASE &HDA: cmdr m.push, REG.x  '  /* PHX */
CASE &H5A: cmdr m.push, REG.y '               /* PHY */
CASE &HFA: cmdr m.pop, REG.x: cmdr m.fl, REG.x '    /* PLX */
CASE &H7A: cmdr m.pop, REG.y: cmdr m.fl, REG.y'      /* PLY */

CASE &H62: REG.a = 0' /* CLA */
CASE &H82: REG.x = 0' /* CLX */
CASE &HC2: REG.y = 0' /* CLY */

CASE &H2:  I = REG.x: REG.x = REG.y: REG.y = I'  /* SXY */
CASE &H22: I = REG.a: REG.a = REG.x: REG.x = I'  /* SAX */
CASE &H42: I = REG.a: REG.a = REG.y: REG.y = I'  /* SAY */

CASE &H3A: cmdr M.DEC, REG.a                  ' /* DEC A */
CASE &H1A: cmdr m.inc, REG.a                  ' /* INC A */



CASE &HD2: cmdr mr.id, I: M.CMP REG.a, I       '/* CMP ($ss) INDIR */
CASE &HB2: cmdr mr.id, REG.a: cmdr m.fl, REG.a '/* LDA ($ss) INDIR */
CASE &H92: cmdc mc.id, j: Wr6502 word(j), REG.a'/* STA ($ss) INDIR */



CASE &HF4: ' /* SET */
        I = op6502i(REG.pc)
        CYCLE& = CYCLE& + CYCLES(I) + 3
        cmdd CMDSET1(I), CMDSET2(I)  'IF ERROR, TAKE BACK OFF CYCLES(I)


CASE &H3: io_write 0, nop6502(REG.pc)  '/* ST0 */
CASE &H13: io_write 2, nop6502(REG.pc) '/* ST1 */
CASE &H23: io_write 3, nop6502(REG.pc) '/* ST2 */

CASE &H43: '/* TMAi */
        I = nop6502(REG.pc)
          FOR II = 0 TO 7
              IF (I AND 2 ^ II) THEN EXIT FOR
          NEXT II
          REG.a = REG.MPR(II)
CASE &H53: '/* TAMi */

        I = nop6502(REG.pc)
         FOR II = 0 TO 7
              IF I AND 2 ^ II THEN
                        REG.MPR(II) = REG.a
                        BANK.SET II, REG.a
              'EXIT FOR
              END IF
         NEXT II

CASE &HC3: ' /* TDD */
        T_INIT src&, dist&, length&
        DO
        Wr6502 dist&, Rd6502(src&)
        dist& = dist& - 1
        src& = src& - 1
        length& = length& - 1
        LOOP WHILE length&

CASE &H73: ' /* TII */
        T_INIT src&, dist&, length&
        DO
             Wr6502 dist&, Rd6502(src&)
             dist& = dist& + 1
             src& = src& + 1
             length& = length& - 1
        LOOP WHILE length&


CASE &HE3: ' /* TIA */
        T_INIT src&, dist&, length&
        DO
                Wr6502 dist&, Rd6502(src&)
                src& = src& + 1
                ' if (!(--length)):break
                length& = length& - 1
                IF length& = 0 THEN EXIT DO
                Wr6502 dist& + 1, Rd6502(src&)
                src& = src& + 1
                lenght& = length& - 1
        LOOP WHILE length&


CASE &HF3: ' /* TAI */

        T_INIT src&, dist&, length&
         DO
                Wr6502 dist&, Rd6502(src&)
                dist& = dist& + 1
                length& = length& - 1
               IF length& = 0 THEN EXIT DO
               Wr6502 dist&, Rd6502(src& + 1)
               dist& = dist& + 1
               length& = length& - 1
         LOOP WHILE length&
        

CASE &HD3: ' /* TIN */
        T_INIT src&, dist&, length&
        DO
                Wr6502 dist&, Rd6502(src&)
                src& = src& + 1
        length& = length& - 1
        LOOP WHILE length&


CASE &H83: '/* TST #$ss,$ss IMM,ZP */
        I = nop6502(REG.pc): II = RAMG(MCZp())
        REG.NF = II
        REG.VF = II: REG.ZF = I AND II

CASE &HA3: '/* TST #$ss,$ss,x IMM,ZP,x */
        I = nop6502(REG.pc): II = RAMG(MCZx())
        REG.NF = II
        REG.VF = II: REG.ZF = I AND II
CASE &H93: '/* TST #$ss,$ssss IMM,ABS */
        I = nop6502(REG.pc): cmdr mr.ab, II
        REG.NF = II
        REG.VF = II: REG.ZF = I AND II

CASE &HB3: '/* TST #$ss,$ssss,x IMM,ABS,x */
        I = nop6502(REG.pc): cmdr mr.ax, II
        REG.NF = II
        REG.VF = II: REG.ZF = I AND II

'SBC
 
CASE &H10: IF (REG.NF AND n.flag) THEN REGINC REG.pc ELSE M.JR  '/* BPL * REL */
CASE &H30: IF (REG.NF AND n.flag) THEN M.JR ELSE REGINC REG.pc  '/* BMI * REL */
CASE &HD0: IF REG.ZF = 0 THEN REGINC REG.pc ELSE M.JR      '/* BNE * REL */
CASE &HF0: IF REG.ZF = 0 THEN M.JR ELSE REGINC REG.pc     '/* BEQ * REL */
CASE &H90: IF (REG.p AND c.flag) THEN REGINC REG.pc ELSE M.JR '/* BCC * REL */
CASE &HB0: IF (REG.p AND c.flag) THEN M.JR ELSE REGINC REG.pc '/* BCS * REL */
CASE &H50: IF (REG.VF AND v.flag) THEN REGINC REG.pc ELSE M.JR'/* BVC * REL */
CASE &H70: IF (REG.VF AND v.flag) THEN M.JR ELSE REGINC REG.pc '/* BVS * REL */


CASE &H40: '/* RTI */

  I = REG.p


  cmdr m.pop.p, REG.p

  IF ((REG.IRequest <> INT.NONE) AND (I AND I.flag) <> 0 AND NOT (REG.p AND I.flag) <> 0) THEN
     REGAfterCLI = 1
    REG.IBackup = REG.ICount
    REG.ICount = 0
    END IF
    cmdr m.pop, REG.pc.L
    cmdr m.pop, REG.pc.H



CASE &H60: '/* RTS */
  cmdr m.pop, REG.pc.L: cmdr m.pop, REG.pc.H: REGINC REG.pc
  'JS = JS - 1
  'REGINC JUMPSTA(JS)
  'PRINT HEX$(word(JUMPSTA(JS)));

CASE &H20: '/* JSR $ssss ABS */
  
  k.L = nop6502(REG.pc)
  k.H = op6502i(REG.pc)
  'JUMPSTA(JS) = REG.PC
  cmdr m.push, REG.pc.H
  cmdr m.push, REG.pc.L
  REG.pc = k
  'JS = JS + 1
  'JSS = JSS + 1
CASE &H4C: M.LDWORD k: REG.pc = k'/* JMP $ssss ABS */

CASE &H6C: '/* JMP ($ssss) ABDINDIR */
  M.LDWORD k
  REG.pc.L = nop6502(k)
  REG.pc.H = op6502i(k)


CASE &H0: '/* BRK */
  REGINC REG.pc
  cmdr m.push, REG.pc.H: cmdr m.push, REG.pc.L
  cmdr m.push.p, REG.p AND Tn.flag OR (b.flag)
  REG.p = (REG.p OR I.flag) AND DN.FLAG
  k = REG.pc
  REG.pc.L = op6502(VEC.BRK)
  REG.pc.H = op6502(VEC.BRK + 1)
  PRINT ERR, "BRK instruction " + HEX$(word(k) - 1)
  endprog



CASE &H58: '/* CLI */
  IF ((REG.IRequest <> INT.NONE) AND (REG.p AND I.flag) <> 0) THEN
  
    REG.AfterCLI = 1
    REG.IBackup = REG.ICount
    REG.ICount = 0

  END IF
  REG.p = REG.p AND IN.FLAG



CASE &H28: '/* PLP */
  cmdr m.pop.p, I

  IF ((REG.IRequest <> INT.NONE) AND ((I XOR REG.p) AND notb(I) AND I.flag) <> 0) THEN

    REG.AfterCLI = 1
    REG.IBackup = REG.ICount
    REG.ICount = 0

  END IF
  REG.p = I



CASE &H8: cmdr m.push.p, REG.p AND Tn.flag OR b.flag'     /* PHP */
CASE &H18: REG.p = REG.p AND cn.flag          '     /* CLC */
CASE &HB8: REG.VF = 0                              '     /* CLV */
CASE &HD8: REG.p = REG.p AND DN.FLAG          '     /* CLD */
CASE &H38: REG.p = REG.p OR c.flag                 '     /* SEC */
CASE &HF8: REG.p = REG.p OR D.flag                 '     /* SED */
CASE &H78: REG.p = REG.p OR I.flag                 '     /* SEI */
CASE &H48: cmdr m.push, REG.a          '             /* PHA */
CASE &H68: cmdr m.pop, REG.a: cmdr m.fl, REG.a       '     /* PLA */
CASE &H98: REG.a = REG.y: cmdr m.fl, REG.a     '     /* TYA */

'can i use cmdr m.inc, reg.y ?
CASE &HA8: REG.y = REG.a: cmdr m.fl, REG.y     '     /* TAY */
CASE &HC8: REG.y = REG.y + 1: cmdr m.fl, REG.y '     /* INY */
CASE &H88: REG.y = REG.y - 1: cmdr m.fl, REG.y '     /* DEY */
CASE &H8A: REG.a = REG.x: cmdr m.fl, REG.a     '     /* TXA */
CASE &HAA: REG.x = REG.a: cmdr m.fl, REG.x     '     /* TAX */
CASE &HE8: REG.x = REG.x + 1: cmdr m.fl, REG.x '     /* INX */
CASE &HCA: REG.x = REG.x - 1: cmdr m.fl, REG.x '     /* DEX */
CASE &HEA:  '                                  /* NOP */
CASE &H9A: REG.S = REG.x                 '     /* TXS */
CASE &HBA: REG.x = REG.S: cmdr m.fl, REG.x     '     /* TSX */



CASE &H84: cmdr mw.zp, REG.y                 '  /* STY $ss ZP */
CASE &H85: cmdr mw.zp, REG.a                 '  /* STA $ss ZP */
CASE &H86: cmdr mw.zp, REG.x                 '  /* STX $ss ZP */
CASE &HA4: cmdr mr.zp, REG.y: cmdr m.fl, REG.y    '  /* LDY $ss ZP */
CASE &HA5: cmdr mr.zp, REG.a: cmdr m.fl, REG.a    '  /* LDA $ss ZP */
CASE &HA6: cmdr mr.zp, REG.x: cmdr m.fl, REG.x     '  /* LDX $ss ZP */
CASE &HC4: cmdr mr.zp, I: M.CMP REG.y, I     '  /* CPY $ss ZP */
CASE &HC5: cmdr mr.zp, I: M.CMP REG.a, I     '  /* CMP $ss ZP */
CASE &HE4: cmdr mr.zp, I: M.CMP REG.x, I    '  /* CPX $ss ZP */
CASE &H8C: cmdr mw.ab, REG.y                 '  /* STY $ssss ABS */
CASE &H8D: cmdr mw.ab, REG.a                '  /* STA $ssss ABS */
CASE &H8E: cmdr mw.ab, REG.x                '  /* STX $ssss ABS */
CASE &HAC: cmdr mr.ab, REG.y: cmdr m.fl, REG.y     '  /* LDY $ssss ABS */
CASE &HAD: cmdr mr.ab, REG.a: cmdr m.fl, REG.a    '  /* LDA $ssss ABS */
CASE &HAE: cmdr mr.ab, REG.x: cmdr m.fl, REG.x     '  /* LDX $ssss ABS */
CASE &HCC: cmdr mr.ab, I: M.CMP REG.y, I     '  /* CPY $ssss ABS */
CASE &HCD: cmdr mr.ab, I: M.CMP REG.a, I     '  /* CMP $ssss ABS */
CASE &HEC: cmdr mr.ab, I: M.CMP REG.x, I    '  /* CPX $ssss ABS */
CASE &HA0: cmdr mr.im, REG.y: cmdr m.fl, REG.y     '  /* LDY #$ss IMM */
CASE &HA2: cmdr mr.im, REG.x: cmdr m.fl, REG.x     '  /* LDX #$ss IMM */
CASE &HA9: cmdr mr.im, REG.a: cmdr m.fl, REG.a     '  /* LDA #$ss IMM */
CASE &HC0: cmdr mr.im, I: M.CMP REG.y, I     '  /* CPY #$ss IMM */
CASE &HC9: cmdr mr.im, I: M.CMP REG.a, I     '  /* CMP #$ss IMM */
CASE &HE0: cmdr mr.im, I: M.CMP REG.x, I    '  /* CPX #$ss IMM */
CASE &H94: cmdr mw.zx, REG.y                 '  /* STY $ss,x ZP,x */
CASE &H95: cmdr mw.zx, REG.a                 '  /* STA $ss,x ZP,x */
CASE &H96: cmdr mw.zy, REG.x                 '  /* STX $ss,y ZP,y */
CASE &HB4: cmdr mr.zx, REG.y: cmdr m.fl, REG.y     '  /* LDY $ss,x ZP,x */
CASE &HB5: cmdr mr.zx, REG.a: cmdr m.fl, REG.a     '  /* LDA $ss,x ZP,x */
CASE &HB6: cmdr mr.zy, REG.x: cmdr m.fl, REG.x     '  /* LDX $ss,y ZP,y */
CASE &HD5: cmdr mr.zx, I: M.CMP REG.a, I     '  /* CMP $ss,x ZP,x */



CASE &H99: cmdr mw.ay, REG.a                 '  /* STA $ssss,y ABS,y */
CASE &H9D: cmdr mw.ax, REG.a                 '  /* STA $ssss,x ABS,x */
CASE &HB9: cmdr mr.ay, REG.a: cmdr m.fl, REG.a     '  /* LDA $ssss,y ABS,y */
CASE &HBC: cmdr mr.ax, REG.y: cmdr m.fl, REG.y     '  /* LDY $ssss,x ABS,x */
CASE &HBD: cmdr mr.ax, REG.a: cmdr m.fl, REG.a     '  /* LDA $ssss,x ABS,x */
CASE &HBE: cmdr mr.ay, REG.x: cmdr m.fl, REG.x     '  /* LDX $ssss,y ABS,y */
CASE &HD9: cmdr mr.ay, I: M.CMP REG.a, I     '  /* CMP $ssss,y ABS,y */
CASE &HDD: cmdr mr.ax, I: M.CMP REG.a, I     '  /* CMP $ssss,x ABS,x */
CASE &H81: cmdr mw.ix, REG.a                 '  /* STA ($ss,x) INDEXINDIR */
CASE &H91: cmdr mw.iy, REG.a                 '  /* STA ($ss),y INDIRINDEX */
CASE &HA1: cmdr mr.ix, REG.a: cmdr m.fl, REG.a     '  /* LDA ($ss,x) INDEXINDIR */
CASE &HB1: cmdr mr.iy, REG.a: cmdr m.fl, REG.a     '  /* LDA ($ss),y INDIRINDEX */
CASE &HC1: cmdr mr.ix, I: M.CMP REG.a, I     '  /* CMP ($ss,x) INDEXINDIR */
CASE &HD1: cmdr mr.iy, I: M.CMP REG.a, I     '  /* CMP ($ss),y INDIRINDEX */


CASE &HA:  cmdr m.asl, REG.a                 '  /* ASL a ACC */
CASE &H2A: cmdr M.ROL, REG.a                '  /* ROL a ACC */
CASE &H4A: cmdr M.LSR, REG.a                '  /* LSR a ACC */
CASE &H6A: cmdr M.ROR, REG.a                '  /* ROR a ACC */
CASE IS = ((cmd1(I) <> 0) AND I): cmdd cmd1(I), CMD2(I)
CASE IS = ((cmr1(I) <> 0) AND I): cmdr cmr1(I), CMr2(I)
CASE IS = (I OR &HF) '/* BBRi/BBSi
IF ((RAMG(MCZp()) AND 2 ^ (I \ SH4)) <> 0) AND (I < &H80) THEN REGINC REG.pc ELSE M.JR'BBRI, BBSI
CASE ELSE
  

'  IF (I AND &H87) = &H87 THEN CMDR M.SMB, 2 ^ (I \ 2 ^ 4)
 ' IF (I AND &H7) = &H7 THEN CMDR M.RMB, 2 ^ (I \ 2 ^ 4)
tt! = TIMER
PRINT CYCLE& / (tt! - ts!), COUNTER& / (tt! - ts!), tt! - ts!
PRINT CYCLE&, COUNTER&
PRINT
PRINT "ERROR:"; HEX$(word(REG.pc) - 1), HEX$(I): endprog
'default:
'  if(_TrapBadOps) {
'    fprintf
'    ( stderr,
'      "[M6502 %lX] Unrecognized instruction: $%02X at PC=$%04X\n",
'      (unsigned)_User,Op6502(REG.PC.W-1),(word)(REG.PC.W-1)
'    );
'
'    _Trace=1;
'
'  }
'
'  break;
END SELECT

'PRINT
'kk$ = INPUT$(1)
NEXTCODES:
END SUB

SUB endprog ()
VMMEND
END
END SUB

FUNCTION io_read (a&)
'PRINT "io_read "; HEX$(a&); ': END
EXIT FUNCTION
'byte IO_read(word A)
'byte ret

  SELECT CASE a& AND &H1C00
  CASE &H0:    '/* VDC */
    SELECT CASE a& AND 3
    CASE 0:
        ret = io.vdc_status
        io.vdc_status = 0';//&=VDC_InVBlank;//&=~VDC_BSY;
        io_read = ret: EXIT FUNCTION
    CASE 1:
        io_read = 0: EXIT FUNCTION
    CASE 2:
        IF (io.vdc_reg = VRR) THEN
            io_read = vramg(word(io.VDC(MARR)) * 2): EXIT FUNCTION

        ELSE
        io_read = io.VDC(io.vdc_reg).L: EXIT FUNCTION
        END IF
    CASE 3:
        IF (io.vdc_reg = VRR) THEN
            ret = vramg(word(io.VDC(MARR)) * 2 + 1)
            WORDS io.VDC(MARR), word(io.VDC(MARR)) + io.vdc_inc
            io_read = ret: EXIT FUNCTION
        ELSE
        io_read = io.VDC(io.vdc_reg).H: EXIT FUNCTION
        END IF
    END SELECT
    

  CASE &H400: '/* VCE */
    SELECT CASE a& AND 7
    CASE 4: io_read = io.VCE(word(io.vce_reg)).L: EXIT FUNCTION
    CASE 5: io_read = io.VCE(word(io.vce_reg)).H: WORDS io.vce_reg, word(io.vce_reg) + 1: EXIT FUNCTION
    END SELECT
    
'#ifndef FINAL_RELEASE
'  case 0x0800:  /* PSG */
'    switch(A&15){
'    case 0: return io.psg_ch;
'    case 1: return io.psg_volume;
'    case 2: return io.PSG[io.psg_ch][2];
'    case 3: return io.PSG[io.psg_ch][3];
'    case 4: return io.PSG[io.psg_ch][4];
'    case 5: return io.PSG[io.psg_ch][5];
'    CASE 6:
'        {
'            //int   ofs=io.wavofs[io.psg_ch];
'            //io.wavofs[io.psg_ch]=(io.wavofs[io.psg_ch]+1)&31;
'            //return io.wave[io.psg_ch][ofs];
'            int ofs=fixtoi(snd_pos[io.psg_ch]);
'            snd_pos[io.psg_ch]=itofix((fixtoi(snd_pos[io.psg_ch])+1)&31);
'            return io.wave[io.psg_ch][ofs];
'
'        }
'    case 7: return io.PSG[io.psg_ch][7];
'    case 8: return io.psg_lfo_freq;
'    case 9: return io.psg_lfo_ctrl;
'    default: return NODATA;
'    }
'    break;
'#endif
  CASE &HC00:  ' /* timer */
    io_read = io.timer_counter: EXIT FUNCTION

  CASE &H1000:  '/* joypad */

  
  ret = io.JOY(io.joy_counter) XOR &HFF
        IF io.joy_select AND 1 THEN
        ret = ret \ SH4
        ELSE
        ret = ret AND 15: io.joy_counter = (io.joy_counter + 1) MOD 5
        END IF
        io_read = ret OR Country: EXIT FUNCTION'; /* country 0:JPN 1=US */


  CASE &H1400: ' /* IRQ */
    SELECT CASE a& AND 15
    CASE 2: io_read = io.irq_mask: EXIT FUNCTION
    CASE 3: ret = io.irq_status: io.irq_status = 0: io_read = ret: EXIT FUNCTION
    END SELECT
    

  CASE &H1800: ' /* CD-ROM extention */
    SELECT CASE a& AND 15
    CASE 3: io.backup = DISABLE: io_read = DISABLE: EXIT FUNCTION'return io.backup = disable
'//  case 0xa:
'//      if (!io.adpcm_firstread) return PCM[io.adpcm_rptr++];
'//      else {io.adpcm_firstread=FALSE; return NODATA;}
    END SELECT
    
    
  END SELECT
    io_read = NODATA


END FUNCTION

SUB io_write (a AS LONG, v)
'PRINT "io_write "; HEX$(a);
EXIT SUB

'A,v
  SELECT CASE a AND &H1C00
  CASE &H0:     '/* VDC */
        SELECT CASE a AND 3
        CASE 0: io.vdc_reg = v AND 31: EXIT SUB:
        CASE 1: EXIT SUB:
        END SELECT
    CASE 2:
       
        SELECT CASE io.vdc_reg
        CASE VWR:
                 
                  
        CASE hdr:
'                        io.screen_w = (V + 1) * 8:
                        
                        

        CASE MWR:
'                        'static byte bgw[]={32,64,128,128}:
'                        'io.bg_h=(V AND &h40)?64:32:
'                        'io.bg_w=bgw[(V>>4) AND 3]:}
'
'
'
        CASE BYR:
            IF scroll = 0 THEN
                                oldScrollX = ScrollX:
                                oldScrollY = ScrollY:
                                oldScrollYDiff = ScrollYDiff:
            END IF
                        io.VDC(BYR).L = v:
                        scroll = 1:
                                ScrollYDiff = scanline - 1:
                        EXIT SUB:
        CASE BXR:
            IF scroll = 0 THEN
                                oldScrollX = ScrollX:
                                oldScrollY = ScrollY:
                                oldScrollYDiff = ScrollYDiff:
            END IF
                        io.VDC(BXR).L = v:
                        scroll = 1:
                        EXIT SUB:


        END SELECT
                io.VDC(io.vdc_reg).L = v:
                EXIT SUB:
    CASE 3:

        SELECT CASE io.vdc_reg
        CASE VWR:
                 
                        VRAMp word(io.VDC(MAWR)) * 2, io.VDC_ratch:
                        VRAMp word(io.VDC(MAWR)) * 2 + 1, v
                        'vchanges(io.VDC(MAWR).W / 64) = 1:
                        'io.VDC[MAWR].W+=io.vdc_inc:
                        io.VDC_ratch = 0:
                        EXIT SUB:
        CASE VDW:
                        
                        io.VDC(VDW).H = v:
                        'io.screen_h = (io.VDC(VDW).W AND 511) + 1:
                        'MaxLine = io.screen_h - 1:
                        
                        EXIT SUB:
        CASE LENR:
                        
                        io.VDC(LENR).H = v:
                        
            '/* VRAM to VRAM DMA */
            'memcpy(VRAM+io.VDC[DISTR].W*2,VRAM+io.VDC[SOUR].W*2,
            '                    (io.VDC[LENR].W+1)*2):
            '            memset(vchange+io.VDC[DISTR].W/16,1,(io.VDC[LENR].W+1)/16):
            '            memset(vchange+io.VDC[DISTR].W/64,1,(io.VDC[LENR].W+1)/64):
'                        io.VDC[DISTR].W += io.VDC[LENR].W+1:
'                        io.VDC[SOUR].W += io.VDC[LENR].W+1:
'                        io.vdc_status|=VDC_DMAfinish:
'                        EXIT SUB:
        CASE CR:
'                        static byte incsize[]={1,32,64,128}:
'                        io.vdc_inc = incsize[(V>>3) AND 3]:
                        
            

        CASE hdr:
            
            
                        
        CASE BYR:
'            IF (scroll = 0) THEN
'                                oldScrollX = ScrollX:
'                                oldScrollY = ScrollY:
'                                oldScrollYDiff = ScrollYDiff:
'            END IF
'                        io.VDC(BYR).B.h = V AND 1:
'                        scroll = 1:
'                                ScrollYDiff = scanline - 1:
'
                        EXIT SUB:
        CASE SATB:
'                        io.VDC(SATB).B.h = V:
'
'
'                        io.vdc_satb = 1:
'                        io.vdc_status AND =~VDC_SATBfinish:
'                        EXIT SUB:
        CASE BXR:
'            IF (scroll = 0) THEN
'                                oldScrollX = ScrollX:
'                                oldScrollY = ScrollY:
'                                oldScrollYDiff = ScrollYDiff:
'            END IF
 '                       io.VDC(BXR).B.h = V AND 3:
'                        scroll = 1:
'                        EXIT SUB:


  '      END SELECT
                
'                io.VDC(io.vdc_reg).B.h = V:
'                EXIT SUB:
    END SELECT


  CASE &H400:   '/* VCE */
        SELECT CASE (a AND 7)
        CASE 0:
                
        CASE 2: io.vce_reg.L = v: EXIT SUB:
        CASE 3: io.vce_reg.H = v AND 1: EXIT SUB:
        CASE 4: io.VCE(word(io.vce_reg)).L = v:
'
'                 byte c: int i,n:
                 n = word(io.vce_reg)
                 c = word(io.VCE(n)) \ SH1
         IF n = 0 THEN
                FOR II = O TO 255 STEP 16: Pal(II) = c: NEXT II
'                        for(i=0:i<256:i+=16) Pal[i]=c:
         ELSE IF (n AND 15) THEN Pal(n) = c:
        END IF


                EXIT SUB:
    CASE 5:
                io.VCE(word(io.vce_reg)).H = v:
        
'                 byte c: int i,n:
                 n = word(io.vce_reg)
                 c = word(io.VCE(n)) \ SH1
        IF n = 0 THEN
        FOR II = 0 TO 255 STEP 16: Pal(II) = c: NEXT II
'                        'for(i=0:i<256:i+=16) Pal[i]=c:
             ELSE IF (n AND 15) THEN Pal(n) = c:
        END IF
                WORDS io.vce_reg, (word(io.vce_reg) + 1) AND &H1FF:
                EXIT SUB

        CASE 1:
        CASE 6:
        CASE 7:
    END SELECT
 


  CASE &HC00:   '/* timer */
        
        SELECT CASE a AND 1
        CASE 0: io.timer_reload = v AND 127: EXIT SUB:
    CASE 1:
'                V AND =1:
'                if (V  AND  AND  !io.timer_start)
'                        io.timer_counter = io.timer_reload:
'                io.timer_start = V:
'                EXIT SUB:
    END SELECT
        

  CASE &H1000: ' /* joypad */

'                io.joy_select = V AND 1:
'                if (V AND 2) io.joy_counter = 0:
'                EXIT SUB:

  CASE &H1400:  '/* IRQ */
        SELECT CASE a AND 15
        'CASE 2: io.irq_mask = V:
        'case 3: io.irq_status= (io.irq_status AND ~TIRQ)|(V AND &hF8): exit sub:
    END SELECT
        

  CASE &H1800: ' /* CD-ROM extention */
        SELECT CASE a AND 15
'        CASE 7: io.backup = ENABLE: EXIT SUB:
'
'        CASE 9: io.adpcm_ptr.B.h = V: EXIT SUB:
        'case &ha: PCM[io.adpcm_wptr++] = V: exit sub:
        CASE &HD:
'                if (V AND 4) io.adpcm_wptr = io.adpcm_ptr.W:
'                else { io.adpcm_rptr = io.adpcm_ptr.W: io.adpcm_firstread = TRUE: }
                EXIT SUB:
'*/
   END SELECT
        
  END SELECT


END SUB

SUB loadpce (f%)

    fs& = LOF(f%)
    hdr& = fs& AND &H1FFF
    fsize& = fs& AND NOT (&H1FFF)

    ROM& = allocVMM&(fs&)


    'popram& = allocvmm&(&H10000) 'byte
    RAM& = allocVMM&(32768)      'byte
    Vram& = allocVMM&(&H10000)   'byte
    ioarea& = allocVMM&(&H2000)  'byte


    DO UNTIL adr& > fs&     'load rom
    D$ = INPUT$(32767, f%)
    vmmP ROM& + adr&, D$
    D$ = ""
    adr& = adr& + 32767
    LOOP

    lockvmm ROM&, RAM& - 1
    ROM& = ROM& + hdr&


    ROM.SIZE = fsize& \ &H2000
    rommask = 1
    

WHILE (rommask < ROM.SIZE)
    rommask = rommask * SH1
    WEND
    rommask = rommask - 1
    

    FOR I = 0 TO &HF7

    
        IF (ROM.SIZE = &H30) THEN
        
            SELECT CASE (I AND &H70)
            
            
            
            CASE &H50, &H10, &H0:
                

            
            rommap&(I) = ROM& + (I AND rommask) * 8192&
            
            CASE &H60, &H20:
                
                 

                 rommap&(I) = ROM& + ((I - &H20) AND rommask) * 8192&
            
            CASE &H70, &H30:

                rommap&(I) = ROM& + ((I - &H10) AND rommask) * 8192&
                
            CASE &H40:
                'rommap&(I) = rom& + ((I - &H20) AND rommask) * 8192&

            
            rommap&(I) = ROM& + ((I - &H20) AND rommask) * 8192&
            END SELECT
        
        ELSE


     rommap&(I) = ROM& + (I AND rommask) * 8192&'* &H2000
    'rommap&(i) = rom& + (i AND rommask) * &H2000
       END IF
    NEXT I


    rommap&(&HF8) = RAM&
    rommap&(&HF9) = RAM& + &H2000
    rommap&(&HFA) = RAM& + &H4000
    rommap&(&HFB) = RAM& + &H6000
    rommap&(&HFF) = ioarea&' //NULL; /* NULL = I/O area */









END SUB

STATIC SUB M.CMP (rg1, rg2)
  'WORDS k, rg1 - rg2
  a% = rg1 - rg2
  'k.h
  IF a% AND &HFF00 THEN REG.p = REG.p AND cn.flag ELSE REG.p = REG.p OR c.flag
  a% = a% AND &HFF  'low byte
  REG.ZF = a%
  REG.NF = a%
  'reg.ZF = k.L
  'reg.NF = k.L
END SUB

SUB M.JR ()
'op6502i is offset
I = op6502i(REG.pc)
I = I + (I > 127) * 256
WORDS REG.pc, word(REG.pc) + I + 1
CYCLE& = CYCLE& + 2
END SUB

SUB M.LDWORD (rg AS PCC)
a& = word(REG.pc)
rg.L = op6502(a&)
rg.H = op6502(a& + 1)
WORDS REG.pc, a& + 2
END SUB

FUNCTION MCZp ()
MCZp = nop6502(REG.pc) + zp
END FUNCTION

FUNCTION MCZx ()
MCZx = nop6502(REG.pc) + REG.x + zp
END FUNCTION

FUNCTION MCZY ()
MCZY = nop6502(REG.pc) + REG.y + zp
END FUNCTION

FUNCTION nop6502 (rg AS PCC)
a1& = word(rg)
a& = a1&
p = a& \ SHD
a& = page&(p) + a&
a& = vmmGb(a&)
'PRINT HEX$(a&); " ";
nop6502 = a&
a& = a1&
a& = a& + 1
WORDS rg, a&
END FUNCTION

FUNCTION notb (a%)
notb = NOT (a%) AND &HFF
END FUNCTION

FUNCTION op6502 (a1&)
'a& = a1&
'IF a& < 0 THEN a& = 65536 + a&
'PRINT HEX$(a&); " ";
op6502 = vmmGb(page&(a1& \ SHD) + a1&)
END FUNCTION

FUNCTION op6502i (rg AS PCC)
op6502i = op6502(word(rg))
END FUNCTION

FUNCTION OP6502W& (a1&)
'retrieve unsigned integer
'error h,l order?
'a1% = op6502(A&)'l
'a2% = op6502(A& + 1)'h
'OP6502W& = a1% + a2% * 2 ^ 8

a& = vmmGw(page&(a1& \ SHD) + a1&)
IF a& < 0 THEN a& = a& + 65536
OP6502W& = a&


END FUNCTION

FUNCTION RAMG% (a&)
RAMG% = vmmGb(RAM& + a&)
END FUNCTION

SUB RAMP (a&, b%)
'PRINT "RAMP("; HEX$(A&); ")";
vmmPb RAM& + a&, b%
END SUB

FUNCTION Rd6502 (a&)
'PRINT "Rd6502("; HEX$(a&); ")";
'IF a& < 0 THEN a& = 65536 + a&
p = a& \ SHD
IF page&(p) <> ioarea& THEN
adr& = page&(p) + a&
Rd6502 = vmmGb(adr&)
ELSE
Rd6502 = io_read(a&)
END IF
END FUNCTION

SUB REGINC (rg AS PCC)
a& = word(rg) + 1
WORDS rg, a&

END SUB

SUB RESET6502 ()
  REG.MPR(7) = &H0: BANK.SET 7, &H0

   REG.MPR(6) = &H5: BANK.SET 6, &H5

   REG.MPR(5) = &H4: BANK.SET 5, &H4

   REG.MPR(4) = &H3: BANK.SET 4, &H3

   REG.MPR(3) = &H2: BANK.SET 3, &H2

   REG.MPR(2) = &H1: BANK.SET 2, &H1

   REG.MPR(1) = &HF8: BANK.SET 1, &HF8   'ram

   REG.MPR(0) = &HFF: BANK.SET 0, &HFF   'io area
  REG.a = 0: REG.x = 0: REG.y = 0
  REG.p = I.flag

  REG.NF = 0: REG.VF = 0

  REG.ZF = &HFF
  REG.S = &HFF

  REG.pc.L = op6502(VEC.RESET)
  REG.pc.H = op6502(VEC.RESET + 1)
  ta.L = op6502(vec.timer)
  ta.H = op6502(vec.timer + 1)


REG.ICount = REG.IPeriod
  REG.IRequest = INT.NONE
  REG.AfterCLI = 0
  '//_CycleCount=0;
  '(int)(R->User)=0;
  REG.USER = 0
END SUB

SUB RUN6502 ()
instr.init
DIM a AS regg
RESET6502

a = REG
a.pc = ta


ts! = TIMER - .01
DO

I = nop6502(REG.pc)
CYCLE& = CYCLE& + CYCLES(I)
codes I


'SWAP a, reg: SWAP c&, cycle&  'needed to execute timer irq




LOOP
END SUB

SUB T_INIT (src&, dist&, length&)
a& = word(REG.pc)
src& = OP6502W&(a&): a& = a& + 2
dist& = OP6502W&(a&): a& = a& + 2
length& = OP6502W&(a&): a& = a& + 2
WORDS REG.pc, a&
'cycle = length& * 6
CYCLE& = CYCLE& + length& * 6
END SUB

FUNCTION vramg (a%)
vramg = vmmGb(Vram& + a%)

END FUNCTION

SUB VRAMp (a%, b%)
vmmPb Vram& + a%, b%
END SUB

FUNCTION word& (rg AS PCC)
'A% = CVI(CHR$(RG.L) + CHR$(RG.H))
'WORD& = CVL(MKI$(A%) + MKI$(0))

word& = rg.L + rg.H * SH8

'word& = CVL(CHR$(RG.l) + CHR$(RG.h) + MKI$(0))



END FUNCTION

SUB WORDS (rg AS PCC, a1&)
a& = a1&
IF a& < 0 THEN a& = 65536 + a&
a& = a& AND &HFFFF
rg.L = a& AND &HFF
rg.H = a& \ SH8
END SUB

SUB Wr6502 (a&, v)
'PRINT "Wr6502("; HEX$(A&); ")";
p = a& \ SHD
IF page&(p) <> ioarea& THEN
vmmPb page&(p) + a&, v
ELSE
io_write a&, v
END IF
END SUB

